/* f/plt_3D.f -- translated by f2c (version 20100827).
   You must link the resulting object file with libf2c:
	on Microsoft Windows system, link with libf2c.lib;
	on Linux or Unix systems, link with .../path/to/libf2c.a -lm
	or, if you install libf2c.a in a standard place, with -lf2c -lm
	-- in that order, at the end of the command line, as in
		cc *.o -lf2c -lm
	Source for libf2c is in /netlib/f2c/libf2c.zip, e.g.,

		http://www.netlib.org/f2c/libf2c.zip
*/

#include "f2c.h"

/* Table of constant values */

static int c__9 = 9;
static int c__1 = 1;
static int c__3 = 3;

/* *********************************************************************** */
/*    Module:  plt_3D.f */

/*    Copyright (C) 1996 Harold Youngren, Mark Drela */

/*    This library is free software; you can redistribute it and/or */
/*    modify it under the terms of the GNU Library General Public */
/*    License as published by the Free Software Foundation; either */
/*    version 2 of the License, or (at your option) any later version. */

/*    This library is distributed in the hope that it will be useful, */
/*    but WITHOUT ANY WARRANTY; without even the implied warranty of */
/*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU */
/*    Library General Public License for more details. */

/*    You should have received a copy of the GNU Library General Public */
/*    License along with this library; if not, write to the Free */
/*    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

/*    Report problems to:    guppy@maine.com */
/*                        or drela@mit.edu */
/* *********************************************************************** */

/* *********************************************************************** */
/* --- Xplot11 3D routines */

/*     Version 4.46 11/28/01 */

/*     Note:  These are routine(s) that provide some means of displaying */
/*            3D objects in conjunction with the usual XPlot11 routines. */
/*            They are by no means complete but can serve as a starting */
/*            point for doing simple 3D graphics. */

/* *********************************************************************** */
/* Subroutine */ int view_(real *x, real *y, real *z__, int *n, real *xp, 
	real *yp, real *xob, real *yob, real *zob, real *robinv, real *xup, 
	real *yup, real *zup)
{
    /* System generated locals */
    int i__1;
    real r__1, r__2, r__3;

    /* Builtin functions */
    double sqrt(doublereal);

    /* Local variables */
    static int i__;
    static real drx, dry, drz, xip, yip, zip, xobn, yobn, zobn, vscal, xihat, 
	    yihat, zihat, xjhat, yjhat, zjhat, rdotr;

/* ........................................................................ */

/*        Projects one or more points in 3-D Cartesian space */
/*     onto a 2-D plane from the viewpoint of an observer */
/*     at a specified location.  This can be used to view */
/*     a 3-D object (described by a set of x,y,z points) */
/*     by projecting the points into a set of x,y points for */
/*     plotting on a planar 2-D graphics screen. */
/*        The viewing  plane, which has its own x,y coordinate */
/*     system, always faces the observer but can be turned */
/*     around the viewing axis, thus simulating the observer */
/*     tilting his head while looking at the object.  This tilt */
/*     is specified by giving a vector in x,y,z space which */
/*     "points up" relative to the observer. */
/*        The distance of the observer from the object is specified */
/*     explicitly.  This does not affect much the size of the viewed */
/*     object, since the viewing plane contains the 3-D space origin */
/*     and hence is at or near the object.  It does however affect the */
/*     apparent distortion of the object due to perspective.  This */
/*     is very useful to convey the 3-dimensionality of the object. */
/*     If the observer is very very far away, there is no distortion */
/*     (as in a mechanical drawing). */

/*     X,Y,Z        Cartesian point coordinates                   (input) */
/*     N            number of points                              (input) */
/*     XP,YP        projected point coordinates on viewing plane  (output) */
/*     XOB,YOB,ZOB  Cartesian vector pointing towards observer    (input) */
/*                  (magnitude irrelevant) */
/*     ROBINV       1/(distance to observer)                      (input) */
/*     XUP,YUP,ZUP  Cartesian vector which points "up" from the */
/*                  observer's viewpoint (magnitude irrelevant)   (input) */

/*                                        Mark Drela     July 1988 */
/* ........................................................................ */

/* ---- unit view vector perpendicular to viewing plane (towards observer) */
    /* Parameter adjustments */
    --yp;
    --xp;
    --z__;
    --y;
    --x;

    /* Function Body */
/* Computing 2nd power */
    r__1 = *xob;
/* Computing 2nd power */
    r__2 = *yob;
/* Computing 2nd power */
    r__3 = *zob;
    xobn = *xob / sqrt(r__1 * r__1 + r__2 * r__2 + r__3 * r__3);
/* Computing 2nd power */
    r__1 = *xob;
/* Computing 2nd power */
    r__2 = *yob;
/* Computing 2nd power */
    r__3 = *zob;
    yobn = *yob / sqrt(r__1 * r__1 + r__2 * r__2 + r__3 * r__3);
/* Computing 2nd power */
    r__1 = *xob;
/* Computing 2nd power */
    r__2 = *yob;
/* Computing 2nd power */
    r__3 = *zob;
    zobn = *zob / sqrt(r__1 * r__1 + r__2 * r__2 + r__3 * r__3);

/* ---- vector along plane's local x coordinate: (up vector)X(view vector) */
    xip = *yup * zobn - *zup * yobn;
    yip = *zup * xobn - *xup * zobn;
    zip = *xup * yobn - *yup * xobn;

/* ---- normalize plane's x coordinate vector */
/* Computing 2nd power */
    r__1 = xip;
/* Computing 2nd power */
    r__2 = yip;
/* Computing 2nd power */
    r__3 = zip;
    xihat = xip / sqrt(r__1 * r__1 + r__2 * r__2 + r__3 * r__3);
/* Computing 2nd power */
    r__1 = xip;
/* Computing 2nd power */
    r__2 = yip;
/* Computing 2nd power */
    r__3 = zip;
    yihat = yip / sqrt(r__1 * r__1 + r__2 * r__2 + r__3 * r__3);
/* Computing 2nd power */
    r__1 = xip;
/* Computing 2nd power */
    r__2 = yip;
/* Computing 2nd power */
    r__3 = zip;
    zihat = zip / sqrt(r__1 * r__1 + r__2 * r__2 + r__3 * r__3);

/* ---- unit vector along plane's y coordinate: (view vector)X(x unit vector) */
    xjhat = yobn * zihat - zobn * yihat;
    yjhat = zobn * xihat - xobn * zihat;
    zjhat = xobn * yihat - yobn * xihat;

/* ---- go over all points */
    i__1 = *n;
    for (i__ = 1; i__ <= i__1; ++i__) {

	rdotr = x[i__] * xobn + y[i__] * yobn + z__[i__] * zobn;

/* ------ viewing-axis component of vector */
	drx = rdotr * xobn;
	dry = rdotr * yobn;
	drz = rdotr * zobn;

/* ------ projected vector scaling factor due to perspective */
/* Computing 2nd power */
	r__1 = xobn - *robinv * drx;
/* Computing 2nd power */
	r__2 = yobn - *robinv * dry;
/* Computing 2nd power */
	r__3 = zobn - *robinv * drz;
	vscal = 1.f / sqrt(r__1 * r__1 + r__2 * r__2 + r__3 * r__3);

/* ------ dot vector into plane coordinate system unit vectors, and scale */
	xp[i__] = (xihat * x[i__] + yihat * y[i__] + zihat * z__[i__]) * 
		vscal;
	yp[i__] = (xjhat * x[i__] + yjhat * y[i__] + zjhat * z__[i__]) * 
		vscal;

/* L10: */
    }

    return 0;
} /* view_ */

/* Subroutine */ int viewr_(real *r__, int *n, real *rp, real *rob, real *
	robinv, real *rup)
{
    /* System generated locals */
    int i__1;
    real r__1, r__2, r__3;

    /* Builtin functions */
    double sqrt(doublereal);

    /* Local variables */
    static int i__;
    static real dr[3], sob, rin[3], rjn[3], rip[3], rkn[3], sip, vscal, rdotr;

/* ........................................................................ */

/*     Same as VIEW, but vectors are passed in R(1:3,...) array form. */
/*     The out-of-plane RP(3...) value is also returned. */

/*     R(..)    Cartesian point coordinates                   (input) */
/*     N        number of points                              (input) */
/*     RP(..)   projected point coordinates on viewing plane  (output) */
/*     ROB(.)   Cartesian vector pointing towards observer    (input) */
/*                  (magnitude irrelevant) */
/*     ROBINV   1/(distance to observer)                      (input) */
/*     RUP(.)   Cartesian vector which points "up" from the */
/*              observer's viewpoint (magnitude irrelevant)   (input) */

/*                                        Mark Drela     July 2007 */
/* ........................................................................ */

/* ---- unit view vector perpendicular to viewing plane (towards observer) */
    /* Parameter adjustments */
    rp -= 4;
    r__ -= 4;
    --rob;
    --rup;

    /* Function Body */
/* Computing 2nd power */
    r__1 = rob[1];
/* Computing 2nd power */
    r__2 = rob[2];
/* Computing 2nd power */
    r__3 = rob[3];
    sob = sqrt(r__1 * r__1 + r__2 * r__2 + r__3 * r__3);
    rkn[0] = rob[1] / sob;
    rkn[1] = rob[2] / sob;
    rkn[2] = rob[3] / sob;

/* ---- vector along plane's local x coordinate: (up vector)X(view vector) */
    rip[0] = rup[2] * rkn[2] - rup[3] * rkn[1];
    rip[1] = rup[3] * rkn[0] - rup[1] * rkn[2];
    rip[2] = rup[1] * rkn[1] - rup[2] * rkn[0];

/* ---- normalize plane's x coordinate vector */
/* Computing 2nd power */
    r__1 = rip[0];
/* Computing 2nd power */
    r__2 = rip[1];
/* Computing 2nd power */
    r__3 = rip[2];
    sip = sqrt(r__1 * r__1 + r__2 * r__2 + r__3 * r__3);
    rin[0] = rip[0] / sip;
    rin[1] = rip[1] / sip;
    rin[2] = rip[2] / sip;

/* ---- unit vector along plane's y coordinate: (view vector)X(x unit vector) */
    rjn[0] = rkn[1] * rin[2] - rkn[2] * rin[1];
    rjn[1] = rkn[2] * rin[0] - rkn[0] * rin[2];
    rjn[2] = rkn[0] * rin[1] - rkn[1] * rin[0];

/* ---- go over all points */
    i__1 = *n;
    for (i__ = 1; i__ <= i__1; ++i__) {
	rdotr = r__[i__ * 3 + 1] * rkn[0] + r__[i__ * 3 + 2] * rkn[1] + r__[
		i__ * 3 + 3] * rkn[2];

/* ------ viewing-axis component of vector */
	dr[0] = rdotr * rkn[0];
	dr[1] = rdotr * rkn[1];
	dr[2] = rdotr * rkn[2];

/* ------ projected vector scaling factor due to perspective */
/* Computing 2nd power */
	r__1 = rkn[0] - *robinv * dr[0];
/* Computing 2nd power */
	r__2 = rkn[1] - *robinv * dr[1];
/* Computing 2nd power */
	r__3 = rkn[2] - *robinv * dr[2];
	vscal = 1.f / sqrt(r__1 * r__1 + r__2 * r__2 + r__3 * r__3);

/* ------ dot vector into plane coordinate system unit vectors, and scale */
	rp[i__ * 3 + 1] = (rin[0] * r__[i__ * 3 + 1] + rin[1] * r__[i__ * 3 + 
		2] + rin[2] * r__[i__ * 3 + 3]) * vscal;
	rp[i__ * 3 + 2] = (rjn[0] * r__[i__ * 3 + 1] + rjn[1] * r__[i__ * 3 + 
		2] + rjn[2] * r__[i__ * 3 + 3]) * vscal;
	rp[i__ * 3 + 3] = (rkn[0] * r__[i__ * 3 + 1] + rkn[1] * r__[i__ * 3 + 
		2] + rkn[2] * r__[i__ * 3 + 3]) * vscal;
/* L10: */
    }

    return 0;
} /* viewr_ */

/* Subroutine */ int projmatrix3_(real *rotz, real *roty, real *rmat)
{
    /* Builtin functions */
    double atan(doublereal), cos(doublereal), sin(doublereal);

    /* Local variables */
    static real dtr, cosy, cosz, siny, sinz;

/* ...Purpose:  To define rotation and transformation matrix. The input */
/*             pair of angles ROTZ,ROTY specify the viewpoint by */
/*             an angle about the Z axis (CCW) and an angle about */
/*             the newly rotated Y axis (CCW).  Both angles are */
/*             right-handed in a conventional sense about each axis. */

/* ...Input:    ROTZ  rotation of viewpoint about     Z axis (deg) */
/*             ROTY  rotation of viewpoint about new Y axis (deg) */

/* ...Output:   RMAT  3x3 rotation and perspective matrix */


    /* Parameter adjustments */
    rmat -= 4;

    /* Function Body */
    dtr = atan(1.f) * 4.f / 180.f;
    cosz = cos(*rotz * dtr);
    sinz = sin(*rotz * dtr);
    cosy = cos(*roty * dtr);
    siny = sin(*roty * dtr);

/* ---Rotation matrix (rotation about Z, then rotation about Y) */
/*     xx = -(     SINZ*X +      COSZ*Y) */
    rmat[4] = -sinz;
    rmat[5] = -cosz;
    rmat[6] = 0.f;
/*     yy =   SINY*COSZ*X - SINY*SINZ*Y + COSY*Z */
    rmat[7] = siny * cosz;
    rmat[8] = -siny * sinz;
    rmat[9] = cosy;
/*     zz = -(COSY*COSZ*X - COSY*SINZ*Y - SINY*Z) */
    rmat[10] = -cosy * cosz;
    rmat[11] = cosy * sinz;
    rmat[12] = siny;

/*      xx = -(     SINZ*X +      COSZ*Y) */
/*      yy =   SINY*COSZ*X - SINY*SINZ*Y + COSY*Z */
/*      zz = -(COSY*COSZ*X - COSY*SINZ*Y - SINY*Z) */

/*      write(*,*) 'Rmatrix row1 ', (RMAT(1,L),L=1,3) */
/*      write(*,*) 'Rmatrix row2 ', (RMAT(2,L),L=1,3) */
/*      write(*,*) 'Rmatrix row3 ', (RMAT(3,L),L=1,3) */
/*      read(*,*) */

    return 0;
} /* projmatrix3_ */

/* Subroutine */ int projmatrix4_(real *rotz, real *roty, real *rdist, real *
	rmat)
{
    /* Builtin functions */
    double atan(doublereal), cos(doublereal), sin(doublereal);

    /* Local variables */
    static int j, k, l;
    static real dtr, tmp, amat[16]	/* was [4][4] */, pmat[16]	/* 
	    was [4][4] */, cosy, cosz, siny, sinz;

/* ...Purpose:  To define rotation and perspective matrix. The input */
/*             pair of angles ROTZ,ROTY specify the viewpoint by */
/*             an angle about the Z axis (CCW) and an angle about */
/*             the newly rotated Y axis (CCW).  Both angles are */
/*             right-handed in a conventional sense about each axis. */
/*             The observer distance RDIST specifies the distance from */
/*             the origin to the observer along the viewpoint direction. */

/* ...Input:    ROTZ  rotation of viewpoint about     Z axis (deg) */
/*             ROTY  rotation of viewpoint about new Y axis (deg) */
/*             RDIST distance from origin to observer along viewpoint */

/* ...Output:   RMAT  4x4 rotation and perspective matrix */


    /* Parameter adjustments */
    rmat -= 5;

    /* Function Body */
    dtr = atan(1.f) * 4.f / 180.f;
    cosz = cos(*rotz * dtr);
    sinz = sin(*rotz * dtr);
    cosy = cos(*roty * dtr);
    siny = sin(*roty * dtr);

/* ---Rotation matrix (rotation about Z, then rotation about Y) */
/*     xx = -(     SINZ*X +      COSZ*Y) */
    amat[0] = -sinz;
    amat[1] = -cosz;
    amat[2] = 0.f;
    amat[3] = 0.f;
/*     yy =   SINY*COSZ*X - SINY*SINZ*Y + COSY*Z */
    amat[4] = siny * cosz;
    amat[5] = -siny * sinz;
    amat[6] = cosy;
    amat[7] = 0.f;
/*     zz = -(COSY*COSZ*X - COSY*SINZ*Y - SINY*Z) */
    amat[8] = -cosy * cosz;
    amat[9] = cosy * sinz;
    amat[10] = siny;
    amat[11] = 0.f;

    amat[12] = 0.f;
    amat[13] = 0.f;
    amat[14] = 0.f;
    amat[15] = 1.f;

/*      xx = -(     SINZ*X +      COSZ*Y) */
/*      yy =   SINY*COSZ*X - SINY*SINZ*Y + COSY*Z */
/*      zz = -(COSY*COSZ*X - COSY*SINZ*Y - SINY*Z) */

/* ---Perspective matrix with projection on Z plane */
    pmat[0] = 1.f;
    pmat[1] = 0.f;
    pmat[2] = 0.f;
    pmat[3] = 0.f;

    pmat[4] = 0.f;
    pmat[5] = 1.f;
    pmat[6] = 0.f;
    pmat[7] = 0.f;

    pmat[8] = 0.f;
    pmat[9] = 0.f;
    pmat[10] = 1.f;
    pmat[11] = 0.f;

    pmat[12] = 0.f;
    pmat[13] = 0.f;
    pmat[14] = -(*rdist);
    pmat[15] = 1.f;

/* ---Product of matrices is perspective matrix */
    for (j = 1; j <= 4; ++j) {
	for (k = 1; k <= 4; ++k) {
	    tmp = 0.f;
	    for (l = 1; l <= 4; ++l) {
		tmp += amat[j + (l << 2) - 5] * pmat[l + (k << 2) - 5];
	    }
	    rmat[j + (k << 2)] = tmp;
	}
    }

/*      write(*,*) 'Rmatrix row1 ', (RMAT(1,L),L=1,4) */
/*      write(*,*) 'Rmatrix row2 ', (RMAT(2,L),L=1,4) */
/*      write(*,*) 'Rmatrix row3 ', (RMAT(3,L),L=1,4) */
/*      write(*,*) 'Rmatrix row4 ', (RMAT(4,L),L=1,4) */
/*      read(*,*) */

    return 0;
} /* projmatrix4_ */

/* Subroutine */ int rotpts3_(real *rmat, real *pts_in__, int *npts, real 
	*pts_out__)
{
    /* System generated locals */
    int i__1;

    /* Local variables */
    static int i__, j, k;
    static real tmp;

/* ...Purpose:    To rotate array of points to a new viewpoint by */
/*               parallel projection. The input rotation matrix */
/*               contains the transformation data in a 3x3 matrix. */

/* ...Input:    RMAT     3x3 transformation matrix */
/*             PTS_IN   array (3xNPTS) of input points */
/*             NPTS     number of points in arrays */

/* ...Output:   PTS_OUT  array (3xNPTS) of transformed points */


    /* Parameter adjustments */
    rmat -= 5;
    pts_out__ -= 4;
    pts_in__ -= 4;

    /* Function Body */
    i__1 = *npts;
    for (i__ = 1; i__ <= i__1; ++i__) {

	for (j = 1; j <= 3; ++j) {
	    tmp = 0.f;
	    for (k = 1; k <= 3; ++k) {
		tmp += pts_in__[k + i__ * 3] * rmat[k + (j << 2)];
	    }
	    pts_out__[j + i__ * 3] = tmp;
	}

    }

    return 0;
} /* rotpts3_ */

/* Subroutine */ int rotpts4_(real *rmat, real *pts_in__, int *npts, real 
	*pts_out__)
{
    /* System generated locals */
    int i__1;

    /* Builtin functions */
    int s_wsle(cilist *), do_lio(int *, int *, char *, ftnlen), 
	    e_wsle(void);

    /* Local variables */
    static int i__, j, k;
    static real tmp, ptmp[4], pptmp[4];

    /* Fortran I/O blocks */
    static cilist io___55 = { 0, 6, 0, 0, 0 };


/* ...Purpose:    To rotate array of points to a new viewpoint by */
/*               perspective projection. The input rotation matrix */
/*               contains the transformation and perspective data in */
/*               a 4x4 matrix in homogeneous coordinates. Note that input */
/*               coordinates may need to be z-clipped if the user trans. */
/*               moves the points behind the observer. A check is made */
/*               for a singular perspective point (at observer). */

/* ...Input:    RMAT  4x4 rotation and perspective matrix */
/*             PTS_IN   array (3xNPTS) of input points */
/*             NPTS     number of points in arrays */

/* ...Output:   PTS_OUT  array (3xNPTS) of transformed points */

/* ...Note:     You may need to translate your points to recenter them */
/*             about the origin to get good perspective views.  Points */
/*             off to the side get pretty distorted... */


    /* Parameter adjustments */
    rmat -= 5;
    pts_out__ -= 4;
    pts_in__ -= 4;

    /* Function Body */
    i__1 = *npts;
    for (i__ = 1; i__ <= i__1; ++i__) {

	ptmp[0] = pts_in__[i__ * 3 + 1];
	ptmp[1] = pts_in__[i__ * 3 + 2];
	ptmp[2] = pts_in__[i__ * 3 + 3];
	ptmp[3] = 1.f;

	for (j = 1; j <= 4; ++j) {
	    tmp = 0.f;
	    for (k = 1; k <= 4; ++k) {
		tmp += ptmp[k - 1] * rmat[k + (j << 2)];
	    }
	    pptmp[j - 1] = tmp;
	}

	if (pptmp[3] != 0.f) {
	    pts_out__[i__ * 3 + 1] = pptmp[0] / pptmp[3];
	    pts_out__[i__ * 3 + 2] = pptmp[1] / pptmp[3];
	    pts_out__[i__ * 3 + 3] = pptmp[2] / pptmp[3];
	} else {
	    s_wsle(&io___55);
	    do_lio(&c__9, &c__1, "Homogeneous coordinate singular for pt ", (
		    ftnlen)39);
	    do_lio(&c__3, &c__1, (char *)&i__, (ftnlen)sizeof(integer));
	    e_wsle();
	}

    }

    return 0;
} /* rotpts4_ */
