/* f/plt_font.f -- translated by f2c (version 20100827).
   You must link the resulting object file with libf2c:
	on Microsoft Windows system, link with libf2c.lib;
	on Linux or Unix systems, link with .../path/to/libf2c.a -lm
	or, if you install libf2c.a in a standard place, with -lf2c -lm
	-- in that order, at the end of the command line, as in
		cc *.o -lf2c -lm
	Source for libf2c is in /netlib/f2c/libf2c.zip, e.g.,

		http://www.netlib.org/f2c/libf2c.zip
*/

#include "f2c.h"

/* Table of constant values */

static int c__1 = 1;
static real c_b9 = 10.f;
static int c_n1 = -1;
static int c__2 = 2;
static int c__3 = 3;

/* *********************************************************************** */
/*    Module: plt_font.f */

/*    Copyright (C) 1996 Harold Youngren, Mark Drela */

/*    This library is free software; you can redistribute it and/or */
/*    modify it under the terms of the GNU Library General Public */
/*    License as published by the Free Software Foundation; either */
/*    version 2 of the License, or (at your option) any later version. */

/*    This library is distributed in the hope that it will be useful, */
/*    but WITHOUT ANY WARRANTY; without even the implied warranty of */
/*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU */
/*    Library General Public License for more details. */

/*    You should have received a copy of the GNU Library General Public */
/*    License along with this library; if not, write to the Free */
/*    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

/*    Report problems to:    guppy@maine.com */
/*                        or drela@mit.edu */
/* *********************************************************************** */

/* *********************************************************************** */
/* --- Font-related utility routines */

/* --- in user-coordinates... */
/*      PLNUMB - formats and plots a number (using PLCHAR) */
/*      PLCHAR - plots characters using CHAR font (WYSIWYG ASCII) */
/*      PLSLAN - plots characters using SLAN font (slanted ASCII) */
/*      PLMATH - plots characters using MATH font (LaTex-like symbols) */
/*      PLSYMB - plots plot-point symbol */

/* --- similarly, in absolute coordinates */
/*      PLNUMBABS - formats and plots a number */
/*      PLCHARABS - plots characters using CHAR font (normal  ASCII) */
/*      PLSLANABS - plots characters using SLAN font (slanted ASCII) */
/*      PLMATHABS - plots characters using MATH font (LaTex-like symbols) */
/*      PLSYMBABS - plots plot-point symbol */

/*     Version 4.46 11/28/01 */

/*     Notes:  These routines require the include files that define the */
/*             stroked fonts CHAR, MATH, SLAN, SYMB. */
/* *********************************************************************** */
/* Subroutine */ int plnumb_(real *xc, real *yc, real *chx, real *fpn, real *
	angle, int *ndig)
{
    extern doublereal xusr2abs_(real *), yusr2abs_(real *);
    extern /* Subroutine */ int plnumbabs_(real *, real *, real *, real *, 
	    real *, int *), getfactors_(real *, real *);
    static real xabs, yabs, chxabs, xscale, yscale;

/* ---------------------------------------------------------------- */
/*     Plots a floating-point number as a string of characters */

/*      xc,yc  = user coordinate position for plotting first character */
/*               (lower left point) */
/*               if xc=999. the last x plotting position is used */
/*               if yc=999. the last y plotting position is used */
/*      chx    = character width in x (user coordinate length) */
/*      FPN    = floating-point number to be plotted */
/*      ANGLE  = angle of character string (degrees from x-axis) */
/*      ndig   = specification of the number of digits and the type */
/*               of numeric string to be plotted (integer) */
/*             > 0 = number of digits to the right of the decimal */
/*                   point to be plotted (last digit is rounded) */
/*             = 0 = rounded int portion of fpn is plotted */
/*                   with a decimal point */
/*            = -1 = rounded int portion of fpn is plotted */
/*                   without the decimal point */
/*            < -1 = rounded int portion of fpn is plotted */
/*                   after having the least significant digits */
/*                   truncated (IABS(NDID)-1 digits are truncated) */

/*        CALLS:  GETFACTORS, PLNUMABS */
/* ---------------------------------------------------------------- */

/* ---Convert user coordinates and size to absolute coordinates */
    xabs = *xc;
    yabs = *yc;
    if (*xc != 999.f) {
	xabs = xusr2abs_(xc);
    }
    if (*yc != 999.f) {
	yabs = yusr2abs_(yc);
    }
    getfactors_(&xscale, &yscale);
    chxabs = xscale * *chx;
/* ---Call absolute coordinate routine */
    plnumbabs_(&xabs, &yabs, &chxabs, fpn, angle, ndig);

    return 0;
} /* plnumb_ */

/* Subroutine */ int plchar_(real *xc, real *yc, real *chx, char *string, 
	real *angle, int *nc, ftnlen string_len)
{
    extern doublereal xusr2abs_(real *), yusr2abs_(real *);
    extern /* Subroutine */ int plcharabs_(real *, real *, real *, char *, 
	    real *, int *, ftnlen), getfactors_(real *, real *);
    static real xabs, yabs, chxabs, xscale, yscale;

/* ---------------------------------------------------------------- */
/*     Plots character string with standard character font */

/*      xc,yc  = user coordinate position for first character in string */
/*               if xc=999. the last x plotting position is used */
/*               if yc=999. the last y plotting position is used */
/*      chx     = character width (user coordinates) */
/*      STRING = character string to plot with nc characters */
/*      ANGLE  = angle of character (radians, positive is righthanded rotation) */
/*      nc     = number of characters to plot */
/*               if nc<0 the length of the string is determined automatically */

/*     Character plotting uses the vector font database NODE(..) */
/*     Each NODE(..) value has the form  sxxyy */

/*        xx   = location of polyline point   0 ... 96 */
/*        yy       (origin assumed to be at 16,16) */
/*        s    = 2  if point is the start of a new polyline stroke */
/*             = 1  if point is inside or at the end of stroke */
/*             = 0  if point is not valid */

/*        CALLS:  GETFACTORS, PLCHARABS */
/* ---------------------------------------------------------------- */

/* ---Convert user coordinates and size to absolute coordinates */
    xabs = *xc;
    yabs = *yc;
    if (*xc != 999.f) {
	xabs = xusr2abs_(xc);
    }
    if (*yc != 999.f) {
	yabs = yusr2abs_(yc);
    }
    getfactors_(&xscale, &yscale);
    chxabs = xscale * *chx;
/* ---Call absolute coordinate routine */
    plcharabs_(&xabs, &yabs, &chxabs, string, angle, nc, string_len);

    return 0;
} /* plchar_ */

/* Subroutine */ int plslan_(real *xc, real *yc, real *chx, char *string, 
	real *angle, int *nc, ftnlen string_len)
{
    extern doublereal xusr2abs_(real *), yusr2abs_(real *);
    extern /* Subroutine */ int plslanabs_(real *, real *, real *, char *, 
	    real *, int *, ftnlen), getfactors_(real *, real *);
    static real xabs, yabs, chxabs, xscale, yscale;

/* ---------------------------------------------------------------- */
/*     Plots character string with slanted character font */

/*      xc,yc  = user coordinate position for first character in string */
/*               if xc=999. the last x plotting position is used */
/*               if yc=999. the last y plotting position is used */
/*      chx     = character width (user coordinates) */
/*      STRING = character string to plot with nc characters */
/*      ANGLE  = angle of character (radians, positive is righthanded rotation) */
/*      nc     = number of characters to plot */
/*               if nc<0 the length of the string is determined automatically */

/*     Character plotting uses the vector font database NODE(..) */
/*     Each NODE(..) value has the form  sxxyy */

/*        xx   = location of polyline point   0 ... 96 */
/*        yy       (origin assumed to be at 16,16) */
/*        s    = 2  if point is the start of a new polyline stroke */
/*             = 1  if point is inside or at the end of stroke */
/*             = 0  if point is not valid */

/*        CALLS:  GETFACTORS, PLCHARABS */
/* ---------------------------------------------------------------- */

/* ---Convert user coordinates and size to absolute coordinates */
    xabs = *xc;
    yabs = *yc;
    if (*xc != 999.f) {
	xabs = xusr2abs_(xc);
    }
    if (*yc != 999.f) {
	yabs = yusr2abs_(yc);
    }
    getfactors_(&xscale, &yscale);
    chxabs = xscale * *chx;
/* ---Call absolute coordinate routine */
    plslanabs_(&xabs, &yabs, &chxabs, string, angle, nc, string_len);

    return 0;
} /* plslan_ */

/* Subroutine */ int plmath_(real *xc, real *yc, real *chx, char *string, 
	real *angle, int *nc, ftnlen string_len)
{
    extern doublereal xusr2abs_(real *), yusr2abs_(real *);
    extern /* Subroutine */ int plmathabs_(real *, real *, real *, char *, 
	    real *, int *, ftnlen), getfactors_(real *, real *);
    static real xabs, yabs, chxabs, xscale, yscale;

/* ---------------------------------------------------------------- */
/*     Plots character string with math character font */

/*      xc,yc  = user coordinate position for first character in string */
/*               if xc=999. the last x plotting position is used */
/*               if yc=999. the last y plotting position is used */
/*      chx     = character width (user coordinates) */
/*      STRING = character string to plot with nc characters */
/*      ANGLE  = angle of character (radians, positive is righthanded rotation) */
/*      nc     = number of characters to plot */
/*               if nc<0 the length of the string is determined automatically */

/*     Character plotting uses the vector font database NODE(..) */
/*     Each NODE(..) value has the form  sxxyy */

/*        xx   = location of polyline point   0 ... 96 */
/*        yy       (origin assumed to be at 16,16) */
/*        s    = 2  if point is the start of a new polyline stroke */
/*             = 1  if point is inside or at the end of stroke */
/*             = 0  if point is not valid */

/*        CALLS:  GETFACTORS, PLMATHABS */
/* ---------------------------------------------------------------- */

/* ---Convert user coordinates and size to absolute coordinates */
    xabs = *xc;
    yabs = *yc;
    if (*xc != 999.f) {
	xabs = xusr2abs_(xc);
    }
    if (*yc != 999.f) {
	yabs = yusr2abs_(yc);
    }
    getfactors_(&xscale, &yscale);
    chxabs = xscale * *chx;
/* ---Call absolute coordinate routine */
    plmathabs_(&xabs, &yabs, &chxabs, string, angle, nc, string_len);

    return 0;
} /* plmath_ */

/* Subroutine */ int plsymb_(real *xc, real *yc, real *chx, int *isym, 
	real *angle, int *nc)
{
    extern doublereal xusr2abs_(real *), yusr2abs_(real *);
    extern /* Subroutine */ int plsymbabs_(real *, real *, real *, int *, 
	    real *, int *), getfactors_(real *, real *);
    static real xabs, yabs, chxabs, xscale, yscale;

/* ---------------------------------------------------------------- */
/*     Plots a symbol with symbol font indexed by int */

/*      xc,yc  = user coordinate position for plotting symbol */
/*               if xc=999. the last x plotting position is used */
/*               if yc=999. the last y plotting position is used */
/*      chx     = symbol width */
/*      ISYM   = int to select symbol (0..?) */
/*      ANGLE  = angle for symbol (radians, positive is righthanded rotation) */
/*      nc     = 0  just move to x,y before plotting symbol */
/*           .ne.0  draw line to x,y before plotting symbol */

/*     Plots a symbol using vector font database NODE(..) */
/*     Each NODE(..) value has the form  sxxyy */

/*        xx   = location of polyline point   0 ... 96 */
/*        yy       (origin assumed to be at 48,48) */
/*        s    = 2  if point is the start of a new polyline stroke */
/*             = 1  if point is inside or at the end of stroke */
/*             = 0  if point is not valid */

/*        CALLS:  GETFACTORS, PLSYMBABS */
/* ---------------------------------------------------------------- */

/* ---Convert user coordinates and size to absolute coordinates */
    xabs = *xc;
    yabs = *yc;
    if (*xc != 999.f) {
	xabs = xusr2abs_(xc);
    }
    if (*yc != 999.f) {
	yabs = yusr2abs_(yc);
    }
    getfactors_(&xscale, &yscale);
    chxabs = xscale * *chx;
/* ---Call absolute coordinate routine */
    plsymbabs_(&xabs, &yabs, &chxabs, isym, angle, nc);

    return 0;
} /* plsymb_ */

/* Subroutine */ int plnumbabs_(real *xc, real *yc, real *chx, real *fpn, 
	real *angle, int *ndig)
{
    /* Initialized data */

    static char minus[1] = "-";
    static char point[1] = ".";

    /* Builtin functions */
    double pow_ri(real *, int *);

    /* Local variables */
    extern /* Subroutine */ int plcharabs_(real *, real *, real *, char *, 
	    real *, int *, ftnlen);
    static real t1, t2;
    static int nd, nl, np;
    static real xx, yy;
    static int idig;
    static char chdig[1];
    static int izero;

/* ---------------------------------------------------------------- */
/*     Plots a floating-point number as a string of characters */

/*      XC,YC  = absolute coordinate position for plotting first character */
/*               (lower left point) */
/*               if XC=999. the last x plotting position is used */
/*               if YC=999. the last y plotting position is used */
/*      CHX    = character width in x (absolute coordinate length) */
/*      FPN    = floating-point number to be plotted */
/*      ANGLE  = angle of character string (degrees from x-axis) */
/*      ndig   = specification of the number of digits and the type */
/*               of numeric string to be plotted (integer) */
/*             > 0 = number of digits to the right of the decimal */
/*                   point to be plotted (last digit is rounded) */
/*             = 0 = rounded int portion of fpn is plotted */
/*                   with a decimal point */
/*            = -1 = rounded int portion of fpn is plotted */
/*                   without the decimal point */
/*            < -1 = rounded int portion of fpn is plotted */
/*                   after having the least significant digits */
/*                   truncated (IABS(NDID)-1 digits are truncated) */

/*        CALLS:  PLCHARABS */
/* ---------------------------------------------------------------- */

    izero = '0';

    t1 = *fpn;
    xx = *xc;
    yy = *yc;
/* ...Number negative? */
    if (t1 < 0.f) {
	plcharabs_(&xx, &yy, chx, minus, angle, &c__1, (ftnlen)1);
	xx = 999.f;
	yy = 999.f;
	t1 = -t1;
    }

/* ...Set working digit count */
    nd = -(*ndig);

/* ...Integer only to be plotted? */
    if (*ndig <= 0) {
/* ...Round and truncate for int */
	if (*ndig == 0) {
	    nd = 1;
	}
	--nd;
	t2 = (real) ((integer) ((t1 + .5f) / pow_ri(&c_b9, &nd))) + .5f;
	nd = 0;
	if (*ndig == 0) {
	    nd = -1;
	}
    } else {
/* ...Round for fraction */
	t2 = t1 + .5f / pow_ri(&c_b9, ndig);
    }

/* ...Find number of digits to the left of decimal point */
    nl = 1;
/* ...Any more digits to the left of the d.p. */
L60:
    if (t2 >= 10.f) {
	t2 /= 10.f;
	++nl;
	goto L60;
    }

/* ...Set plottable digit count */
    np = nl - nd;
/* ...Bad digit count? */
    if (np <= 0) {
	np = 1;
    }

/* ...Plot decimal point (NL=0) */
L80:
    if (nl == 0) {
/* ...No decimal point? */
	if (*ndig < 0) {
	    goto L120;
	}
	plcharabs_(&xx, &yy, chx, point, angle, &c__1, (ftnlen)1);
	if (*ndig != 0) {
	    ++np;
	}
    } else {
/* ...Plot digit */
	idig = (integer) t2;
	t2 = (t2 - (real) idig) * 10.f;
	*(unsigned char *)chdig = (char) (idig + izero);
	plcharabs_(&xx, &yy, chx, chdig, angle, &c__1, (ftnlen)1);
    }
    xx = 999.f;
    yy = 999.f;

/* ...Count digit */
    --np;
L120:
    --nl;

/* ...More digits to plot? */
    if (np > 0) {
	goto L80;
    }
    return 0;
} /* plnumbabs_ */

/* Subroutine */ int plcharabs_(real *xc, real *yc, real *chx, char *string, 
	real *angle, int *nc, ftnlen string_len)
{
    /* Initialized data */

    static char chars[92] = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstu"
	    "vwxyz0123456789,.;:`\"!?@#$%&|()[]{}<>_+-*=/^~";
    static real pi = 3.1415926535897932384f;
    static struct {
	int e_1[1840];
	} equiv_9 = { 21616, 11672, 12183, 12888, 14488, 15183, 15672, 15616, 
		21650, 15650, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 21616, 11688, 
		14288, 15284, 15676, 15668, 15260, 14256, 15252, 15644, 15628,
		 15220, 14216, 11616, 21656, 14256, 0, 0, 0, 0, 25674, 15183, 
		14488, 12888, 12183, 11672, 11632, 12121, 12816, 14416, 15121,
		 15629, 0, 0, 0, 0, 0, 0, 0, 0, 21416, 14416, 15121, 15632, 
		15672, 15183, 14488, 11488, 21816, 11888, 0, 0, 0, 0, 0, 0, 0,
		 0, 0, 0, 25616, 11616, 11688, 15688, 21656, 14756, 0, 0, 0, 
		0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 21616, 11688, 15688, 21656, 
		14656, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 25674, 
		15183, 14488, 12888, 12183, 11672, 11632, 12121, 12816, 14416,
		 15121, 15632, 15650, 14050, 0, 0, 0, 0, 0, 0, 21616, 11688, 
		25616, 15688, 21656, 15656, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
		0, 0, 0, 23888, 13816, 22616, 15016, 22688, 15088, 0, 0, 0, 0,
		 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 21430, 11921, 12616, 13916, 
		14621, 15132, 15188, 25788, 13688, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
		0, 0, 21688, 11616, 25688, 11645, 22858, 15616, 0, 0, 0, 0, 0,
		 0, 0, 0, 0, 0, 0, 0, 0, 0, 22088, 12016, 16016, 0, 0, 0, 0, 
		0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 21416, 11488, 13648, 
		15888, 15816, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
		21616, 11688, 15616, 15688, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
		0, 0, 0, 0, 0, 21632, 11672, 12183, 12888, 14488, 15183, 
		15672, 15632, 15121, 14416, 12816, 12121, 11632, 0, 0, 0, 0, 
		0, 0, 0, 21616, 11688, 14288, 15283, 15676, 15662, 15255, 
		14250, 11650, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 21632, 11672, 
		12183, 12888, 14488, 15183, 15672, 15632, 15121, 14416, 12816,
		 12121, 11632, 24131, 15616, 0, 0, 0, 0, 0, 21616, 11688, 
		14288, 15283, 15676, 15662, 15255, 14250, 11650, 24250, 15816,
		 0, 0, 0, 0, 0, 0, 0, 0, 0, 25676, 15183, 14288, 13088, 12183,
		 11674, 11670, 12161, 13056, 14256, 15151, 15642, 15630, 
		15121, 14216, 13016, 12121, 11630, 0, 0, 23688, 13616, 21488, 
		15888, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 21688, 
		11632, 12121, 12816, 14416, 15121, 15632, 15688, 0, 0, 0, 0, 
		0, 0, 0, 0, 0, 0, 0, 0, 21688, 11682, 13616, 15682, 15688, 0, 
		0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 21488, 11452, 11639,
		 12516, 13437, 13646, 13837, 14716, 15639, 15852, 15888, 
		23646, 13654, 0, 0, 0, 0, 0, 0, 0, 21688, 11682, 15622, 15616,
		 25688, 15682, 11622, 11616, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
		0, 21688, 11682, 13656, 15682, 15688, 23656, 13616, 0, 0, 0, 
		0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 21688, 15688, 11616, 15616, 
		22756, 14556, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 22064,
		 14264, 15159, 15650, 15616, 25642, 12842, 12038, 11630, 
		11628, 12020, 12816, 14416, 15220, 15628, 0, 0, 0, 0, 0, 
		21888, 11816, 21852, 12260, 13064, 14664, 15460, 15852, 15828,
		 15420, 14616, 13016, 12220, 11828, 0, 0, 0, 0, 0, 0, 25652, 
		15260, 14464, 12864, 12060, 11652, 11628, 12020, 12816, 14416,
		 15220, 15628, 0, 0, 0, 0, 0, 0, 0, 0, 25488, 15416, 25452, 
		15060, 14264, 12664, 11860, 11452, 11428, 11820, 12616, 14216,
		 15020, 15428, 0, 0, 0, 0, 0, 0, 25626, 15220, 14416, 12816, 
		12020, 11628, 11652, 12060, 12864, 14464, 15260, 15652, 15641,
		 11641, 0, 0, 0, 0, 0, 0, 26072, 15680, 14884, 13684, 12880, 
		12472, 12416, 21656, 14256, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
		21616, 12008, 12804, 14404, 15208, 15616, 15664, 25652, 15260,
		 14464, 12864, 12060, 11652, 11637, 12029, 12825, 14425, 
		15229, 15637, 0, 21688, 11616, 21652, 12060, 12864, 14464, 
		15260, 15652, 15616, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 22416, 
		15216, 24016, 14062, 12962, 23377, 13380, 13582, 13882, 14080,
		 14077, 13875, 13575, 13377, 0, 0, 0, 0, 0, 0, 21416, 11808, 
		12604, 13804, 14608, 15016, 15062, 13862, 24375, 14177, 14180,
		 14382, 14682, 14880, 14877, 14675, 14375, 0, 0, 0, 21888, 
		11816, 21844, 15268, 22750, 15816, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
		0, 0, 0, 0, 0, 22316, 14916, 23616, 13688, 12788, 0, 0, 0, 0, 
		0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 21464, 11416, 21453, 11760, 
		12364, 12764, 13360, 13653, 13960, 14564, 14964, 15560, 15853,
		 15816, 23653, 13624, 0, 0, 0, 0, 21664, 11616, 21652, 12060, 
		12864, 14464, 15260, 15652, 15616, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
		0, 0, 21628, 11652, 12060, 12864, 14464, 15260, 15652, 15628, 
		15220, 14416, 12816, 12020, 11628, 0, 0, 0, 0, 0, 0, 0, 21864,
		 11800, 21852, 12260, 13064, 14664, 15460, 15852, 15836, 
		15428, 14624, 13024, 12228, 11836, 0, 0, 0, 0, 0, 0, 25464, 
		15400, 25452, 15060, 14264, 12664, 11860, 11452, 11436, 11828,
		 12624, 14224, 15028, 15436, 0, 0, 0, 0, 0, 0, 22064, 12016, 
		22052, 12460, 13264, 14664, 15460, 15852, 0, 0, 0, 0, 0, 0, 0,
		 0, 0, 0, 0, 0, 25656, 15361, 14664, 12664, 11961, 11654, 
		11651, 11945, 12641, 14641, 15337, 15631, 15626, 15319, 14616,
		 12616, 11919, 11624, 0, 0, 22484, 12428, 12820, 13616, 14816,
		 15620, 16028, 21666, 14266, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
		21664, 11628, 12020, 12816, 14416, 15220, 15628, 25664, 15616,
		 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 21664, 11657, 11849, 13616, 
		15449, 15657, 15664, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
		21464, 11440, 11630, 12516, 13429, 13636, 13829, 14716, 15630,
		 15840, 15864, 23636, 13642, 0, 0, 0, 0, 0, 0, 0, 21864, 
		15616, 25464, 11616, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
		 0, 0, 21664, 11637, 12029, 12825, 14425, 15229, 15637, 25664,
		 15616, 15208, 14404, 12804, 12008, 11616, 0, 0, 0, 0, 0, 0, 
		21864, 15464, 11616, 15616, 22742, 14442, 0, 0, 0, 0, 0, 0, 0,
		 0, 0, 0, 0, 0, 0, 0, 21628, 11676, 12084, 12888, 14488, 
		15284, 15676, 15628, 15220, 14416, 12816, 12020, 11628, 0, 0, 
		0, 0, 0, 0, 0, 22678, 13688, 13616, 22616, 14616, 0, 0, 0, 0, 
		0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 21676, 12084, 12888, 14488, 
		15284, 15676, 15666, 15258, 12036, 11628, 11616, 15616, 0, 0, 
		0, 0, 0, 0, 0, 0, 21878, 12284, 13088, 14488, 15284, 15676, 
		15669, 15261, 14457, 15253, 15644, 15628, 15220, 14416, 12816,
		 12020, 11626, 24457, 12857, 0, 25088, 15016, 24016, 16016, 
		26040, 11640, 11688, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
		25488, 11688, 11657, 14457, 15253, 15645, 15628, 15220, 14416,
		 12816, 12020, 11628, 0, 0, 0, 0, 0, 0, 0, 0, 25678, 15284, 
		14488, 12888, 12084, 11676, 11628, 12020, 12816, 14416, 15220,
		 15628, 15645, 15253, 14457, 12857, 12053, 11645, 0, 0, 21688,
		 15688, 15679, 13228, 13216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
		0, 0, 0, 0, 24757, 12557, 11667, 11676, 12084, 12888, 14488, 
		15284, 15676, 15667, 14757, 15647, 15628, 15220, 14416, 12816,
		 12020, 11628, 11647, 12557, 21626, 12020, 12816, 14416, 
		15220, 15628, 15676, 15284, 14488, 12888, 12084, 11676, 11659,
		 12051, 12847, 14447, 15251, 15659, 0, 0, 22604, 13416, 13424,
		 12624, 12616, 13215, 12604, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
		0, 0, 22624, 13424, 13416, 12616, 12624, 0, 0, 0, 0, 0, 0, 0, 
		0, 0, 0, 0, 0, 0, 0, 0, 22604, 13215, 12616, 12624, 13424, 
		13416, 12604, 22656, 12648, 13448, 13456, 12656, 0, 0, 0, 0, 
		0, 0, 0, 0, 22624, 12616, 13416, 13424, 12624, 22656, 12648, 
		13448, 13456, 12656, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 25284, 
		16268, 15884, 15284, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
		 0, 0, 22184, 12666, 12784, 12184, 23784, 14266, 14384, 13784,
		 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 23524, 13316, 13916, 
		13724, 13524, 23639, 14088, 13288, 13639, 23685, 13646, 0, 0, 
		0, 0, 0, 0, 0, 0, 0, 22074, 12283, 13088, 14288, 15083, 15274,
		 14866, 14160, 13754, 13647, 13639, 23524, 13316, 13916, 
		13724, 13524, 0, 0, 0, 0, 24543, 13738, 12843, 12854, 13761, 
		14758, 14543, 14939, 15439, 15949, 15865, 15075, 13877, 12674,
		 11863, 11647, 11931, 13222, 14422, 15627, 23278, 12622, 
		24778, 14122, 21959, 15759, 21640, 15440, 0, 0, 0, 0, 0, 0, 0,
		 0, 0, 0, 0, 0, 25176, 12976, 12273, 11967, 11959, 12254, 
		12852, 14452, 15050, 15445, 15437, 15031, 14328, 12128, 23616,
		 13688, 0, 0, 0, 0, 21616, 15688, 22488, 12084, 12079, 12475, 
		12975, 13379, 13384, 12988, 12488, 25116, 15520, 15525, 15129,
		 14629, 14225, 14220, 14616, 15116, 25636, 15023, 14418, 
		13716, 12816, 12021, 11629, 11637, 12246, 13956, 14564, 14572,
		 14377, 13880, 13280, 12677, 12469, 12758, 15616, 0, 23696, 
		13608, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
		25092, 14382, 13965, 13850, 13935, 14318, 15008, 24417, 14230,
		 14150, 14270, 14483, 0, 0, 0, 0, 0, 0, 0, 0, 22292, 12982, 
		13365, 13450, 13335, 12918, 12208, 22883, 13070, 13150, 13030,
		 12817, 0, 0, 0, 0, 0, 0, 0, 0, 25294, 13894, 13806, 15206, 
		24094, 14006, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 22094,
		 13494, 13406, 12006, 23294, 13206, 0, 0, 0, 0, 0, 0, 0, 0, 0,
		 0, 0, 0, 0, 0, 24896, 13890, 13853, 12850, 13846, 13810, 
		14804, 24009, 14045, 13846, 24091, 14054, 13853, 0, 0, 0, 0, 
		0, 0, 0, 22496, 13490, 13453, 14450, 13446, 13410, 12304, 
		23209, 13245, 13446, 23291, 13254, 13453, 0, 0, 0, 0, 0, 0, 0,
		 25666, 11648, 15630, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
		0, 0, 0, 0, 21666, 15648, 11630, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
		 0, 0, 0, 0, 0, 0, 0, 20800, 17200, 0, 0, 0, 0, 0, 0, 0, 0, 0,
		 0, 0, 0, 0, 0, 0, 0, 0, 0, 21648, 15648, 23668, 13628, 0, 0, 
		0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 21648, 15648, 0, 0, 
		0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 22765, 14531, 
		22731, 14565, 21748, 15548, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
		0, 0, 0, 21656, 15656, 21640, 15640, 0, 0, 0, 0, 0, 0, 0, 0, 
		0, 0, 0, 0, 0, 0, 0, 0, 21208, 16096, 0, 0, 0, 0, 0, 0, 0, 0, 
		0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 21854, 13868, 15854, 0, 0, 0, 0,
		 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 21546, 11951, 12754, 
		13452, 14344, 14942, 15745, 16150, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
		0, 0, 0 };


    /* System generated locals */
    int i__1;

    /* Builtin functions */
    double sin(doublereal), cos(doublereal);
    int i_len(char *, ftnlen), i_indx(char *, char *, ftnlen, ftnlen);

    /* Local variables */
    static int i__, j, k;
    static real x, y, x0, y0;
    static int ic, kc;
    static real fi, fj, xx, yy;
    static int ncc;
#define node ((int *)&equiv_9)
    static real cosa, sina, xchr, ychr;
#define node0 ((int *)&equiv_9)
#define node1 ((int *)&equiv_9 + 200)
#define node2 ((int *)&equiv_9 + 400)
#define node3 ((int *)&equiv_9 + 600)
#define node4 ((int *)&equiv_9 + 800)
#define node5 ((int *)&equiv_9 + 1000)
#define node6 ((int *)&equiv_9 + 1200)
#define node7 ((int *)&equiv_9 + 1400)
#define node8 ((int *)&equiv_9 + 1600)
#define node9 ((int *)&equiv_9 + 1800)
    extern /* Subroutine */ int getlastxyabs_(real *, real *);
    static int nodeb, lmask, istat;
    extern /* Subroutine */ int getpat_(int *), newpat_(int *), 
	    plotabs_(real *, real *, int *);

/* ---------------------------------------------------------------- */
/*     Plots character string with standard character font */

/*      XC,YC  = absolute coordinate position for first character in string */
/*               if XC=999. the last x plotting position is used */
/*               if YC=999. the last y plotting position is used */
/*      CHX    = character width in x (absolute coordinate length) */
/*      STRING = character string to plot with nc characters */
/*      ANGLE  = angle of character (radians, positive is righthanded rotation) */
/*      nc     = number of characters to plot */
/*               if nc<0 the length of the string is determined automatically */

/*     Character plotting uses the vector font database NODE(..) */
/*     Each NODE(..) value has the form  sxxyy */

/*        xx   = location of polyline point   0 ... 96 */
/*        yy       (origin assumed to be at 16,16) */
/*        s    = 2  if point is the start of a new polyline stroke */
/*             = 1  if point is inside or at the end of stroke */
/*             = 0  if point is not valid */

/*        CALLS:  GETLASTXYABS, GETPAT, NEWPAT, PLOTABS */
/* ---------------------------------------------------------------- */


/*     Version 4.46 11/28/01 */

    sina = sin(*angle * pi / 180.f);
    cosa = cos(*angle * pi / 180.f);

    xx = *xc;
    yy = *yc;
/* ---- if XC=999. or YC=999. get last x,y character plotting position */
    if (*xc == 999.f || *yc == 999.f) {
	getlastxyabs_(&xchr, &ychr);
	if (*xc == 999.f) {
	    xx = xchr;
	}
	if (*yc == 999.f) {
	    yy = ychr;
	}
    }

/* ---- get the old line pattern, only plot characters & symbols with solid lines */
    getpat_(&lmask);
    if (lmask != -1) {
	newpat_(&c_n1);
    }

/* ---- if number of characters */
    ncc = *nc;
    if (ncc < 0) {
	ncc = i_len(string, string_len);
    }
    if (ncc == 0) {
	return 0;
    }

/* ---- go over each character... */
    i__1 = ncc;
    for (ic = 1; ic <= i__1; ++ic) {

/* ------ set character origin location */
	x0 = xx + *chx * (real) (ic - 1) * cosa;
	y0 = yy + *chx * (real) (ic - 1) * sina;

	kc = i_indx(chars, string + (ic - 1), (ftnlen)92, (ftnlen)1);

	if (kc != 0) {

/* -------- decode and plot each node */
	    for (k = 1; k <= 20; ++k) {

/* ---------- strip off leading point-status digit */
		istat = node[k + kc * 20 - 21] / 10000;
		nodeb = node[k + kc * 20 - 21] - istat * 10000;

/* ---------- decode x and y location coordinates */
		i__ = nodeb / 100;
		j = nodeb - i__ * 100;

		fi = (real) (i__ - 16) / 64.f;
		fj = (real) (j - 16) / 64.f;

		x = x0 + *chx * (fi * cosa - fj * sina);
		y = y0 + *chx * (fi * sina + fj * cosa);

		if (istat == 0) {
		    goto L12;
		} else if (istat == 1) {
		    plotabs_(&x, &y, &c__2);
		} else {
		    plotabs_(&x, &y, &c__3);
		}

	    }
	}

L12:
	;
    }

/* ---- move to bottom right corner x,y for next call with x,y = 999.,999. */
    x0 = xx + *chx * (real) ncc * cosa;
    y0 = yy + *chx * (real) ncc * sina;
    plotabs_(&x0, &y0, &c__3);

/* ---- restore line pattern */
    if (lmask != -1) {
	newpat_(&lmask);
    }

    return 0;
} /* plcharabs_ */

#undef node9
#undef node8
#undef node7
#undef node6
#undef node5
#undef node4
#undef node3
#undef node2
#undef node1
#undef node0
#undef node


/* Subroutine */ int plslanabs_(real *xc, real *yc, real *chx, char *string, 
	real *angle, int *nc, ftnlen string_len)
{
    /* Initialized data */

    static char chars[92] = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstu"
	    "vwxyz0123456789,.;:`\"!?@#$%&|()[]{}<>_+-*=/^~";
    static real pi = 3.1415926535897932384f;
    static struct {
	int e_1[1840];
	} equiv_9 = { 21616, 12472, 13183, 13888, 15488, 16183, 16472, 15616, 
		22150, 16150, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 21616, 12688, 
		15188, 16184, 16476, 16368, 15860, 14856, 15752, 16044, 15728,
		 15220, 14216, 11616, 22256, 14856, 0, 0, 0, 0, 26474, 16183, 
		15488, 13888, 13183, 12472, 11832, 12121, 12816, 14416, 15121,
		 15729, 0, 0, 0, 0, 0, 0, 0, 0, 21416, 14416, 15121, 15832, 
		16472, 16183, 15488, 12488, 21816, 12888, 0, 0, 0, 0, 0, 0, 0,
		 0, 0, 0, 25616, 11616, 12688, 16688, 22256, 15356, 0, 0, 0, 
		0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 21616, 12688, 16688, 22256, 
		15256, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 26474, 
		16183, 15488, 13888, 13183, 12472, 11832, 12121, 12816, 14416,
		 15121, 15832, 16150, 14550, 0, 0, 0, 0, 0, 0, 21616, 12688, 
		25616, 16688, 22256, 16256, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
		0, 0, 0, 24888, 13816, 22616, 15016, 23688, 16088, 0, 0, 0, 0,
		 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 21630, 11921, 12616, 13916, 
		14621, 15332, 16188, 26788, 14688, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
		0, 0, 22688, 11616, 26688, 12045, 23458, 15616, 0, 0, 0, 0, 0,
		 0, 0, 0, 0, 0, 0, 0, 0, 0, 23088, 12016, 16016, 0, 0, 0, 0, 
		0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 21416, 12488, 14048, 
		16888, 15816, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
		21616, 12688, 15616, 16688, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
		0, 0, 0, 0, 0, 21832, 12472, 13183, 13888, 15488, 16183, 
		16472, 15832, 15121, 14416, 12816, 12121, 11832, 0, 0, 0, 0, 
		0, 0, 0, 21616, 12688, 15188, 16183, 16476, 16262, 15755, 
		14750, 12150, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 21832, 12472, 
		13183, 13888, 15488, 16183, 16472, 15832, 15121, 14416, 12816,
		 12121, 11832, 24331, 15616, 0, 0, 0, 0, 0, 21616, 12688, 
		15188, 16183, 16476, 16262, 15755, 14750, 12150, 24750, 15816,
		 0, 0, 0, 0, 0, 0, 0, 0, 0, 26576, 16183, 15288, 14088, 13183,
		 12474, 12470, 12761, 13656, 14856, 15651, 15942, 15830, 
		15121, 14216, 13016, 12121, 11830, 0, 0, 24688, 13616, 22488, 
		16888, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 22688, 
		11832, 12121, 12816, 14416, 15121, 15832, 16688, 0, 0, 0, 0, 
		0, 0, 0, 0, 0, 0, 0, 0, 22688, 12582, 13616, 16582, 16688, 0, 
		0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 22488, 11952, 11939,
		 12516, 13737, 14046, 14137, 14716, 15939, 16352, 16888, 
		24046, 14154, 0, 0, 0, 0, 0, 0, 0, 22688, 12582, 15622, 15616,
		 26688, 16582, 11622, 11616, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
		0, 22688, 12582, 14256, 16582, 16688, 24256, 13616, 0, 0, 0, 
		0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 22688, 16688, 11616, 15616, 
		23356, 15156, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 22764,
		 14964, 15759, 16150, 15616, 25942, 13142, 12338, 11730, 
		11728, 12020, 12816, 14416, 15220, 15728, 0, 0, 0, 0, 0, 
		22888, 11816, 22352, 12860, 13764, 15364, 16060, 16252, 15928,
		 15420, 14616, 13016, 12220, 12028, 0, 0, 0, 0, 0, 0, 26152, 
		15860, 15164, 13564, 12660, 12152, 11728, 12020, 12816, 14416,
		 15220, 15728, 0, 0, 0, 0, 0, 0, 0, 0, 26488, 15416, 25952, 
		15660, 14964, 13364, 12460, 11952, 11528, 11820, 12616, 14216,
		 15020, 15528, 0, 0, 0, 0, 0, 0, 25726, 15220, 14416, 12816, 
		12020, 11728, 12152, 12660, 13564, 15164, 15860, 16152, 15941,
		 11941, 0, 0, 0, 0, 0, 0, 26872, 16680, 15884, 14684, 13880, 
		13272, 12416, 22256, 14856, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
		21616, 11908, 12704, 14304, 15108, 15616, 16364, 26152, 15860,
		 15164, 13564, 12660, 12152, 11937, 12129, 12925, 14525, 
		15329, 15937, 0, 22688, 11616, 22152, 12660, 13564, 15164, 
		15860, 16152, 15616, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 22416, 
		15216, 24016, 14662, 13562, 24277, 14280, 14482, 14782, 14980,
		 14977, 14675, 14375, 14277, 0, 0, 0, 0, 0, 0, 21416, 11708, 
		12504, 13704, 14508, 15016, 15662, 14462, 25175, 15077, 15080,
		 15282, 15582, 15780, 15777, 15475, 15175, 0, 0, 0, 22888, 
		11816, 22244, 15968, 23250, 15816, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
		0, 0, 0, 0, 0, 22316, 14916, 23616, 14688, 13788, 0, 0, 0, 0, 
		0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 22164, 11416, 22053, 12360, 
		13064, 13464, 13960, 14153, 14560, 15264, 15664, 16160, 16353,
		 15816, 24153, 13724, 0, 0, 0, 0, 22364, 11616, 22152, 12660, 
		13564, 15164, 15860, 16152, 15616, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
		0, 0, 21728, 12152, 12660, 13564, 15164, 15860, 16152, 15728, 
		15220, 14416, 12816, 12020, 11728, 0, 0, 0, 0, 0, 0, 0, 22564,
		 11600, 22352, 12860, 13764, 15364, 16060, 16352, 16136, 
		15528, 14724, 13124, 12328, 12136, 0, 0, 0, 0, 0, 0, 26164, 
		15200, 25952, 15660, 14964, 13364, 12460, 11952, 11736, 11928,
		 12724, 14324, 15128, 15736, 0, 0, 0, 0, 0, 0, 22764, 12016, 
		22552, 13060, 13964, 15364, 16060, 16352, 0, 0, 0, 0, 0, 0, 0,
		 0, 0, 0, 0, 0, 26256, 15961, 15364, 13364, 12661, 12255, 
		12151, 12345, 12941, 14941, 15637, 15831, 15726, 15319, 14616,
		 12616, 11919, 11724, 0, 0, 23484, 12528, 12820, 13616, 14816,
		 15620, 16128, 22366, 14966, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
		22364, 11728, 12020, 12816, 14416, 15220, 15728, 26364, 15616,
		 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 22364, 12154, 13616, 16154, 
		16364, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 22164, 
		11840, 11830, 12516, 13529, 13936, 14029, 14716, 15830, 16140,
		 16564, 23936, 14042, 0, 0, 0, 0, 0, 0, 0, 22564, 15616, 
		26164, 11616, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
		22364, 11937, 12129, 12925, 14525, 15329, 15937, 26364, 15616,
		 15108, 14304, 12704, 11908, 11616, 0, 0, 0, 0, 0, 0, 22564, 
		16164, 11616, 15616, 23042, 14742, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
		0, 0, 0, 0, 0, 21728, 12576, 13084, 13888, 15488, 16284, 
		16576, 15728, 15220, 14416, 12816, 12020, 11728, 0, 0, 0, 0, 
		0, 0, 0, 23578, 14688, 13616, 22616, 14616, 0, 0, 0, 0, 0, 0, 
		0, 0, 0, 0, 0, 0, 0, 0, 0, 22576, 13084, 13888, 15488, 16284, 
		16576, 16466, 15858, 12336, 11728, 11616, 15616, 0, 0, 0, 0, 
		0, 0, 0, 0, 22778, 13284, 14088, 15488, 16284, 16576, 16469, 
		15861, 15057, 15753, 16044, 15728, 15220, 14416, 12816, 12020,
		 11726, 25057, 13457, 0, 26088, 15016, 24016, 16016, 26340, 
		11940, 12688, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 26488, 
		12688, 12257, 15057, 15753, 16045, 15728, 15220, 14416, 12816,
		 12020, 11728, 0, 0, 0, 0, 0, 0, 0, 0, 26578, 16284, 15488, 
		13888, 13084, 12576, 11728, 12020, 12816, 14416, 15220, 15728,
		 16045, 15753, 15057, 13457, 12553, 12045, 0, 0, 22688, 16688,
		 16579, 13328, 13216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
		0, 0, 25357, 13157, 12467, 12576, 13084, 13888, 15488, 16284, 
		16576, 16367, 15357, 16047, 15728, 15220, 14416, 12816, 12020,
		 11728, 12047, 13157, 21726, 12020, 12816, 14416, 15220, 
		15728, 16576, 16284, 15488, 13888, 13084, 12576, 12259, 12551,
		 13247, 14847, 15751, 16259, 0, 0, 22002, 12916, 13024, 12224,
		 12116, 12515, 12002, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
		22224, 13024, 12916, 12116, 12224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
		0, 0, 0, 0, 0, 0, 22002, 12515, 12116, 12224, 13024, 12916, 
		12002, 22656, 12548, 13348, 13456, 12656, 0, 0, 0, 0, 0, 0, 0,
		 0, 22224, 12116, 12916, 13024, 12224, 22656, 12548, 13348, 
		13456, 12656, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 25784, 16468, 
		16384, 15784, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
		22684, 12866, 13284, 12684, 24284, 14466, 14884, 14284, 0, 0, 
		0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 23124, 12816, 13416, 13324, 
		13124, 23439, 14588, 13788, 13439, 24185, 13546, 0, 0, 0, 0, 
		0, 0, 0, 0, 0, 22374, 12783, 13588, 14788, 15583, 15574, 
		15066, 14260, 13754, 13547, 13439, 23124, 12816, 13416, 13324,
		 13124, 0, 0, 0, 0, 24443, 13538, 12743, 12854, 13861, 14858, 
		14443, 14739, 15239, 15849, 16065, 15375, 14277, 12974, 12063,
		 11547, 11631, 12722, 13922, 15227, 23678, 12223, 25178, 
		13723, 21859, 15859, 21440, 15340, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
		0, 0, 0, 25576, 13376, 12573, 12167, 12059, 12254, 12852, 
		14452, 15050, 15345, 15237, 14731, 13928, 11728, 23116, 14188,
		 0, 0, 0, 0, 21116, 16188, 22888, 12484, 12479, 12875, 13375, 
		13779, 13784, 13388, 12888, 24616, 15020, 15025, 14629, 14129,
		 13725, 13720, 14116, 14616, 25436, 14623, 13918, 13216, 
		12316, 11521, 11229, 11437, 12146, 14056, 14764, 14872, 14777,
		 14280, 13680, 13077, 12669, 12858, 15116, 0, 23696, 13608, 0,
		 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 26092, 
		15282, 14665, 14350, 14235, 14418, 14808, 24515, 14430, 14650,
		 15072, 15485, 0, 0, 0, 0, 0, 0, 0, 0, 23492, 13882, 14065, 
		13950, 13635, 13018, 12208, 23784, 13870, 13650, 13229, 12816,
		 0, 0, 0, 0, 0, 0, 0, 0, 25794, 14494, 13306, 14606, 24694, 
		13506, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 22794, 14094,
		 12906, 11606, 23894, 12706, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
		0, 0, 0, 25696, 14490, 13853, 12750, 13746, 13310, 14304, 
		23509, 13945, 13746, 24691, 14054, 13853, 0, 0, 0, 0, 0, 0, 0,
		 23096, 14090, 13453, 14450, 13346, 12910, 11804, 22709, 
		13145, 13346, 23890, 13254, 13453, 0, 0, 0, 0, 0, 0, 0, 25866,
		 11548, 15330, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
		 0, 21866, 15548, 11330, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
		0, 0, 0, 0, 0, 20600, 17000, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
		0, 0, 0, 0, 0, 0, 0, 21648, 15648, 23668, 13628, 0, 0, 0, 0, 
		0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 21648, 15648, 0, 0, 0, 0, 
		0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 22265, 14031, 22231,
		 14065, 21248, 15048, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
		0, 21656, 15656, 21640, 15640, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
		0, 0, 0, 0, 0, 0, 20608, 16696, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
		0, 0, 0, 0, 0, 0, 0, 0, 21634, 15634, 21648, 15648, 21662, 
		15662, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 21636, 15636,
		 21653, 12059, 12862, 13459, 13854, 14452, 15255, 15661, 0, 0,
		 0, 0, 0, 0, 0, 0, 0, 0 };


    /* System generated locals */
    int i__1;

    /* Builtin functions */
    double sin(doublereal), cos(doublereal);
    int i_len(char *, ftnlen), i_indx(char *, char *, ftnlen, ftnlen);

    /* Local variables */
    static int i__, j, k;
    static real x, y, x0, y0;
    static int ic, kc;
    static real fi, fj, xx, yy;
    static int ncc;
#define node ((int *)&equiv_9)
    static real cosa, sina, xchr, ychr;
#define node0 ((int *)&equiv_9)
#define node1 ((int *)&equiv_9 + 200)
#define node2 ((int *)&equiv_9 + 400)
#define node3 ((int *)&equiv_9 + 600)
#define node4 ((int *)&equiv_9 + 800)
#define node5 ((int *)&equiv_9 + 1000)
#define node6 ((int *)&equiv_9 + 1200)
#define node7 ((int *)&equiv_9 + 1400)
#define node8 ((int *)&equiv_9 + 1600)
#define node9 ((int *)&equiv_9 + 1800)
    extern /* Subroutine */ int getlastxyabs_(real *, real *);
    static int nodeb, lmask, istat;
    extern /* Subroutine */ int getpat_(int *), newpat_(int *), 
	    plotabs_(real *, real *, int *);

/* ---------------------------------------------------------------- */
/*     Plots character string with slanted character font */

/*      XC,YC  = absolute coordinate position for first character in string */
/*               if XC=999. the last x plotting position is used */
/*               if YC=999. the last y plotting position is used */
/*      CHX    = character width in x (absolute coordinate length) */
/*      STRING = character string to plot with nc characters */
/*      ANGLE  = angle of character (radians, positive is righthanded rotation) */
/*      nc     = number of characters to plot */
/*               if nc<0 the length of the string is determined automatically */

/*     Character plotting uses the vector font database NODE(..) */
/*     Each NODE(..) value has the form  sxxyy */

/*        xx   = location of polyline point   0 ... 96 */
/*        yy       (origin assumed to be at 16,16) */
/*        s    = 2  if point is the start of a new polyline stroke */
/*             = 1  if point is inside or at the end of stroke */
/*             = 0  if point is not valid */

/*        CALLS:  GETLASTXYABS, GETPAT, NEWPAT, PLOTABS */
/* ---------------------------------------------------------------- */


/*     Version 4.46 11/28/01 */

    sina = sin(*angle * pi / 180.f);
    cosa = cos(*angle * pi / 180.f);

    xx = *xc;
    yy = *yc;
/* ---- if XC=999. or YC=999. get last x,y character plotting position */
    if (*xc == 999.f || *yc == 999.f) {
	getlastxyabs_(&xchr, &ychr);
	if (*xc == 999.f) {
	    xx = xchr;
	}
	if (*yc == 999.f) {
	    yy = ychr;
	}
    }

/* ---- get the old line pattern, only plot characters & symbols with solid lines */
    getpat_(&lmask);
    if (lmask != -1) {
	newpat_(&c_n1);
    }

/* ---- if number of characters */
    ncc = *nc;
    if (ncc < 0) {
	ncc = i_len(string, string_len);
    }
    if (ncc == 0) {
	return 0;
    }

/* ---- go over each character... */
    i__1 = ncc;
    for (ic = 1; ic <= i__1; ++ic) {

/* ------ set character origin location */
	x0 = xx + *chx * (real) (ic - 1) * cosa;
	y0 = yy + *chx * (real) (ic - 1) * sina;

	kc = i_indx(chars, string + (ic - 1), (ftnlen)92, (ftnlen)1);

	if (kc != 0) {

/* -------- decode and plot each node */
	    for (k = 1; k <= 20; ++k) {

/* ---------- strip off leading point-status digit */
		istat = node[k + kc * 20 - 21] / 10000;
		nodeb = node[k + kc * 20 - 21] - istat * 10000;

/* ---------- decode x and y location coordinates */
		i__ = nodeb / 100;
		j = nodeb - i__ * 100;

		fi = (real) (i__ - 16) / 64.f;
		fj = (real) (j - 16) / 64.f;

		x = x0 + *chx * (fi * cosa - fj * sina);
		y = y0 + *chx * (fi * sina + fj * cosa);

		if (istat == 0) {
		    goto L12;
		} else if (istat == 1) {
		    plotabs_(&x, &y, &c__2);
		} else {
		    plotabs_(&x, &y, &c__3);
		}

	    }
	}

L12:
	;
    }

/* ---- move to bottom right corner x,y for next call with x,y = 999.,999. */
    x0 = xx + *chx * (real) ncc * cosa;
    y0 = yy + *chx * (real) ncc * sina;
    plotabs_(&x0, &y0, &c__3);

/* ---- restore line pattern */
    if (lmask != -1) {
	newpat_(&lmask);
    }

    return 0;
} /* plslanabs_ */

#undef node9
#undef node8
#undef node7
#undef node6
#undef node5
#undef node4
#undef node3
#undef node2
#undef node1
#undef node0
#undef node


/* Subroutine */ int plmathabs_(real *xc, real *yc, real *chx, char *string, 
	real *angle, int *nc, ftnlen string_len)
{
    /* Initialized data */

    static char chars[92] = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstu"
	    "vwxyz0123456789,.;:`\"!?@#$%&|()[]{}<>_+-*=/^~";
    static real pi = 3.1415926535897932384f;
    static struct {
	int e_1[1840];
	} equiv_9 = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
		 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
		0, 21688, 12488, 25288, 16088, 21616, 12416, 25216, 16016, 
		22016, 15688, 21988, 15516, 22188, 15716, 0, 0, 0, 0, 0, 0, 
		21216, 13988, 16416, 11216, 21318, 16118, 13884, 0, 0, 0, 0, 
		0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
		 0, 0, 0, 0, 0, 0, 0, 0, 22816, 14816, 22888, 14888, 23788, 
		13716, 23988, 13916, 22575, 11461, 11443, 12529, 15129, 16243,
		 16261, 15175, 12575, 0, 0, 0, 25888, 16180, 16188, 11688, 
		22288, 12216, 22488, 12416, 21616, 13016, 0, 0, 0, 0, 0, 0, 0,
		 0, 0, 0, 20490, 11096, 11064, 21964, 13196, 23890, 14396, 
		15296, 15691, 15684, 13871, 13864, 15664, 0, 0, 0, 0, 0, 0, 0,
		 26694, 16696, 16396, 16191, 15982, 15346, 15014, 14805, 
		14600, 14300, 14302, 25014, 15754, 15982, 0, 0, 0, 0, 0, 0, 
		26396, 16196, 15891, 15573, 14923, 14605, 14300, 14100, 24956,
		 14552, 14544, 14940, 15540, 15944, 15952, 15556, 14956, 0, 0,
		 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
		0, 21516, 12616, 24916, 16116, 21816, 13888, 15816, 25616, 
		13784, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 22890, 13396, 13362, 
		22962, 13762, 20479, 12079, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
		0, 0, 24416, 16769, 12169, 14416, 26565, 12565, 14518, 0, 0, 
		0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 21616, 14067, 16416, 11616, 
		0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 22416, 13216, 
		24416, 15216, 22716, 12788, 22916, 12988, 24716, 14788, 24916,
		 14988, 21888, 11683, 11688, 16088, 16083, 15888, 0, 0, 22716,
		 14816, 15933, 15971, 14888, 12888, 11771, 11733, 12716, 
		23052, 14652, 23056, 13048, 24656, 14648, 21973, 11931, 25773,
		 15731, 0, 23058, 13658, 14507, 16196, 17296, 23658, 13858, 
		14613, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 25616, 16125, 
		16016, 11616, 14654, 12088, 21688, 15988, 16179, 21688, 14452,
		 0, 0, 0, 0, 0, 0, 0, 0, 0, 21347, 11755, 12255, 12451, 12235,
		 12422, 12916, 13816, 14522, 15134, 15552, 15670, 15582, 
		14888, 13988, 13484, 13277, 13468, 14362, 16153, 23016, 14616,
		 21674, 11984, 12588, 13184, 13766, 13716, 26074, 15784, 
		15188, 14584, 13966, 13916, 23184, 13966, 24584, 13766, 0, 0, 
		22124, 13642, 14456, 14870, 14983, 14888, 14688, 14486, 14080,
		 13670, 13253, 12935, 12924, 13118, 13516, 14216, 15019, 
		15926, 0, 0, 21522, 11716, 13016, 11548, 11567, 12283, 13188, 
		14588, 15483, 16167, 16148, 14616, 15916, 16122, 21976, 11758,
		 11940, 25776, 15958, 15740, 21626, 11716, 15916, 16026, 
		21678, 11788, 15988, 16078, 22660, 12644, 25060, 15044, 22654,
		 15054, 22650, 15050, 21720, 15920, 21784, 15984, 23088, 
		14688, 23016, 14616, 23788, 13716, 23988, 13916, 21474, 11769,
		 11842, 13029, 14629, 15842, 15969, 16274, 21769, 12040, 
		25969, 15640, 22088, 11680, 11688, 16088, 11816, 16016, 16025,
		 15616, 21816, 11616, 15888, 0, 0, 0, 0, 0, 0, 0, 0, 0, 26064,
		 15554, 14937, 14323, 13617, 12916, 12217, 11722, 11534, 
		11746, 12256, 12962, 13564, 14064, 14460, 14750, 14737, 14919,
		 15416, 16120, 21508, 12655, 13276, 13986, 14688, 15287, 
		15682, 15671, 15161, 14256, 12757, 24256, 15449, 15837, 15626,
		 14918, 13816, 13016, 11820, 0, 21504, 15866, 25504, 15104, 
		14709, 14317, 13349, 12662, 12266, 11866, 0, 0, 0, 0, 0, 0, 0,
		 0, 0, 0, 25184, 14987, 14588, 13888, 13485, 13177, 13267, 
		13861, 14857, 15345, 15233, 14722, 13716, 12816, 11922, 11734,
		 12150, 12857, 13861, 0, 25559, 14664, 13764, 12760, 12052, 
		11739, 11729, 12220, 13116, 14116, 15220, 21842, 14142, 0, 0, 
		0, 0, 0, 0, 0, 21645, 12057, 12863, 13864, 14962, 15556, 
		15744, 15332, 14427, 13326, 12427, 11733, 11645, 23004, 14388,
		 0, 0, 0, 0, 0, 21557, 12164, 12867, 13662, 14246, 14325, 
		14113, 13804, 13500, 13305, 13416, 13932, 14950, 16063, 0, 0, 
		0, 0, 0, 0, 21759, 11962, 12264, 12563, 12661, 12755, 11916, 
		22755, 13360, 14164, 14864, 15361, 15556, 15546, 14804, 0, 0, 
		0, 0, 0, 23164, 12424, 12618, 13016, 14116, 15018, 15724, 0, 
		0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 22666, 12060, 11751, 
		11740, 12232, 13329, 14329, 15333, 15841, 16049, 15958, 15662,
		 15064, 14564, 14160, 13747, 13004, 0, 0, 0, 22464, 11616, 
		25764, 15264, 14862, 13448, 12037, 22843, 13924, 14218, 14616,
		 15116, 0, 0, 0, 0, 0, 0, 0, 0, 22788, 13288, 13685, 14074, 
		14627, 15018, 15316, 15716, 21316, 14256, 0, 0, 0, 0, 0, 0, 0,
		 0, 0, 0, 22764, 11600, 22130, 12122, 12517, 12916, 13716, 
		14418, 14922, 15664, 24922, 15017, 15316, 15616, 0, 0, 0, 0, 
		0, 0, 22064, 12364, 12562, 12645, 12631, 12416, 13825, 15037, 
		15753, 15759, 15662, 15564, 15264, 0, 0, 0, 0, 0, 0, 0, 21641,
		 12052, 12962, 13964, 15062, 15651, 15641, 15428, 14418, 
		13316, 12119, 11628, 11641, 0, 0, 0, 0, 0, 0, 0, 21559, 11963,
		 12566, 15966, 23266, 12216, 24766, 14444, 14430, 14716, 0, 0,
		 0, 0, 0, 0, 0, 0, 0, 0, 25554, 12154, 12469, 12779, 13285, 
		13988, 14788, 15285, 15579, 15669, 15554, 15236, 14824, 14319,
		 13816, 13016, 12519, 12224, 12036, 12154, 21500, 12244, 
		12655, 13161, 13864, 14764, 15460, 15752, 15640, 15330, 14223,
		 13022, 11923, 0, 0, 0, 0, 0, 0, 0, 26264, 13964, 12962, 
		12052, 11641, 11628, 12119, 13316, 14418, 15428, 15641, 15551,
		 14961, 13763, 0, 0, 0, 0, 0, 0, 21655, 12061, 12764, 15964, 
		23864, 13016, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 21958,
		 12162, 12464, 12663, 12658, 12239, 12224, 12716, 13716, 
		14521, 15333, 15645, 15657, 15463, 15164, 0, 0, 0, 0, 0, 
		25660, 14964, 14264, 13464, 12761, 12254, 12147, 12542, 11936,
		 11728, 12020, 12816, 13816, 14618, 15321, 22542, 14042, 0, 0,
		 0, 22764, 12056, 11645, 11432, 11621, 12116, 12716, 13320, 
		13816, 14416, 15120, 15731, 15942, 15953, 15564, 23320, 13740,
		 0, 0, 0, 25386, 14086, 12977, 12765, 13357, 14457, 23357, 
		12044, 11733, 12023, 13317, 15016, 15213, 14810, 24086, 13392,
		 0, 0, 0, 0, 21865, 12163, 12357, 11947, 11736, 12025, 12822, 
		14222, 15228, 15938, 16051, 15865, 23004, 14388, 0, 0, 0, 0, 
		0, 0, 25482, 14482, 13473, 12560, 11942, 11931, 12422, 13617, 
		15016, 15314, 14809, 23990, 14482, 0, 0, 0, 0, 0, 0, 0, 21272,
		 11864, 13064, 13672, 13688, 13096, 11896, 11288, 11272, 0, 0,
		 0, 0, 0, 0, 0, 0, 0, 0, 0, 21687, 12496, 12460, 21660, 13260,
		 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 21290, 11896, 
		13196, 13690, 13683, 11268, 11260, 13660, 0, 0, 0, 0, 0, 0, 0,
		 0, 0, 0, 0, 0, 21391, 11896, 13196, 13691, 13684, 13179, 
		12079, 23179, 13674, 13666, 13060, 11860, 11266, 0, 0, 0, 0, 
		0, 0, 0, 21296, 11271, 13771, 23296, 13260, 22860, 13560, 0, 
		0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 23696, 11296, 11280, 
		13180, 13675, 13666, 13060, 11860, 11266, 0, 0, 0, 0, 0, 0, 0,
		 0, 0, 0, 0, 23691, 13196, 11896, 11290, 11266, 11860, 13060, 
		13666, 13675, 13279, 11679, 11275, 0, 0, 0, 0, 0, 0, 0, 0, 
		21296, 13696, 13692, 12268, 12260, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
		0, 0, 0, 0, 0, 0, 21779, 11284, 11291, 11796, 13196, 13691, 
		13684, 13179, 13675, 13665, 13060, 11860, 11265, 11275, 11779,
		 13179, 0, 0, 0, 0, 23682, 13177, 11777, 11282, 11290, 11896, 
		13096, 13690, 13666, 13060, 11860, 11266, 0, 0, 0, 0, 0, 0, 0,
		 0, 22604, 13215, 12616, 12624, 13424, 13416, 12604, 0, 0, 0, 
		0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 22624, 12616, 13416, 13424, 
		12624, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
		0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 21620, 
		11616, 12016, 12020, 11620, 23820, 13816, 14216, 14220, 13820,
		 26020, 16016, 16416, 16420, 16020, 0, 0, 0, 0, 0, 21466, 
		11890, 12590, 11466, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
		 0, 0, 22696, 13496, 14092, 14486, 14478, 14072, 13468, 12668,
		 12072, 11678, 11686, 12092, 12696, 0, 0, 0, 0, 0, 0, 0, 
		23130, 12822, 13622, 13530, 13130, 23441, 13588, 14488, 13441,
		 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
		0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
		 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 22064, 15232, 22032, 15264, 0, 
		0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 23775, 14380, 
		15480, 16075, 16365, 16242, 15826, 15016, 13716, 13021, 12834,
		 13245, 14153, 15053, 16249, 0, 0, 0, 0, 0, 21648, 15648, 
		23464, 13460, 13860, 13864, 13464, 23436, 13432, 13832, 13836,
		 13436, 0, 0, 0, 0, 0, 0, 0, 0, 22001, 11201, 10708, 10716, 
		11223, 12023, 13601, 14401, 14908, 14916, 14423, 13623, 12001,
		 0, 0, 0, 0, 0, 0, 0, 23696, 13608, 0, 0, 0, 0, 0, 0, 0, 0, 0,
		 0, 0, 0, 0, 0, 0, 0, 0, 0, 24872, 14159, 13941, 14121, 14808,
		 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 22472, 13159, 
		13340, 13121, 12408, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
		 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
		0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
		 24266, 11648, 14230, 26066, 13448, 16030, 0, 0, 0, 0, 0, 0, 
		0, 0, 0, 0, 0, 0, 0, 0, 21666, 14248, 11630, 23466, 16048, 
		13430, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 27280, 14016,
		 17216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
		22282, 15482, 24882, 14786, 15882, 14578, 14882, 0, 0, 0, 0, 
		0, 0, 0, 0, 0, 0, 0, 0, 0, 20896, 17296, 0, 0, 0, 0, 0, 0, 0, 
		0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 23668, 13628, 21648, 15648, 
		0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 21648, 15648, 
		0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 23146, 
		13150, 13453, 13853, 14150, 14146, 13843, 13443, 13146, 23450,
		 13846, 23850, 13446, 0, 0, 0, 0, 0, 0, 0, 21656, 15656, 
		21640, 15640, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
		21208, 16096, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
		0, 0, 22480, 14088, 15680, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
		 0, 0, 0, 0, 0, 22480, 12985, 13685, 14479, 15179, 15684, 0, 
		0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };


    /* System generated locals */
    int i__1;

    /* Builtin functions */
    double sin(doublereal), cos(doublereal);
    int i_len(char *, ftnlen), i_indx(char *, char *, ftnlen, ftnlen);

    /* Local variables */
    static int i__, j, k;
    static real x, y, x0, y0;
    static int ic, kc;
    static real fi, fj, xx, yy;
    static int ncc;
#define node ((int *)&equiv_9)
    static real cosa, sina, xchr, ychr;
#define node0 ((int *)&equiv_9)
#define node1 ((int *)&equiv_9 + 200)
#define node2 ((int *)&equiv_9 + 400)
#define node3 ((int *)&equiv_9 + 600)
#define node4 ((int *)&equiv_9 + 800)
#define node5 ((int *)&equiv_9 + 1000)
#define node6 ((int *)&equiv_9 + 1200)
#define node7 ((int *)&equiv_9 + 1400)
#define node8 ((int *)&equiv_9 + 1600)
#define node9 ((int *)&equiv_9 + 1800)
    extern /* Subroutine */ int getlastxyabs_(real *, real *);
    static int nodeb, lmask, istat;
    extern /* Subroutine */ int getpat_(int *), newpat_(int *), 
	    plotabs_(real *, real *, int *);

/* ---------------------------------------------------------------- */
/*     Plots character string with math character font */

/*      XC,YC  = absolute coordinate position for first character in string */
/*               if XC=999. the last x plotting position is used */
/*               if YC=999. the last y plotting position is used */
/*      CHX    = character width in x (absolute coordinate length) */
/*      STRING = character string to plot with nc characters */
/*      ANGLE  = angle of character (radians, positive is righthanded rotation) */
/*      nc     = number of characters to plot */
/*               if nc<0 the length of the string is determined automatically */

/*     Character plotting uses the vector font database NODE(..) */
/*     Each NODE(..) value has the form  sxxyy */

/*        xx   = location of polyline point   0 ... 96 */
/*        yy       (origin assumed to be at 16,16) */
/*        s    = 2  if point is the start of a new polyline stroke */
/*             = 1  if point is inside or at the end of stroke */
/*             = 0  if point is not valid */

/*        CALLS:  GETLASTXYABS, GETPAT, NEWPAT, PLOTABS */
/* ---------------------------------------------------------------- */


/*     Version 4.46 11/28/01 */

    sina = sin(*angle * pi / 180.f);
    cosa = cos(*angle * pi / 180.f);

    xx = *xc;
    yy = *yc;
/* ---- if XC=999. or YC=999. get last x,y character plotting position */
    if (*xc == 999.f || *yc == 999.f) {
	getlastxyabs_(&xchr, &ychr);
	if (*xc == 999.f) {
	    xx = xchr;
	}
	if (*yc == 999.f) {
	    yy = ychr;
	}
    }

/* ---- get the old line pattern, only plot characters & symbols with solid lines */
    getpat_(&lmask);
    if (lmask != -1) {
	newpat_(&c_n1);
    }

/* ---- if number of characters */
    ncc = *nc;
    if (ncc < 0) {
	ncc = i_len(string, string_len);
    }
    if (ncc == 0) {
	return 0;
    }

/* ---- go over each character... */
    i__1 = ncc;
    for (ic = 1; ic <= i__1; ++ic) {

/* ------ set character origin location */
	x0 = xx + *chx * (real) (ic - 1) * cosa;
	y0 = yy + *chx * (real) (ic - 1) * sina;

	kc = i_indx(chars, string + (ic - 1), (ftnlen)92, (ftnlen)1);

	if (kc != 0) {

/* -------- decode and plot each node */
	    for (k = 1; k <= 20; ++k) {

/* ---------- strip off leading point-status digit */
		istat = node[k + kc * 20 - 21] / 10000;
		nodeb = node[k + kc * 20 - 21] - istat * 10000;

/* ---------- decode x and y location coordinates */
		i__ = nodeb / 100;
		j = nodeb - i__ * 100;

		fi = (real) (i__ - 16) / 64.f;
		fj = (real) (j - 16) / 64.f;

		x = x0 + *chx * (fi * cosa - fj * sina);
		y = y0 + *chx * (fi * sina + fj * cosa);

		if (istat == 0) {
		    goto L12;
		} else if (istat == 1) {
		    plotabs_(&x, &y, &c__2);
		} else {
		    plotabs_(&x, &y, &c__3);
		}

	    }
	}

L12:
	;
    }

/* ---- move to bottom right corner x,y for next call with x,y = 999.,999. */
    x0 = xx + *chx * (real) ncc * cosa;
    y0 = yy + *chx * (real) ncc * sina;
    plotabs_(&x0, &y0, &c__3);

/* ---- restore line pattern */
    if (lmask != -1) {
	newpat_(&lmask);
    }

    return 0;
} /* plmathabs_ */

#undef node9
#undef node8
#undef node7
#undef node6
#undef node5
#undef node4
#undef node3
#undef node2
#undef node1
#undef node0
#undef node


/* Subroutine */ int plsymbabs_(real *xc, real *yc, real *chx, int *isym, 
	real *angle, int *nc)
{
    /* Initialized data */

    static int nchars = 14;
    static real pi = 3.1415926535897932384f;
    static struct {
	int e_1[280];
	} equiv_1 = { 24848, 14880, 18080, 18016, 11616, 11680, 14880, 0, 0, 
		0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 24848, 14880, 16480, 18064, 
		18032, 16416, 13216, 11632, 11664, 13280, 14880, 0, 0, 0, 0, 
		0, 0, 0, 0, 0, 24848, 14886, 18128, 11528, 14886, 0, 0, 0, 0, 
		0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 24885, 14811, 21148, 18548, 
		0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 22175, 17521, 
		22121, 17575, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
		24848, 14882, 18248, 14814, 11448, 14882, 0, 0, 0, 0, 0, 0, 0,
		 0, 0, 0, 0, 0, 0, 0, 24848, 14868, 18168, 14810, 11568, 
		14868, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 21669, 14848,
		 14810, 24848, 18069, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
		0, 0, 24886, 14848, 11627, 24848, 18027, 0, 0, 0, 0, 0, 0, 0, 
		0, 0, 0, 0, 0, 0, 0, 0, 23078, 16618, 23018, 16678, 21448, 
		18248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 21866, 17830,
		 21830, 17866, 24882, 14814, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
		0, 0, 0, 21680, 18016, 11616, 18080, 11680, 0, 0, 0, 0, 0, 0, 
		0, 0, 0, 0, 0, 0, 0, 0, 0, 21616, 18080, 18016, 11680, 11616, 
		0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 24848, 14859, 
		11559, 16917, 14884, 12717, 18159, 14859, 0, 0, 0, 0, 0, 0, 0,
		 0, 0, 0, 0, 0 };


    /* Builtin functions */
    double sin(doublereal), cos(doublereal);

    /* Local variables */
    static int i__, j, k;
    static real x, y, x0, y0;
    static int kc;
    static real fi, fj, xx, yy;
#define node ((int *)&equiv_1)
    static real cosa, sina, xchr, ychr;
#define node0 ((int *)&equiv_1)
#define node1 ((int *)&equiv_1 + 200)
    extern /* Subroutine */ int getlastxyabs_(real *, real *);
    static int nodeb, lmask, istat;
    extern /* Subroutine */ int getpat_(int *), newpat_(int *), 
	    plotabs_(real *, real *, int *);

/* ---------------------------------------------------------------- */
/*     Plots a symbol with symbol font indexed by int */

/*      XC,YC  = absolute coordinate position for plotting symbol */
/*               if XC=999. the last x plotting position is used */
/*               if YC=999. the last y plotting position is used */
/*      CHX    = symbol width in x (absolute coordinate length) */
/*      ISYM   = int to select symbol (0..?) */
/*      ANGLE  = angle for symbol (radians, positive is righthanded rotation) */
/*      nc     = 0  just move to x,y before plotting symbol */
/*           .ne.0  draw line to x,y before plotting symbol */

/*     Plots a symbol using vector font database NODE(..) */
/*     Each NODE(..) value has the form  sxxyy */

/*        xx   = location of polyline point   0 ... 96 */
/*        yy       (origin assumed to be at 48,48) */
/*        s    = 2  if point is the start of a new polyline stroke */
/*             = 1  if point is inside or at the end of stroke */
/*             = 0  if point is not valid */

/*        CALLS:  GETLASTXYABS, GETPAT, NEWPAT, PLOTABS */
/* ---------------------------------------------------------------- */


/*     Version 4.46 11/28/01 */

    sina = sin(*angle * pi / 180.f);
    cosa = cos(*angle * pi / 180.f);

    xx = *xc;
    yy = *yc;
/* ---- if XC=999. or YC=999. get last x,y character plotting position */
    if (*xc == 999.f || *yc == 999.f) {
	getlastxyabs_(&xchr, &ychr);
	if (*xc == 999.f) {
	    xx = xchr;
	}
	if (*yc == 999.f) {
	    yy = ychr;
	}
    }

/* ------ set character origin location */
    x0 = xx;
    y0 = yy;
/* ------ draw to X0,Y0 first ? */
    if (*nc != 0) {
	plotabs_(&x0, &y0, &c__2);
    }

/* ---- get the old line pattern, only plot characters & symbols with solid lines */
    getpat_(&lmask);
    if (lmask != -1) {
	newpat_(&c_n1);
    }


/* ---Plot symbol index modulo symbol count (NCHARS defined symbols) */
/* cc      KC = ISYM + 1 */
    kc = *isym % nchars + 1;

    if (kc >= 1 && kc <= nchars) {

/* -------- decode and plot each node */
	for (k = 1; k <= 20; ++k) {

/* ---------- strip off leading point-status digit */
	    istat = node[k + kc * 20 - 21] / 10000;
	    nodeb = node[k + kc * 20 - 21] - istat * 10000;

/* ---------- decode x and y location coordinates */
	    i__ = nodeb / 100;
	    j = nodeb - i__ * 100;

	    fi = (real) (i__ - 48) / 64.f;
	    fj = (real) (j - 48) / 64.f;

	    x = x0 + *chx * (fi * cosa - fj * sina);
	    y = y0 + *chx * (fi * sina + fj * cosa);

	    if (istat == 0) {
		goto L12;
	    } else if (istat == 1) {
		plotabs_(&x, &y, &c__2);
	    } else {
		plotabs_(&x, &y, &c__3);
	    }

	}
    }

L12:

/* ---- move to origin x,y for next call with x,y = 999.,999. */
    plotabs_(&x0, &y0, &c__3);

/* ---- restore line pattern */
    if (lmask != -1) {
	newpat_(&lmask);
    }

    return 0;
} /* plsymbabs_ */

#undef node1
#undef node0
#undef node
