/* f/plt_util.f -- translated by f2c (version 20100827).
   You must link the resulting object file with libf2c:
	on Microsoft Windows system, link with libf2c.lib;
	on Linux or Unix systems, link with .../path/to/libf2c.a -lm
	or, if you install libf2c.a in a standard place, with -lf2c -lm
	-- in that order, at the end of the command line, as in
		cc *.o -lf2c -lm
	Source for libf2c is in /netlib/f2c/libf2c.zip, e.g.,

		http://www.netlib.org/f2c/libf2c.zip
*/

#include "f2c.h"

/* Table of constant values */

static int c__10 = 10;
static int c__3 = 3;
static int c__2 = 2;
static real c_b12 = 10.f;
static real c_b13 = 0.f;
static int c__0 = 0;
static doublereal c_b62 = 10.;
static int c__1 = 1;
static int c__9 = 9;
static int c__4 = 4;

/* *********************************************************************** */
/*    Module:  plt_util.f */

/*    Copyright (C) 1996 Harold Youngren, Mark Drela */

/*    This library is free software; you can redistribute it and/or */
/*    modify it under the terms of the GNU Library General Public */
/*    License as published by the Free Software Foundation; either */
/*    version 2 of the License, or (at your option) any later version. */

/*    This library is distributed in the hope that it will be useful, */
/*    but WITHOUT ANY WARRANTY; without even the implied warranty of */
/*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU */
/*    Library General Public License for more details. */

/*    You should have received a copy of the GNU Library General Public */
/*    License along with this library; if not, write to the Free */
/*    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

/*    Report problems to:    guppy@maine.com */
/*                        or drela@mit.edu */
/* *********************************************************************** */

/* ********************************************************************** */
/* --- Xplot11 utility routines */

/*     Version 4.46 11/28/01 */

/*     Note:  These are additional routines that supply additional plot */
/*            functionality.  Included are routines for axis scaling, */
/*            axis plotting, line or curve plotting, contours, etc. */
/* *********************************************************************** */
/* Subroutine */ int xaxis_(real *x1, real *y1, real *xaxt, real *dxann, real 
	*fann, real *dann, real *cht, int *ndig)
{
    /* System generated locals */
    int i__1, i__2;
    real r__1;

    /* Builtin functions */
    double r_lg10(real *);
    int pow_ii(int *, int *);
    double r_int(real *), pow_ri(real *, int *);

    /* Local variables */
    static real ch;
    static int nd;
    static real rn;
    static int nt;
    static real xt;
    extern /* Subroutine */ int getfactors_(real *, real *);
    static real chx, chy, grn, xax;
    static int nabc;
    static real xfac, yfac;
    extern /* Subroutine */ int plot_(real *, real *, int *);
    static real xnum, ynum, adann, width;
    extern /* Subroutine */ int plnumb_(real *, real *, real *, real *, real *
	    , int *);

/* ....................................................... */

/*     X1,Y1  starting point of x axis */
/*     XAXT   length of x axis   ( - = suppress zero annotation) */
/*     DXANN  distance between annotations */
/*     FANN   first annotation value */
/*     DANN   delta annotation value */
/*     CHT    character width   ( - = annotation above axis) */
/*     NDIG   number of digits to right of decimal point */
/*            = -1   no decimal point */
/*            = -2   number of digits determined internally */
/*           <= -3   no axis annotation (just hash marks) */
/* ....................................................... */

    xax = dabs(*xaxt);
    ch = dabs(*cht);

    if (*ndig <= -2) {
	adann = dabs(*dann);
/* Computing MAX */
	i__1 = 1, i__2 = (integer) (-r_lg10(&adann));
	nd = max(i__1,i__2);
	r__1 = adann * pow_ii(&c__10, &nd) + .01f;
	if (adann * pow_ii(&c__10, &nd) - r_int(&r__1) > .01f) {
	    ++nd;
	}
	r__1 = adann * pow_ii(&c__10, &nd) + .01f;
	if (adann * pow_ii(&c__10, &nd) - r_int(&r__1) > .01f) {
	    ++nd;
	}
    } else {
	nd = *ndig;
    }

    getfactors_(&xfac, &yfac);
    chx = ch;
    chy = ch * xfac / yfac;

/* ---- x-axis */
    plot_(x1, y1, &c__3);
    r__1 = *x1 + xax;
    plot_(&r__1, y1, &c__2);

/* ---- annotate x-axis */
    for (nt = 1; nt <= 12345; ++nt) {
	xt = *x1 + *dxann * (real) (nt - 1);
	if (xt - *x1 > xax + *dxann * .5f) {
	    goto L11;
	}
/* ---- hash marks */
	r__1 = *y1 - chy * .2f;
	plot_(&xt, &r__1, &c__3);
	r__1 = *y1 + chy * .2f;
	plot_(&xt, &r__1, &c__2);
/* ---- Numeric annotations */
	if (*ndig <= -3) {
	    goto L10;
	}
	rn = *fann + *dann * (real) (nt - 1);
	if (dabs(rn) < 1e-5f && *xaxt < 0.f) {
	    goto L10;
	}
	grn = 0.f;
	if (rn != 0.f) {
	    i__1 = max(0,nd);
	    r__1 = dabs(rn) + .5f / pow_ri(&c_b12, &i__1);
	    grn = r_lg10(&r__1);
	}
	grn = dmax(grn,0.f);
	nabc = (integer) grn + 2 + nd;
	width = chx * (real) nabc;
	if (rn < 0.f) {
	    width += chx;
	}
	xnum = xt - width * .5f + chx * .1f;
	ynum = *y1 - chy * 2.1f;
	if (*cht < 0.f) {
	    ynum = *y1 + chy * .9f;
	}
	plnumb_(&xnum, &ynum, &ch, &rn, &c_b13, &nd);
L10:
	;
    }
L11:

    return 0;
} /* xaxis_ */

/* Subroutine */ int yaxis_(real *x1, real *y1, real *yaxt, real *dyann, real 
	*fann, real *dann, real *cht, int *ndig)
{
    /* System generated locals */
    int i__1, i__2;
    real r__1;

    /* Builtin functions */
    double r_lg10(real *);
    int pow_ii(int *, int *);
    double r_int(real *), pow_ri(real *, int *);

    /* Local variables */
    static real ch;
    static int nd;
    static real rn;
    static int nt;
    static real xt, yt;
    extern /* Subroutine */ int getfactors_(real *, real *);
    static real chx, chy, grn, yax;
    static int nabc;
    static real xfac, yfac;
    extern /* Subroutine */ int plot_(real *, real *, int *);
    static real adann, width;
    extern /* Subroutine */ int plnumb_(real *, real *, real *, real *, real *
	    , int *);

/* ....................................................... */

/*     X1,Y1  starting point of y axis */
/*     YAXT   length of y axis   ( - = suppress zero annotation) */
/*     DYANN  distance between annotations */
/*     FANN   first annotation value */
/*     DANN   delta annotation value */
/*     CHT    character width   ( - = annotation on right side ) */
/*     NDIG   number of digits to right of decimal point */
/*            = -1   no decimal point */
/*            = -2   number of digits determined internally */
/*           <= -3   no axis annotation (just hash marks) */
/* ....................................................... */

    yax = dabs(*yaxt);
    ch = dabs(*cht);

    if (*ndig <= -2) {
	adann = dabs(*dann);
/* Computing MAX */
	i__1 = 1, i__2 = (integer) (-r_lg10(&adann));
	nd = max(i__1,i__2);
	r__1 = adann * pow_ii(&c__10, &nd) + .01f;
	if (adann * pow_ii(&c__10, &nd) - r_int(&r__1) > .01f) {
	    ++nd;
	}
	r__1 = adann * pow_ii(&c__10, &nd) + .01f;
	if (adann * pow_ii(&c__10, &nd) - r_int(&r__1) > .01f) {
	    ++nd;
	}
    } else {
	nd = *ndig;
    }

    getfactors_(&xfac, &yfac);
    chx = ch;
    chy = ch * xfac / yfac;

/* ---- y-axis */
    plot_(x1, y1, &c__3);
    r__1 = *y1 + yax;
    plot_(x1, &r__1, &c__2);

/* ---- annotate y-axis */
    for (nt = 1; nt <= 12345; ++nt) {
	yt = *y1 + *dyann * (real) (nt - 1);
	if (yt - *y1 > yax + *dyann * .5f) {
	    goto L11;
	}
/* ---- hash marks */
	r__1 = *x1 - chx * .2f;
	plot_(&r__1, &yt, &c__3);
	r__1 = *x1 + chx * .2f;
	plot_(&r__1, &yt, &c__2);
/* ---- Numeric annotations */
	if (*ndig <= -3) {
	    goto L10;
	}
	rn = *fann + *dann * (real) (nt - 1);
	if (dabs(rn) < 1e-5f && *yaxt < 0.f) {
	    goto L10;
	}
	grn = 0.f;
	if (rn != 0.f) {
	    i__1 = max(0,nd);
	    r__1 = dabs(rn) + .5f / pow_ri(&c_b12, &i__1);
	    grn = r_lg10(&r__1);
	}
	grn = dmax(grn,0.f);
	nabc = (integer) grn + 2 + nd;
	width = chx * (real) nabc;
	if (rn < 0.f) {
	    width += chx;
	}
	xt = *x1 - (chx * .6f + width);
	if (*cht < 0.f) {
	    xt = *x1 + chx;
	}
	r__1 = yt - chy * .5f;
	plnumb_(&xt, &r__1, &ch, &rn, &c_b13, &nd);
L10:
	;
    }
L11:

    return 0;
} /* yaxis_ */

/* Subroutine */ int xyline_(int *n, real *x, real *y, real *xoff, real *
	xwt, real *yoff, real *ywt, int *ilin)
{
    /* Initialized data */

    static int npat = 8;
    static real scl1 = .125f;
    static int nmov[7] = { 2,2,2,4,6,8,8 };
    static real smov[56]	/* was [8][7] */ = { 1.2f,-.4f,0.f,0.f,0.f,
	    0.f,0.f,0.f,.5f,-.4f,0.f,0.f,0.f,0.f,0.f,0.f,.2f,-.4f,0.f,0.f,0.f,
	    0.f,0.f,0.f,1.4f,-.4f,.2f,-.4f,0.f,0.f,0.f,0.f,1.4f,-.4f,.2f,-.4f,
	    .2f,-.4f,0.f,0.f,1.4f,-.4f,.2f,-.4f,.2f,-.4f,.2f,-.4f,1.2f,-.4f,
	    1.2f,-.4f,.2f,-.4f,.2f,-.4f };

    /* System generated locals */
    int i__1;
    real r__1, r__2;

    /* Builtin functions */
    double sqrt(doublereal);

    /* Local variables */
    static int i__;
    static real s0, s1, s2, x1, x2, y2, y1;
    static int ii, im;
    static real ds, xx, yy;
    extern /* Subroutine */ int getfactors_(real *, real *);
    static real scl, frac;
    static int ipen, ipat, nlin;
    static real spat;
    extern /* Subroutine */ int plot_(real *, real *, int *);
    static real xscale, yscale;

/* .................................................................... */

/* ...General XY polyline plotting routine with offsets and scaling */

/* ...INPUT    X, Y     Input arrays of length N */
/*            XOFF,XWT Offset and scale factor for X array... */
/*            YOFF,YWT Offset and scale factor for Y array... */
/*                       Xplot = XWT*(X-XOFF) */
/*                       Yplot = YWT*(Y-YOFF) */
/*            ILIN     Selects line pattern */

/* ...8 line patterns are available (repeat for ILIN>8) */
/*     1  *****************************  SOLID */
/*     2  **** **** **** **** **** ****  LONG DASHED */
/*     3  ** ** ** ** ** ** ** ** ** **  SHORT DASHED */
/*     4  * * * * * * * * * * * * * * *  DOTTED */
/*     5  ***** * ***** * ***** * *****  DASH-DOT */
/*     6  ***** * * ***** * * ***** * *  DASH-DOT-DOT */
/*     7  ***** * * * ***** * * * *****  DASH-DOT-DOT-DOT */
/*     8  **** **** * * **** **** * *    DASH-DASH-DOT-DOT */

/* .................................................................... */


    /* Parameter adjustments */
    --y;
    --x;

    /* Function Body */

    if (*n <= 1) {
	return 0;
    }

/* ---- set line pattern scale based on current user scaling factors */
    getfactors_(&xscale, &yscale);
    scl = scl1 / sqrt(xscale * yscale);

    nlin = max(*ilin,1);
    ipat = (nlin - 1) % npat + 1;

    x2 = *xwt * (x[1] - *xoff);
    y2 = *ywt * (y[1] - *yoff);
    plot_(&x2, &y2, &c__3);

    if (ipat == 1) {
/* ...Plot using continuous line */
	i__1 = *n;
	for (i__ = 2; i__ <= i__1; ++i__) {
	    x1 = x2;
	    y1 = y2;
	    x2 = *xwt * (x[i__] - *xoff);
	    y2 = *ywt * (y[i__] - *yoff);
	    plot_(&x2, &y2, &c__2);
/* L10: */
	}

    } else {
/* ...Plot using stored patterns for lines */
	i__ = 1;
	s1 = 0.f;
	s2 = 0.f;
	s0 = 0.f;

/* L20: */
	for (ii = 1; ii <= 99999; ++ii) {

/* ...Pattern specifies pen up or down */
	    im = (ii + 1) % nmov[ipat - 2] + 1;
	    ipen = 3;
	    if (smov[im + (ipat - 1 << 3) - 9] > 0.f) {
		ipen = 2;
	    }

	    ds = scl * (r__1 = smov[im + (ipat - 1 << 3) - 9], dabs(r__1));
	    spat = s0 + ds;

/* ...Find data interval containing pattern point */
L30:
	    if (spat >= s2 && i__ + 1 <= *n) {
		++i__;
		plot_(&x2, &y2, &ipen);
		x1 = x2;
		y1 = y2;
		s1 = s2;
		x2 = *xwt * (x[i__] - *xoff);
		y2 = *ywt * (y[i__] - *yoff);
/* Computing 2nd power */
		r__1 = x2 - x1;
/* Computing 2nd power */
		r__2 = y2 - y1;
		ds = sqrt(r__1 * r__1 + r__2 * r__2);
		s2 = s1 + ds;
		goto L30;
	    }

/* ...Find point on interval using linear interpolation */
	    if (spat > s2) {
		spat = s2;
	    }
	    if (s2 == s1) {
		frac = 0.f;
	    } else {
		frac = (spat - s1) / (s2 - s1);
	    }
	    xx = x1 + frac * (x2 - x1);
	    yy = y1 + frac * (y2 - y1);

/* ...Move to new point using stored pattern to specify pen up or down */
	    plot_(&xx, &yy, &ipen);
	    if (i__ >= *n && spat >= s2) {
		goto L50;
	    }
	    s0 = spat;
/* L40: */
	}

L50:
	;
    }

    return 0;
} /* xyline_ */

/* Subroutine */ int xysymb_(int *n, real *x, real *y, real *xoff, real *
	xwt, real *yoff, real *ywt, real *sh, int *isym)
{
    /* System generated locals */
    int i__1;

    /* Local variables */
    static int i__;
    static real xplt, yplt;
    extern /* Subroutine */ int plsymb_(real *, real *, real *, int *, 
	    real *, int *);

/* ............................................................. */

/* ...GENERAL XY MULTIPLE-SYMBOL PLOTTING ROUTINE */
/*   (useful for overplotting XYLINE plot with point symbols) */

/* ...INPUT    X, Y     Input arrays of length N */
/*            XOFF,XWT Offset and scale factor for X array */
/*            YOFF,YWT Offset and scale factor for Y array */
/*            SH       Symbol size */
/*            ISYM     Selects symbol type */
/*                     if ISYM < 0 ... no plotting */
/* ............................................................. */


    /* Parameter adjustments */
    --y;
    --x;

    /* Function Body */
    if (*isym < 0) {
	return 0;
    }

    i__1 = *n;
    for (i__ = 1; i__ <= i__1; ++i__) {
	xplt = *xwt * (x[i__] - *xoff);
	yplt = *ywt * (y[i__] - *yoff);
	plsymb_(&xplt, &yplt, sh, isym, &c_b13, &c__0);
/* L10: */
    }

    return 0;
} /* xysymb_ */

/* Subroutine */ int cont_grid__(int *ix, int *jx, int *ii, 
	int *jj, real *x, real *y, real *f, real *fcon, real *xoff, real *
	yoff, real *xwt, real *ywt)
{
    /* System generated locals */
    int x_dim1, x_offset, y_dim1, y_offset, f_dim1, f_offset;

    /* Local variables */
    extern /* Subroutine */ int contgrid_(int *, int *, int *, 
	    int *, real *, real *, real *, real *, real *, real *, real *,
	     real *);

    /* Parameter adjustments */
    f_dim1 = *ix;
    f_offset = 1 + f_dim1;
    f -= f_offset;
    y_dim1 = *ix;
    y_offset = 1 + y_dim1;
    y -= y_offset;
    x_dim1 = *ix;
    x_offset = 1 + x_dim1;
    x -= x_offset;

    /* Function Body */
    contgrid_(ix, jx, ii, jj, &x[x_offset], &y[y_offset], &f[f_offset], fcon, 
	    xoff, yoff, xwt, ywt);
    return 0;
} /* cont_grid__ */

/* Subroutine */ int contgrid_(int *ix, int *jx, int *ii, int 
	*jj, real *x, real *y, real *f, real *fcon, real *xoff, real *yoff, 
	real *xwt, real *ywt)
{
    /* System generated locals */
    int x_dim1, x_offset, y_dim1, y_offset, f_dim1, f_offset, i__1, i__2;
    real r__1, r__2;

    /* Local variables */
    static int io, ip, jo, jp;
    static real foo, fop, fpo, fpp, xoo, xop, xpo, xpp, yoo, yop, ypo, ypp, 
	    xcon, ycon;
    extern /* Subroutine */ int plot_(real *, real *, int *);
    static logical found;

/* -------------------------------------------------------------------------- */

/*     Plots one contour of a function F on a logically rectangular grid. */
/*     (normally called repeatedly if a number of contours is to be drawn) */

/*      IX JX   dimensions of arrays   X, Y, F */
/*      II JJ   array limits of arrays X, Y, F */
/*      X(i,j)  independent coordinates of point (i,j) */
/*      Y(i,j) */
/*      F(i,j)  function value at point (i,j) */
/*      FCON    value of F on the contour to be drawn */
/*      XOFF    offset for X */
/*      YOFF    offset for Y */
/*      XWT     scaling factor for X */
/*      YWT     scaling factor for Y */

/*        XPLOT = (X - XOFF)*XWT */
/*        YPLOT = (Y - YOFF)*YWT */
/* -------------------------------------------------------------------------- */


/* ---- go over all cells and draw contour in any cell which contains the contour */
    /* Parameter adjustments */
    f_dim1 = *ix;
    f_offset = 1 + f_dim1;
    f -= f_offset;
    y_dim1 = *ix;
    y_offset = 1 + y_dim1;
    y -= y_offset;
    x_dim1 = *ix;
    x_offset = 1 + x_dim1;
    x -= x_offset;

    /* Function Body */
    i__1 = *ii - 1;
    for (io = 1; io <= i__1; ++io) {
	ip = io + 1;

	i__2 = *jj - 1;
	for (jo = 1; jo <= i__2; ++jo) {
	    jp = jo + 1;

	    found = FALSE_;

/*           op    3    pp */

/*           4           2 */

/*           oo    1    po */

	    xoo = x[io + jo * x_dim1];
	    xop = x[io + jp * x_dim1];
	    xpo = x[ip + jo * x_dim1];
	    xpp = x[ip + jp * x_dim1];

	    yoo = y[io + jo * y_dim1];
	    yop = y[io + jp * y_dim1];
	    ypo = y[ip + jo * y_dim1];
	    ypp = y[ip + jp * y_dim1];

	    foo = f[io + jo * f_dim1];
	    fop = f[io + jp * f_dim1];
	    fpo = f[ip + jo * f_dim1];
	    fpp = f[ip + jp * f_dim1];

/* -------- bottom edge (side 1) */
	    if (*fcon >= foo && *fcon < fpo || *fcon < foo && *fcon >= fpo) {
		xcon = xoo + (*fcon - foo) * (xpo - xoo) / (fpo - foo);
		ycon = yoo + (*fcon - foo) * (ypo - yoo) / (fpo - foo);
		if (found) {
		    r__1 = *xwt * (xcon - *xoff);
		    r__2 = *ywt * (ycon - *yoff);
		    plot_(&r__1, &r__2, &c__2);
		} else {
		    r__1 = *xwt * (xcon - *xoff);
		    r__2 = *ywt * (ycon - *yoff);
		    plot_(&r__1, &r__2, &c__3);
		}
		found = ! found;
	    }

/* -------- left edge (side 4) */
	    if (*fcon >= foo && *fcon < fop || *fcon < foo && *fcon >= fop) {
		xcon = xoo + (*fcon - foo) * (xop - xoo) / (fop - foo);
		ycon = yoo + (*fcon - foo) * (yop - yoo) / (fop - foo);
		if (found) {
		    r__1 = *xwt * (xcon - *xoff);
		    r__2 = *ywt * (ycon - *yoff);
		    plot_(&r__1, &r__2, &c__2);
		} else {
		    r__1 = *xwt * (xcon - *xoff);
		    r__2 = *ywt * (ycon - *yoff);
		    plot_(&r__1, &r__2, &c__3);
		}
		found = ! found;
	    }

/* -------- right edge (side 2) */
	    if (*fcon >= fpo && *fcon < fpp || *fcon < fpo && *fcon >= fpp) {
		xcon = xpo + (*fcon - fpo) * (xpp - xpo) / (fpp - fpo);
		ycon = ypo + (*fcon - fpo) * (ypp - ypo) / (fpp - fpo);
		if (found) {
		    r__1 = *xwt * (xcon - *xoff);
		    r__2 = *ywt * (ycon - *yoff);
		    plot_(&r__1, &r__2, &c__2);
		} else {
		    r__1 = *xwt * (xcon - *xoff);
		    r__2 = *ywt * (ycon - *yoff);
		    plot_(&r__1, &r__2, &c__3);
		}
		found = ! found;
	    }

/* -------- top edge (side 3) */
	    if (*fcon >= fop && *fcon < fpp || *fcon < fop && *fcon >= fpp) {
		xcon = xop + (*fcon - fop) * (xpp - xop) / (fpp - fop);
		ycon = yop + (*fcon - fop) * (ypp - yop) / (fpp - fop);
		if (found) {
		    r__1 = *xwt * (xcon - *xoff);
		    r__2 = *ywt * (ycon - *yoff);
		    plot_(&r__1, &r__2, &c__2);
		} else {
		    r__1 = *xwt * (xcon - *xoff);
		    r__2 = *ywt * (ycon - *yoff);
		    plot_(&r__1, &r__2, &c__3);
		}
		found = ! found;
	    }

/* L110: */
	}
/* L10: */
    }

    return 0;
} /* contgrid_ */

/* Subroutine */ int contquad_(real *x, real *y, real *f, real *fupr, real *
	flwr, int *ncu, real *xcu, real *ycu, int *ncl, real *xcl, 
	real *ycl, int *na, int *ne, int *nv, real *xp, real *yp)
{
    /* System generated locals */
    real r__1;

    /* Local variables */
    static int i__, j, jm, ip, jp, jm1, jm2, jp1, jp2;
    static real fhi, flo;
    static int iang[4];
    static real fmin, fmax, ftmp[3];
    static int isum;
    static real xtmp[3], ytmp[3];
    extern /* Subroutine */ int conttri_(real *, real *, real *, real *, real 
	    *, int *, real *, real *, int *, real *, real *, int *
	    , int *, int *, real *, real *);

/* -------------------------------------------------------------------------- */
/*  Contour a single quadrilateral element between an upper and */
/*  a lower contour limit.  The output from this routine is both the */
/*  line segments defining the upper and lower contours and a set of */
/*  polygons that define the area of the element lying between the */
/*  contour limits.  These may be used to shade the area on a plot. */

/*    X, Y       Arrays containing quadrilateral coordinate data */
/*    F          Array containing the quantity F(x,y) to be contoured, */
/*                ie. F(i) is defined at X(i),Y(i), i=1->4 */
/*    FUPR, FLWR Upper and lower contour limits */
/*    NCU        Number of upper limit contour line points */
/*    XCU, YCU   Arrays of x,y points (in pairs) on upper contour */
/*    NCL        Number of lower limit contour line points */
/*    XCL, YCL   Arrays of x,y points (in pairs) on lower contour */
/*    NA         Number of polygon areas in XP, YP, NE arrays */
/*    NE         Array of numbers of points in each polygon area */
/*    NV         Vertex count of points in XP,YP arrays */
/*    XP, YP     Coordinate points of contour polygons */

/*  Note: the output contour line points on the upper contour (XCU,YCU) */
/*        or lower contour (XCL,YCL) are only valid in point pairs, ie. */
/*        points 1 and 2 define a segment, points 3 and 4 define the next, */
/*        etc.  In general, there is no guarantee that the cross-pair points */
/*        (like points 2 and 3) will be contiguous. DO NOT PLOT THESE AS A */
/*        CONTIGUOUS ARRAY OF POINTS. */

/*  Note: the output areas (NA polygon areas) are stored with the points */
/*        for all polygons in one big XP,YP array.  The number of points */
/*        in each polygon are stored in NE, i.e. NE(1) is the number of */
/*        points stored in XP,YP for the first polygon, NE(2) is the number */
/*        of vertices stored following those for the second polygon, etc. */
/*        The total number of vertices is NV=sum[NE(1)+NE(2)..+NE(NA)]. */

/*  Note:  the NCU,NCL,NA,NV counters are cumulative in this routine! */
/*         If you want to contour each quadrilateral without accumulating */
/*         contour points or polygons reset NCU=0,NCL=0,NA=0,NV=0 before */
/*         each call to CONTQUAD. */

/* -------------------------------------------------------------------------- */


/* ----  NCU tracks the number of upper contour points */
/*      NCL tracks the number of lower contour points */
/*      NA tracks the number of polygon areas */
/*      NV tracks the total number of stored vertices in the XP,YP arrays */
/* ---- Uncomment these if you want to reset the counters each time you */
/*     contour a quadrilateral */
/*      NA = 0 */
/*      NV = 0 */
/*      NCU = 0 */
/*      NCL = 0 */

    /* Parameter adjustments */
    --yp;
    --xp;
    --ne;
    --ycl;
    --xcl;
    --ycu;
    --xcu;
    --f;
    --y;
    --x;

    /* Function Body */
    fhi = *fupr;
    flo = *flwr;
    if (fhi < flo) {
	fhi = *flwr;
	flo = *fupr;
    }

/* ---- Extrema */
/* Computing MAX */
    r__1 = max(f[1],f[2]), r__1 = max(r__1,f[3]);
    fmax = dmax(r__1,f[4]);
/* Computing MIN */
    r__1 = min(f[1],f[2]), r__1 = min(r__1,f[3]);
    fmin = dmin(r__1,f[4]);

/* ---- If cell is above contour band or below contour band skip it */
    if (fmax <= flo || fmin >= fhi) {
	return 0;
    }

/* ---- If cell is totally within contour band there are no contour lines, */
/*     and cell can be shaded directly */
    if (fmax <= fhi && fmin >= flo) {
	for (i__ = 1; i__ <= 4; ++i__) {
	    ++(*nv);
	    xp[*nv] = x[i__];
	    yp[*nv] = y[i__];
/* L2: */
	}
	++(*na);
	ne[*na] = 4;
	goto L100;
    }

/* ----Check for convex or concave quadrilaterals */
    isum = 0;
    for (j = 1; j <= 4; ++j) {
	jm = (j + 2) % 4 + 1;
	jp = j % 4 + 1;
	iang[j - 1] = 1;
	if ((x[j] - x[jm]) * (y[jp] - y[j]) < (x[jp] - x[j]) * (y[j] - y[jm]))
		 {
	    iang[j - 1] = -1;
	}
	isum += iang[j - 1];
/* L3: */
    }
    for (j = 1; j <= 4; ++j) {
	if (iang[j - 1] * isum < 0) {
	    goto L10;
	}
/* L4: */
    }

/* ----All angles < 180 deg., split into 4 triangles with average center pt */
    xtmp[2] = (x[1] + x[2] + x[3] + x[4]) * .25f;
    ytmp[2] = (y[1] + y[2] + y[3] + y[4]) * .25f;
    ftmp[2] = (f[1] + f[2] + f[3] + f[4]) * .25f;

    for (i__ = 1; i__ <= 4; ++i__) {
	ip = i__ % 4 + 1;
	xtmp[0] = x[i__];
	ytmp[0] = y[i__];
	ftmp[0] = f[i__];
	xtmp[1] = x[ip];
	ytmp[1] = y[ip];
	ftmp[1] = f[ip];
	conttri_(xtmp, ytmp, ftmp, &fhi, &flo, ncu, &xcu[1], &ycu[1], ncl, &
		xcl[1], &ycl[1], na, &ne[1], nv, &xp[1], &yp[1]);
/* L5: */
    }
    goto L100;

/* ----Quadrilaterals with an angle > 180, two triangles */
L10:
    xtmp[2] = x[j];
    ytmp[2] = y[j];
    ftmp[2] = f[j];

    jp1 = j % 4 + 1;
    xtmp[0] = x[jp1];
    ytmp[0] = y[jp1];
    ftmp[0] = f[jp1];
    jp2 = jp1 % 4 + 1;
    xtmp[1] = x[jp2];
    ytmp[1] = y[jp2];
    ftmp[1] = f[jp2];
    conttri_(xtmp, ytmp, ftmp, &fhi, &flo, ncu, &xcu[1], &ycu[1], ncl, &xcl[1]
	    , &ycl[1], na, &ne[1], nv, &xp[1], &yp[1]);

    jm2 = (jm + 1) % 4 + 1;
    xtmp[0] = x[jm2];
    ytmp[0] = y[jm2];
    ftmp[0] = f[jm2];
    jm1 = jm2 % 4 + 1;
    xtmp[1] = x[jm1];
    ytmp[1] = y[jm1];
    ftmp[1] = f[jm1];
    conttri_(xtmp, ytmp, ftmp, &fhi, &flo, ncu, &xcu[1], &ycu[1], ncl, &xcl[1]
	    , &ycl[1], na, &ne[1], nv, &xp[1], &yp[1]);

L100:
    return 0;
} /* contquad_ */

/* Subroutine */ int conttri_(real *x, real *y, real *f, real *fupr, real *
	flwr, int *ncu, real *xcu, real *ycu, int *ncl, real *xcl, 
	real *ycl, int *na, int *ne, int *nv, real *xp, real *yp)
{
    static int i__;
    static real fh[3], fl[3];
    static int im, ip;
    static real fhi, eta, flo, eps;
    static int nvfrst;


/*  Contour a single triangular element between an upper and */
/*  a lower contour limit.  The output from this routine is both the line */
/*  segments defining the upper and lower contours and a set of */
/*  polygons that define the area of the element lying between the */
/*  contour limits.  These may be used to shade the area on a plot. */

/*    X, Y,      Arrays containing triangular element points */
/*    F          Array containing the quantity F(x,y) to be contoured, */
/*                ie. F(i) is defined at X(i),Y(i), i=1->3 */
/*    FUPR, FLWR Upper and lower contour limits */
/*    NCU        Number of upper limit contour line points */
/*    XCU, YCU   Arrays of x,y points on upper contour */
/*    NCL        Number of lower limit contour line points */
/*    XCL, YCL   Arrays of x,y points on lower contour */
/*    NA         Number of polygon areas in XP, YP, NE arrays */
/*    NE         Array of numbers of points in each polygon area */
/*    NV         Vertex count of points in XP,YP arrays */
/*    XP, YP     Coordinate points of contour polygons */

/*  Note: the output contour line points on the upper contour (XCU,YCU) */
/*        or lower contour (XCL,YCL) are only valid in point pairs, ie. */
/*        points 1 and 2 define a segment, points 3 and 4 define the next, */
/*        etc.  In general, there is no guarantee that the cross-pair points */
/*        (like points 2 and 3) will be contiguous.  DO NOT PLOT THESE AS A */
/*        CONTIGUOUS ARRAY OF POINTS. */

/*  Note: the output areas (NA polygons) are stored with the points */
/*        for all polys in one big XP,YP array.  The number of points */
/*        in each polygon are stored in NE, i.e. NE(1) is the number of */
/*        points stored in XP,YP for the first polygon, NE(2) is the number */
/*        of vertices stored following those for the second polygon, etc. */
/*        The total number of vertices is NV=sum[NE(1)+NE(2)..+NE(NA)]. */

/*  Note:  the NCU,NCL,NA,NV counters are cumulative in this routine! */
/*         If you want to contour each triangle without accumulating */
/*         contour points or polygons reset NCU=0,NCL=0,NA=0,NV=0 before */
/*         each call to CONTTRI. */


/* ----  NCU tracks the number of upper contour points */
/*      NCL tracks the number of lower contour points */
/*      NA tracks the number of polygon areas */
/*      NV tracks the total number of stored vertices in the XP,YP arrays */
/* ---- Uncomment these if you want to reset the counters each time you */
/*     contour a triangle */
/*      NA = 0 */
/*      NV = 0 */
/*      NCU = 0 */
/*      NCL = 0 */

    /* Parameter adjustments */
    --yp;
    --xp;
    --ne;
    --ycl;
    --xcl;
    --ycu;
    --xcu;
    --f;
    --y;
    --x;

    /* Function Body */
    fhi = *fupr;
    flo = *flwr;
    if (fhi < flo) {
	fhi = *flwr;
	flo = *fupr;
    }
    nvfrst = *nv;

    eps = (fhi - flo) * 1e-4f;

/* ---- Temporary values */
    for (i__ = 1; i__ <= 3; ++i__) {
	fh[i__ - 1] = f[i__] - fhi;
	fl[i__ - 1] = f[i__] - flo;
	if (fh[i__ - 1] >= 0.f && fh[i__ - 1] < eps) {
	    fh[i__ - 1] = eps;
	}
	if (fh[i__ - 1] <= 0.f && fh[i__ - 1] > -eps) {
	    fh[i__ - 1] = -eps;
	}
	if (fl[i__ - 1] >= 0.f && fl[i__ - 1] < eps) {
	    fl[i__ - 1] = eps;
	}
	if (fl[i__ - 1] <= 0.f && fl[i__ - 1] > -eps) {
	    fl[i__ - 1] = -eps;
	}
/* L1: */
    }

/* ----Check point by point for points in contour limits */
    for (i__ = 1; i__ <= 3; ++i__) {

/* ----Inside contour limits */
	if (fh[i__ - 1] < 0.f && fl[i__ - 1] > 0.f) {
	    ++(*nv);
	    xp[*nv] = x[i__];
	    yp[*nv] = y[i__];

	} else {

	    if (fh[i__ - 1] >= 0.f) {
/* ----Check for intersections with previous and next point */
		ip = i__ % 3 + 1;
		im = (i__ + 1) % 3 + 1;
		if (fh[im - 1] < 0.f) {
		    eta = -(fh[im - 1] + fh[i__ - 1]) / (fh[im - 1] - fh[i__ 
			    - 1]);
		    ++(*ncu);
		    xcu[*ncu] = (x[i__] + x[im] + eta * (x[im] - x[i__])) * 
			    .5f;
		    ycu[*ncu] = (y[i__] + y[im] + eta * (y[im] - y[i__])) * 
			    .5f;
		    ++(*nv);
		    xp[*nv] = xcu[*ncu];
		    yp[*nv] = ycu[*ncu];
		}
		if (fh[ip - 1] < 0.f) {
		    eta = -(fh[ip - 1] + fh[i__ - 1]) / (fh[ip - 1] - fh[i__ 
			    - 1]);
		    ++(*ncu);
		    xcu[*ncu] = (x[i__] + x[ip] + eta * (x[ip] - x[i__])) * 
			    .5f;
		    ycu[*ncu] = (y[i__] + y[ip] + eta * (y[ip] - y[i__])) * 
			    .5f;
		    ++(*nv);
		    xp[*nv] = xcu[*ncu];
		    yp[*nv] = ycu[*ncu];
		}
	    }

	    if (fl[i__ - 1] <= 0.f) {
/* ----Check for intersections with previous and next point */
		ip = i__ % 3 + 1;
		im = (i__ + 1) % 3 + 1;
		if (fl[im - 1] > 0.f) {
		    eta = -(fl[im - 1] + fl[i__ - 1]) / (fl[im - 1] - fl[i__ 
			    - 1]);
		    ++(*ncl);
		    xcl[*ncl] = (x[i__] + x[im] + eta * (x[im] - x[i__])) * 
			    .5f;
		    ycl[*ncl] = (y[i__] + y[im] + eta * (y[im] - y[i__])) * 
			    .5f;
		    ++(*nv);
		    xp[*nv] = xcl[*ncl];
		    yp[*nv] = ycl[*ncl];
		}
		if (fl[ip - 1] > 0.f) {
		    eta = -(fl[ip - 1] + fl[i__ - 1]) / (fl[ip - 1] - fl[i__ 
			    - 1]);
		    ++(*ncl);
		    xcl[*ncl] = (x[i__] + x[ip] + eta * (x[ip] - x[i__])) * 
			    .5f;
		    ycl[*ncl] = (y[i__] + y[ip] + eta * (y[ip] - y[i__])) * 
			    .5f;
		    ++(*nv);
		    xp[*nv] = xcl[*ncl];
		    yp[*nv] = ycl[*ncl];
		}
	    }

	}

/* L50: */
    }

    if (*nv > nvfrst + 2) {
	++(*na);
	ne[*na] = *nv - nvfrst;
    }

    return 0;
} /* conttri_ */

/* Subroutine */ int axisadj_(real *xmin, real *xmax, real *xspan, real *
	deltax, int *ntics)
{
    /* Initialized data */

    static real xinctbl[5] = { .1f,.2f,.25f,.5f,1.f };

    /* System generated locals */
    real r__1;
    doublereal d__1;

    /* Builtin functions */
    double r_lg10(real *), pow_dd(doublereal *, doublereal *);

    /* Local variables */
    extern int iceiling_(real *);
    static int i__;
    static real xinc, xpon, xspan1;
    extern int ifloor_(real *);

/* ...Make scaled axes with engineering increments between tics */

/*   Input:    xmin, xmax - input range for which scaled axis is desired */

/*   Output:   xmin, xmax - adjusted range for scaled axis */
/*             xspan      - adjusted span of scaled axis */
/*             deltax     - increment to be used for scaled axis */
/*             nincr      - number of tics to be used on axis */
/*                          note that ntics=1+(xspan/deltax) */


    xspan1 = *xmax - *xmin;
    if (xspan1 == 0.f) {
	xspan1 = 1.f;
    }

    xpon = (real) ((integer) r_lg10(&xspan1));
    d__1 = (doublereal) xpon;
    *xspan = xspan1 / pow_dd(&c_b62, &d__1);

    for (i__ = 1; i__ <= 5; ++i__) {
	xinc = xinctbl[i__ - 1];
	*ntics = (integer) (*xspan / xinc + .1f) + 1;
	if (*ntics <= 6) {
	    goto L1;
	}
    }

L1:
    d__1 = (doublereal) xpon;
    *deltax = xinc * pow_dd(&c_b62, &d__1);
    r__1 = *xmin / *deltax;
    *xmin = *deltax * ifloor_(&r__1);
    r__1 = *xmax / *deltax;
    *xmax = *deltax * iceiling_(&r__1);
    *xspan = *xmax - *xmin;
    *ntics = (integer) (*xspan / *deltax + .1f) + 1;
    return 0;
} /* axisadj_ */

int iceiling_(real *x)
{
    /* System generated locals */
    int ret_val;

    /* Local variables */
    static int i__;

/* --- returns next highest int value if fraction is non-zero */
    i__ = (integer) (*x);
    if (*x - i__ > 0.f) {
	++i__;
    }
    ret_val = i__;
    return ret_val;
} /* iceiling_ */

int ifloor_(real *x)
{
    /* System generated locals */
    int ret_val;

    /* Local variables */
    static int i__;

/* --- returns next lowest int value if fraction is negative, non-zero */
    i__ = (integer) (*x);
    if (*x - i__ < 0.f) {
	--i__;
    }
    ret_val = i__;
    return ret_val;
} /* ifloor_ */

/* Subroutine */ int annot_(real *ch)
{
    /* Initialized data */

    static real chf = 1.f;
    static int isymb = 0;

    /* Format strings */
    static char fmt_1000[] = "(a)";
    static char fmt_1010[] = "(a,$)";
    static char fmt_1020[] = "(a,f7.3,a,$)";
    static char fmt_1030[] = "(a,i2,a,$)";
    static char fmt_1050[] = "(/\002   C haracters           |       \002"
	    "/\002   S lant characters     |       \002/\002   M ath characte"
	    "rs      |  plot \002/\002   P oint symbol         |       \002"
	    "/\002   L ine                 |       \002/\002   A rrow        "
	    "        |       \002/\002 \002/\002   W idth of characters  | mo"
	    "dify\002/\002   T ype of point symbol |       \002)";

    /* System generated locals */
    int i__1;
    real r__1, r__2;

    /* Builtin functions */
    int s_wsfe(cilist *), e_wsfe(void), s_wsle(cilist *), e_wsle(void), 
	    do_fio(int *, char *, ftnlen), s_rsfe(cilist *), e_rsfe(void),
	     i_indx(char *, char *, ftnlen, ftnlen), do_lio(int *, 
	    int *, char *, ftnlen);
    double sqrt(doublereal);
    int s_rsle(cilist *), e_rsle(void);

    /* Local variables */
    static char aa[80];
    static int na;
    static real ds;
    static int ip;
    static real dx, dy, xx, yy, chi, har;
    static char opt[1];
    static real xxl, xxm, yyl, yym;
    extern /* Subroutine */ int getcursorxy_(real *, real *, char *, ftnlen), 
	    plot_(real *, real *, int *);
    static char kchar[1];
    static real arlen;
    extern /* Subroutine */ int plchar_(real *, real *, real *, char *, real *
	    , int *, ftnlen), plmath_(real *, real *, real *, char *, 
	    real *, int *, ftnlen), plslan_(real *, real *, real *, char *
	    , real *, int *, ftnlen), newpen_(int *), plsymb_(real *, 
	    real *, real *, int *, real *, int *), plflush_(void);

    /* Fortran I/O blocks */
    static cilist io___116 = { 0, 6, 0, fmt_1050, 0 };
    static cilist io___117 = { 0, 6, 0, 0, 0 };
    static cilist io___118 = { 0, 6, 0, fmt_1010, 0 };
    static cilist io___119 = { 0, 5, 0, fmt_1000, 0 };
    static cilist io___122 = { 0, 6, 0, 0, 0 };
    static cilist io___126 = { 0, 6, 0, fmt_1010, 0 };
    static cilist io___127 = { 0, 5, 0, fmt_1000, 0 };
    static cilist io___130 = { 0, 6, 0, 0, 0 };
    static cilist io___131 = { 0, 6, 0, 0, 0 };
    static cilist io___142 = { 0, 6, 0, fmt_1020, 0 };
    static cilist io___143 = { 1, 5, 0, 0, 0 };
    static cilist io___144 = { 0, 6, 0, 0, 0 };
    static cilist io___145 = { 0, 6, 0, 0, 0 };
    static cilist io___146 = { 0, 6, 0, 0, 0 };
    static cilist io___147 = { 0, 6, 0, 0, 0 };
    static cilist io___148 = { 0, 6, 0, 0, 0 };
    static cilist io___149 = { 0, 6, 0, 0, 0 };
    static cilist io___150 = { 0, 6, 0, 0, 0 };
    static cilist io___151 = { 0, 6, 0, 0, 0 };
    static cilist io___152 = { 0, 6, 0, 0, 0 };
    static cilist io___153 = { 0, 6, 0, fmt_1030, 0 };
    static cilist io___154 = { 1, 5, 0, 0, 0 };


/* ------------------------------------------------------ */
/*     Interactive annotation menu for adding custom */
/*     ornaments to an active plot (before PLEND call). */
/* ------------------------------------------------------ */


L900:

/* L1000: */
/* L1010: */
/* L1020: */
/* L1030: */

    s_wsfe(&io___116);
    e_wsfe();

L905:
    s_wsle(&io___117);
    e_wsle();
    s_wsfe(&io___118);
    do_fio(&c__1, " Select option or <return>:  ", (ftnlen)29);
    e_wsfe();
    s_rsfe(&io___119);
    do_fio(&c__1, opt, (ftnlen)1);
    e_rsfe();
    if (*(unsigned char *)opt == ' ') {
	return 0;
    }

    chi = chf * *ch;

/* ------------------------------------------------------------- */
    if (i_indx("CcSsMm", opt, (ftnlen)6, (ftnlen)1) != 0) {

	s_wsle(&io___122);
	do_lio(&c__9, &c__1, "Click on lower left point of character string."
		"..", (ftnlen)48);
	e_wsle();
	getcursorxy_(&xx, &yy, kchar, (ftnlen)1);
	s_wsfe(&io___126);
	do_fio(&c__1, " Enter character string:  ", (ftnlen)26);
	e_wsfe();
	s_rsfe(&io___127);
	do_fio(&c__1, aa, (ftnlen)80);
	e_rsfe();

/* ---- find index of last non-blank character */
	for (na = 80; na >= 1; --na) {
	    if (*(unsigned char *)&aa[na - 1] != ' ') {
		goto L113;
	    }
/* L112: */
	}
L113:

	newpen_(&c__3);
	if (i_indx("Cc", opt, (ftnlen)2, (ftnlen)1) != 0) {
	    plchar_(&xx, &yy, &chi, aa, &c_b13, &na, (ftnlen)80);
	}
	if (i_indx("Ss", opt, (ftnlen)2, (ftnlen)1) != 0) {
	    plslan_(&xx, &yy, &chi, aa, &c_b13, &na, (ftnlen)80);
	}
	if (i_indx("Mm", opt, (ftnlen)2, (ftnlen)1) != 0) {
	    plmath_(&xx, &yy, &chi, aa, &c_b13, &na, (ftnlen)80);
	}
	plflush_();

/* ------------------------------------------------------------- */
    } else if (i_indx("Pp", opt, (ftnlen)2, (ftnlen)1) != 0) {

	s_wsle(&io___130);
	do_lio(&c__9, &c__1, "Click on symbol locations ...", (ftnlen)29);
	e_wsle();
	getcursorxy_(&xx, &yy, kchar, (ftnlen)1);
	newpen_(&c__2);
	plsymb_(&xx, &yy, &chi, &isymb, &c_b13, &c__0);
	plflush_();

/* ------------------------------------------------------------- */
    } else if (i_indx("LlAa", opt, (ftnlen)4, (ftnlen)1) != 0) {

	s_wsle(&io___131);
	do_lio(&c__9, &c__1, "Click on line points, twice on last point...", (
		ftnlen)44);
	e_wsle();

	newpen_(&c__1);
	getcursorxy_(&xxm, &yym, kchar, (ftnlen)1);
	plot_(&xxm, &yym, &c__3);
	plot_(&xxm, &yym, &c__2);
	xxl = xxm;
	yyl = yym;
	plflush_();
	for (ip = 1; ip <= 12345; ++ip) {
	    getcursorxy_(&xx, &yy, kchar, (ftnlen)1);
	    plot_(&xx, &yy, &c__2);
	    plflush_();
	    if (xxm == xx && yym == yy) {
		goto L132;
	    }
	    xxl = xxm;
	    yyl = yym;
	    xxm = xx;
	    yym = yy;
/* L131: */
	}
L132:

	if (i_indx("Aa", opt, (ftnlen)2, (ftnlen)1) != 0) {
/* ------ add arrowhead */
	    dx = xx - xxl;
	    dy = yy - yyl;
/* Computing 2nd power */
	    r__1 = dx;
/* Computing 2nd power */
	    r__2 = dy;
	    ds = sqrt(r__1 * r__1 + r__2 * r__2);
	    arlen = chi * 1.5f;
	    har = .1f;
/* c        IF(DS .GT. ARLEN) THEN */
	    r__1 = xx - arlen * (dx + har * dy) / ds;
	    r__2 = yy - arlen * (dy - har * dx) / ds;
	    plot_(&r__1, &r__2, &c__2);
	    r__1 = xx - arlen * (dx - har * dy) / ds;
	    r__2 = yy - arlen * (dy + har * dx) / ds;
	    plot_(&r__1, &r__2, &c__2);
	    plot_(&xx, &yy, &c__2);
/* c        ENDIF */
	}

	xx += chi * .7f;
	yy -= chi * .5f;
	plflush_();

/* ------------------------------------------------------------- */
    } else if (i_indx("Ww", opt, (ftnlen)2, (ftnlen)1) != 0) {

L140:
	s_wsfe(&io___142);
	do_fio(&c__1, " Enter new character width factor (currently =", (
		ftnlen)46);
	do_fio(&c__1, (char *)&chf, (ftnlen)sizeof(real));
	do_fio(&c__1, "):  ", (ftnlen)4);
	e_wsfe();
	i__1 = s_rsle(&io___143);
	if (i__1 != 0) {
	    goto L140;
	}
	i__1 = do_lio(&c__4, &c__1, (char *)&chf, (ftnlen)sizeof(real));
	if (i__1 != 0) {
	    goto L140;
	}
	i__1 = e_rsle();
	if (i__1 != 0) {
	    goto L140;
	}

/* ------------------------------------------------------------- */
    } else if (i_indx("Tt", opt, (ftnlen)2, (ftnlen)1) != 0) {

	s_wsle(&io___144);
	e_wsle();
	s_wsle(&io___145);
	do_lio(&c__9, &c__1, "  0  square         7  Y         ", (ftnlen)33);
	e_wsle();
	s_wsle(&io___146);
	do_lio(&c__9, &c__1, "  1  circle         8  flipped Y ", (ftnlen)33);
	e_wsle();
	s_wsle(&io___147);
	do_lio(&c__9, &c__1, "  2  triangle       9  *         ", (ftnlen)33);
	e_wsle();
	s_wsle(&io___148);
	do_lio(&c__9, &c__1, "  3  +             10  flipped * ", (ftnlen)33);
	e_wsle();
	s_wsle(&io___149);
	do_lio(&c__9, &c__1, "  4  x             11  hourglass ", (ftnlen)33);
	e_wsle();
	s_wsle(&io___150);
	do_lio(&c__9, &c__1, "  5  diamond       12  bowtie    ", (ftnlen)33);
	e_wsle();
	s_wsle(&io___151);
	do_lio(&c__9, &c__1, "  6  yield sign    13  star      ", (ftnlen)33);
	e_wsle();
	s_wsle(&io___152);
	e_wsle();
L160:
	s_wsfe(&io___153);
	do_fio(&c__1, " Enter new symbol type (currently =", (ftnlen)35);
	do_fio(&c__1, (char *)&isymb, (ftnlen)sizeof(integer));
	do_fio(&c__1, "):  ", (ftnlen)4);
	e_wsfe();
	i__1 = s_rsle(&io___154);
	if (i__1 != 0) {
	    goto L160;
	}
	i__1 = do_lio(&c__3, &c__1, (char *)&isymb, (ftnlen)sizeof(integer));
	if (i__1 != 0) {
	    goto L160;
	}
	i__1 = e_rsle();
	if (i__1 != 0) {
	    goto L160;
	}

/* ------------------------------------------------------------- */
    } else {

	goto L900;

    }

    goto L905;
} /* annot_ */
