/* f/frplot.f -- translated by f2c (version 20100827).
   You must link the resulting object file with libf2c:
	on Microsoft Windows system, link with libf2c.lib;
	on Linux or Unix systems, link with .../path/to/libf2c.a -lm
	or, if you install libf2c.a in a standard place, with -lf2c -lm
	-- in that order, at the end of the command line, as in
		cc *.o -lf2c -lm
	Source for libf2c is in /netlib/f2c/libf2c.zip, e.g.,

		http://www.netlib.org/f2c/libf2c.zip
*/

#include "f2c.h"

/* Table of constant values */

static int c__300 = 300;
static int c__1 = 1;
static int c__3 = 3;
static int c__2 = 2;
static real c_b8 = 0.f;

/* Subroutine */ int frplot_(int *n, real *s, real *x, real *hk, real *th,
	 real *ue, real *ve, real *xtr, real *fref, real *xoff, real *xsf, 
	real *yoff, real *ysf, real *chf)
{
    /* System generated locals */
    int i__1;
    real r__1, r__2;

    /* Builtin functions */
    /* Subroutine */ int s_stop(char *, ftnlen);

    /* Local variables */
    static real x1, x2, y1, y2, anf[4500]	/* was [300][15] */;
    static int ifr, nfr;
    static real frac, freq[15];
    extern /* Subroutine */ int plot_(real *, real *, int *);
    static real xnum, ynum;
    extern /* Subroutine */ int ntcalc_(int *, int *, real *, real *, 
	    real *, real *, real *, int *, real *, real *);
    static real anfmin;
    extern /* Subroutine */ int plnumb_(real *, real *, real *, real *, real *
	    , int *), xyline_(int *, real *, real *, real *, real *, 
	    real *, real *, int *);

/* ------------------------------------------------------------ */
/*     Plots the amplitude A(x) for a specified number */
/*     of frequencies.  The frequency values which are */
/*     used are set internally in the amplitude calculation */
/*     routine NTCALC, and displayed here. */

/*     N       number of laminar streamwise points i */
/*              (transition is in interval N...N+1) */
/*     S(i)    streamwise arc length for integrating -a_i = d[ln(A)]/ds */
/*     X(i)    plotting x coordinate */
/*     HK(i)   kinematic shape parameter */
/*     TH(i)   momentum thickness */
/*     UE(i)   edge velocity */
/*     VE(i)   edge kinematic viscosity */
/*     XTR     transition x location,  should be  X(N) < XTR < X(N+1) */

/*     FREF    reference radian frequency (w/FREF is displayed) */

/*     XOFF    plotting offsets, scales...  Xplot = (X-XOFF)*XSF */
/*     YOFF                                 Yplot = (Y-YOFF)*YSF */
/*     XSF */
/*     YSF */

/*     CHF     character height */
/* ------------------------------------------------------------ */

/* ---- max number of streamwise points and frequencies */
/* cc      PARAMETER (IDIM=300,NFX=50) */


    /* Parameter adjustments */
    --ve;
    --ue;
    --th;
    --hk;
    --x;
    --s;

    /* Function Body */
    if (*n + 1 > 300) {
	s_stop("FRPLOT: Array overflow.  Increase IDIM.", (ftnlen)39);
    }

/* ---- set number of frequencies plotted */
    nfr = 15;

/* ---- calculate wave amplitudes for each frequency */
    i__1 = *n + 1;
    ntcalc_(&c__300, &i__1, &s[1], &hk[1], &th[1], &ue[1], &ve[1], &nfr, freq,
	     anf);

/* ---- plot amplitudes for all frequencies */
    x1 = x[*n];
    x2 = *xtr;
    frac = (x2 - x1) / (x[*n + 1] - x1);
    i__1 = nfr;
    for (ifr = 1; ifr <= i__1; ++ifr) {

/* ------ plot A(x) up to the transition interval */
	xyline_(n, &x[1], &anf[ifr * 300 - 300], xoff, xsf, yoff, ysf, &c__1);

/* ------ plot last bit to the transition location in the transition interval */
	y1 = anf[*n + ifr * 300 - 301];
	y2 = anf[*n + ifr * 300 - 301] + frac * (anf[*n + 1 + ifr * 300 - 301]
		 - anf[*n + ifr * 300 - 301]);
	r__1 = (x1 - *xoff) * *xsf;
	r__2 = (y1 - *yoff) * *ysf;
	plot_(&r__1, &r__2, &c__3);
	r__1 = (x2 - *xoff) * *xsf;
	r__2 = (y2 - *yoff) * *ysf;
	plot_(&r__1, &r__2, &c__2);

/* ------ label the curve with its frequency if it grew to more than ANFMIN */
	anfmin = .5f;
/* Computing MAX */
	r__1 = anf[*n + ifr * 300 - 301], r__2 = anf[*n + 1 + ifr * 300 - 301]
		;
	if (dmax(r__1,r__2) > anfmin) {
	    xnum = (x2 - *xoff) * *xsf + *chf * .5f;
	    ynum = (y2 - *yoff) * *ysf - *chf * .5f;
	    r__1 = freq[ifr - 1] / *fref;
	    plnumb_(&xnum, &ynum, chf, &r__1, &c_b8, &c__2);
	}

/* L10: */
    }

    return 0;
} /* frplot_ */
