/* f/ntcalc.f -- translated by f2c (version 20100827).
   You must link the resulting object file with libf2c:
	on Microsoft Windows system, link with libf2c.lib;
	on Linux or Unix systems, link with .../path/to/libf2c.a -lm
	or, if you install libf2c.a in a standard place, with -lf2c -lm
	-- in that order, at the end of the command line, as in
		cc *.o -lf2c -lm
	Source for libf2c is in /netlib/f2c/libf2c.zip, e.g.,

		http://www.netlib.org/f2c/libf2c.zip
*/

#include "f2c.h"

/* Table of constant values */

static doublereal c_b7 = 10.;

/* Subroutine */ int ntcalc_(int *nx, int *n, real *x, real *hk, real 
	*th, real *ue, real *ve, int *nw, real *w, real *a)
{
    /* System generated locals */
    int a_dim1, a_offset, i__1, i__2;
    real r__1;
    doublereal d__1;

    /* Builtin functions */
    double r_lg10(real *), tanh(doublereal), pow_dd(doublereal *, doublereal *
	    );

    /* Local variables */
    static int i__;
    static real ha, ai, ar, ta;
    static int im;
    static real ua, va;
    static logical ok;
    static real dw, dx;
    static int iw;
    static real hkb, rdl, hsp, rsp, uot, wsp, ai_h__, ar_h__, ai_r__, ai_w__, 
	    ar_r__, rdlc, ar_w__, wlog, aiw_h__, arw_h__, aiw_r__, aiw_w__, 
	    arw_r__, arw_w__;
    extern /* Subroutine */ int osmap_(real *, real *, real *, real *, real *,
	     real *, real *, real *, real *, real *, real *, real *, real *, 
	    real *, real *, real *, real *, logical *);
    static int istart;

/* ------------------------------------------------------------------ */
/*     Calculates range of frequencies which span the */
/*     critical frequency.  Also calculates the amplitude */
/*     distribution for each frequency. */

/*    Input:  NX     array physical dimension */
/*            N      number of streamwise points i */
/*                    (i = N  point is assumed turbulent) */
/*            X (i)  streamwise coordinate array for integrating A(x) */
/*            HK(i)  kinematic shape parameter */
/*            TH(i)  momentum thickness */
/*            UE(i)  edge velocity */
/*            VE(i)  edge kinematic viscosity (in same units as UE*TH) */
/*            NW     number of frequencies to be set */

/*    Output: W(k)   radian frequencies in same units as UE/TH */
/*            A(i,k) amplitude distribution for frequency W(k) */
/* ------------------------------------------------------------------ */



/* ---- log(frequency) increment over range (i.e. 1.5 decades) */
    /* Parameter adjustments */
    --ve;
    --ue;
    --th;
    --hk;
    --x;
    a_dim1 = *nx;
    a_offset = 1 + a_dim1;
    a -= a_offset;
    --w;

    /* Function Body */
    dw = -1.5f / (real) (*nw - 1);

/* ---- frequency and amplitude will be returned as zero if no instability */
    i__1 = *nw;
    for (iw = 1; iw <= i__1; ++iw) {
	w[iw] = 0.f;
	i__2 = *n;
	for (i__ = 1; i__ <= i__2; ++i__) {
	    a[i__ + iw * a_dim1] = 0.f;
/* L105: */
	}
/* L10: */
    }

/* ---- search downstream for location where Rcrit is first exceeded */
    i__1 = *n - 1;
    for (i__ = 1; i__ <= i__1; ++i__) {
/* ------ local Rdelta* */
	r__1 = hk[i__] * th[i__] * ue[i__] / ve[i__];
	rdl = r_lg10(&r__1);

/* ------ approximate critical Rdelta* for local shape parameter */
	hkb = 1.f / (hk[i__] - 1.f);
	rdlc = hkb * 1.35f + 2.23f + tanh(hkb * 10.4f - 7.07f) * .85f - .1f;

	if (rdl >= rdlc) {
	    goto L21;
	}
/* L20: */
    }
/* CC   WRITE(*,*) 'Rcrit not exceeded' */
    return 0;

L21:
    istart = i__;

/* ---- set frequency array at location where Rcrit is first exceeded */
    i__ = istart;
    uot = ue[i__] / th[i__];
    i__1 = *nw;
    for (iw = 1; iw <= i__1; ++iw) {
	wlog = dw * (real) (iw - 1) - 1.f;
	d__1 = (doublereal) wlog;
	w[iw] = pow_dd(&c_b7, &d__1) * uot;
/* L30: */
    }

    i__1 = *n;
    for (i__ = istart + 1; i__ <= i__1; ++i__) {
	im = i__ - 1;

/* ------ set flow variables over i-1,i interval */
	ua = (ue[im] + ue[i__]) * .5f;
	va = (ve[im] + ve[i__]) * .5f;
	ta = (th[im] + th[i__]) * .5f;
	ha = (hk[im] + hk[i__]) * .5f;

	if (i__ == *n) {
/* ------- last point is turbulent, so extrapolate from laminar region */
/* -       (turbulent H is likely to be inappropriate) */
	    ua = ue[im] * 1.5f - ue[im - 1] * .5f;
	    va = ve[im] * 1.5f - ve[im - 1] * .5f;
	    ta = th[im] * 1.5f - th[im - 1] * .5f;
	    ha = hk[im] * 1.5f - hk[im - 1] * .5f;
	}

/* ------ set local Rtheta, Hk */
	rsp = ua * ta / va;
	hsp = ha;

/* ------ limit Hk, (OSMAP routine would clip anyway) */
	hsp = dmin(hsp,19.999f);

/* ------ go over frequencies */
	i__2 = *nw;
	for (iw = 1; iw <= i__2; ++iw) {
/* -------- set Ue/Theta-normalized frequency  WSP = w Theta/Ue */
	    wsp = w[iw] * ta / ua;

/* -------- calculate Theta-normalized spatial growth rate  AI = ai * Theta */
	    osmap_(&rsp, &wsp, &hsp, &ar, &ar_r__, &ar_w__, &ar_h__, &arw_r__,
		     &arw_w__, &arw_h__, &ai, &ai_r__, &ai_w__, &ai_h__, &
		    aiw_r__, &aiw_w__, &aiw_h__, &ok);

/* -------- integrate growth rate to get amplitude */
	    dx = x[i__] - x[im];
	    a[i__ + iw * a_dim1] = a[im + iw * a_dim1] - ai * dx / ta;
/* Computing MAX */
	    r__1 = a[i__ + iw * a_dim1];
	    a[i__ + iw * a_dim1] = dmax(r__1,0.f);
/* L405: */
	}
/* L40: */
    }

    return 0;
} /* ntcalc_ */
