/* f/sort.f -- translated by f2c (version 20100827).
   You must link the resulting object file with libf2c:
	on Microsoft Windows system, link with libf2c.lib;
	on Linux or Unix systems, link with .../path/to/libf2c.a -lm
	or, if you install libf2c.a in a standard place, with -lf2c -lm
	-- in that order, at the end of the command line, as in
		cc *.o -lf2c -lm
	Source for libf2c is in /netlib/f2c/libf2c.zip, e.g.,

		http://www.netlib.org/f2c/libf2c.zip
*/

#include "f2c.h"

/* Table of constant values */

static int c__9 = 9;
static int c__1 = 1;

/* Subroutine */ int hsort_(int *n, real *a, int *indx)
{
    /* System generated locals */
    int i__1;

    /* Local variables */
    static int i__, j, l;
    static real q;
    static int ir, indxt;

/* -------------------------------------- */
/*     Heapsort algorithm. */
/*     Returns INDX(.) such that */

/*       A(INDX(i)) < A(INDX(i+1)) */

/*     Stolen from Numerical Recipes. */
/* -------------------------------------- */

    /* Parameter adjustments */
    --indx;
    --a;

    /* Function Body */
    i__1 = *n;
    for (i__ = 1; i__ <= i__1; ++i__) {
	indx[i__] = i__;
    }

    if (*n <= 1) {
	return 0;
    }

    l = *n / 2 + 1;
    ir = *n;

L10:
    if (l > 1) {
	--l;
	indxt = indx[l];
	q = a[indxt];
    } else {
	indxt = indx[ir];
	q = a[indxt];
	indx[ir] = indx[1];

	--ir;
	if (ir == 1) {
	    indx[1] = indxt;
	    return 0;
	}
    }

    i__ = l;
    j = l + l;

L20:
    if (j <= ir) {
	if (j < ir) {
	    if (a[indx[j]] < a[indx[j + 1]]) {
		++j;
	    }
	}
	if (q < a[indx[j]]) {
	    indx[i__] = indx[j];

	    i__ = j;
	    j += j;
	} else {
	    j = ir + 1;
	}
	goto L20;
    }

    indx[i__] = indxt;
    goto L10;
} /* hsort_ */

/* Subroutine */ int asort_(int *n, real *a, int *indx, real *atmp)
{
    /* System generated locals */
    int i__1;

    /* Local variables */
    static int i__, isort;

/* ----------------------------------------------- */
/*     Applies sorted index array to reorder A. */
/* ----------------------------------------------- */
    /* Parameter adjustments */
    --atmp;
    --indx;
    --a;

    /* Function Body */
    i__1 = *n;
    for (i__ = 1; i__ <= i__1; ++i__) {
	atmp[i__] = a[i__];
    }

    i__1 = *n;
    for (i__ = 1; i__ <= i__1; ++i__) {
	isort = indx[i__];
	a[i__] = atmp[isort];
    }

    return 0;
} /* asort_ */

/* Subroutine */ int remd_(int *n, real *a, int *indx, real *tol, 
	int *nnew)
{
    /* System generated locals */
    int i__1;
    real r__1;

    /* Local variables */
    static int i__, k;

/* ---------------------------------------------------- */
/*     Sets index array, such that */
/*     duplicate A values are left out */
/* ---------------------------------------------------- */
    /* Parameter adjustments */
    --indx;
    --a;

    /* Function Body */
    k = 1;
    indx[k] = 1;

    i__1 = *n;
    for (i__ = 2; i__ <= i__1; ++i__) {
	if ((r__1 = a[i__] - a[i__ - 1], dabs(r__1)) > *tol) {
	    ++k;
	    indx[k] = i__;
	}
    }

    *nnew = k;

    return 0;
} /* remd_ */

/* Subroutine */ int sortdup_(int *kk, real *s, real *w)
{
    /* System generated locals */
    int i__1;

    /* Builtin functions */
    int s_wsle(cilist *), do_lio(int *, int *, char *, ftnlen), 
	    e_wsle(void);

    /* Local variables */
    static int n, np;
    static logical done;
    static real temp;
    static int ipass;

    /* Fortran I/O blocks */
    static cilist io___16 = { 0, 6, 0, 0, 0 };


/* --- Sort arrays in S with no removal of duplicates */

/* ---- sort arrays */
    /* Parameter adjustments */
    --w;
    --s;

    /* Function Body */
    for (ipass = 1; ipass <= 1234; ++ipass) {
	done = TRUE_;
	i__1 = *kk - 1;
	for (n = 1; n <= i__1; ++n) {
	    np = n + 1;
	    if (s[np] >= s[n]) {
		goto L101;
	    }
	    temp = s[np];
	    s[np] = s[n];
	    s[n] = temp;
	    temp = w[np];
	    w[np] = w[n];
	    w[n] = temp;
	    done = FALSE_;
L101:
	    ;
	}
	if (done) {
	    goto L11;
	}
/* L10: */
    }
    s_wsle(&io___16);
    do_lio(&c__9, &c__1, "Sort failed", (ftnlen)11);
    e_wsle();

L11:
    return 0;
} /* sortdup_ */

/* Subroutine */ int fixdup_(int *kk, real *s, real *w)
{
    /* System generated locals */
    int i__1, i__2;

    /* Local variables */
    static int i__, n;

/* --- Check arrays in S by removing leading and ending duplicates */
/*    eliminate extra duplicates (more than one duplicate point) elsewhere */

/* ---- Check first elements for dups */
    /* Parameter adjustments */
    --w;
    --s;

    /* Function Body */
    if (s[2] == s[1]) {
	i__1 = *kk - 1;
	for (n = 1; n <= i__1; ++n) {
	    s[n] = s[n + 1];
	    w[n] = w[n + 1];
	}
	--(*kk);
    }

/* ---- Check last elements for dups */
    if (s[*kk] == s[*kk - 1]) {
	s[*kk - 1] = s[*kk];
	w[*kk - 1] = w[*kk];
	--(*kk);
    }

/* --- Eliminate more than 2 succeeding identical elements */
L10:
    i__1 = *kk - 2;
    for (n = 1; n <= i__1; ++n) {
	if (s[n] == s[n + 1] && s[n] == s[n + 2]) {
	    i__2 = *kk - 1;
	    for (i__ = n; i__ <= i__2; ++i__) {
		s[i__] = s[i__ + 1];
		w[i__] = w[i__ + 1];
	    }
	    --(*kk);
	    goto L10;
	}
    }

    return 0;
} /* fixdup_ */

/* Subroutine */ int sort_(int *kk, real *s, real *w)
{
    /* System generated locals */
    int i__1, i__2;

    /* Builtin functions */
    int s_wsle(cilist *), do_lio(int *, int *, char *, ftnlen), 
	    e_wsle(void);

    /* Local variables */
    static int k, n, np, kt, kks;
    static logical done;
    static real temp;
    static int ipass;

    /* Fortran I/O blocks */
    static cilist io___24 = { 0, 6, 0, 0, 0 };



/* ---- sort arrays */
    /* Parameter adjustments */
    --w;
    --s;

    /* Function Body */
    for (ipass = 1; ipass <= 1234; ++ipass) {
	done = TRUE_;
	i__1 = *kk - 1;
	for (n = 1; n <= i__1; ++n) {
	    np = n + 1;
	    if (s[np] >= s[n]) {
		goto L101;
	    }
	    temp = s[np];
	    s[np] = s[n];
	    s[n] = temp;
	    temp = w[np];
	    w[np] = w[n];
	    w[n] = temp;
	    done = FALSE_;
L101:
	    ;
	}
	if (done) {
	    goto L11;
	}
/* L10: */
    }
    s_wsle(&io___24);
    do_lio(&c__9, &c__1, "Sort failed", (ftnlen)11);
    e_wsle();

/* ---- search for duplicate pairs and eliminate each one */
L11:
    kks = *kk;
    i__1 = kks;
    for (k = 1; k <= i__1; ++k) {
	if (k >= *kk) {
	    return 0;
	}
	if (s[k] != s[k + 1]) {
	    goto L20;
	}
/* ------- eliminate pair */
	*kk += -2;
	i__2 = *kk;
	for (kt = k; kt <= i__2; ++kt) {
	    s[kt] = s[kt + 2];
	    w[kt] = w[kt + 2];
/* L201: */
	}
L20:
	;
    }

    return 0;
} /* sort_ */

/* Subroutine */ int sortol_(real *tol, int *kk, real *s, real *w)
{
    /* System generated locals */
    int i__1, i__2;
    real r__1, r__2;

    /* Builtin functions */
    int s_wsle(cilist *), do_lio(int *, int *, char *, ftnlen), 
	    e_wsle(void);

    /* Local variables */
    static int k, n, np, kt;
    static real dsq;
    static int kks;
    static logical done;
    static real temp;
    static int ipass;

    /* Fortran I/O blocks */
    static cilist io___33 = { 0, 6, 0, 0, 0 };



/* ---- sort arrays */
    /* Parameter adjustments */
    --w;
    --s;

    /* Function Body */
    for (ipass = 1; ipass <= 1234; ++ipass) {
	done = TRUE_;
	i__1 = *kk - 1;
	for (n = 1; n <= i__1; ++n) {
	    np = n + 1;
	    if (s[np] < s[n]) {
		temp = s[np];
		s[np] = s[n];
		s[n] = temp;
		temp = w[np];
		w[np] = w[n];
		w[n] = temp;
		done = FALSE_;
	    }
	}
	if (done) {
	    goto L10;
	}
    }
    s_wsle(&io___33);
    do_lio(&c__9, &c__1, "Sort failed", (ftnlen)11);
    e_wsle();

/* ---- search for near-duplicate pairs and eliminate extra points */
/* ---- Modified 4/24/01 HHY to check list until ALL duplicates removed */
/*     This cures a bug for sharp LE foils where there were 3 LE points in */
/*     camber, thickness lists from GETCAM. */

L10:
    kks = *kk;
    done = TRUE_;
    i__1 = kks;
    for (k = 1; k <= i__1; ++k) {
	if (k >= *kk) {
	    goto L20;
	}
/* Computing 2nd power */
	r__1 = s[k] - s[k + 1];
/* Computing 2nd power */
	r__2 = w[k] - w[k + 1];
	dsq = r__1 * r__1 + r__2 * r__2;
	if (dsq >= *tol * *tol) {
	    goto L20;
	}
/* ------- eliminate extra point pairs */
/* cc         write(*,*) 'extra on point ',k,kks */
	--(*kk);
	i__2 = *kk;
	for (kt = k + 1; kt <= i__2; ++kt) {
	    s[kt] = s[kt + 1];
	    w[kt] = w[kt + 1];
	}
	done = FALSE_;
L20:
	;
    }
    if (! done) {
	goto L10;
    }

    return 0;
} /* sortol_ */
