/* f/spline.f -- translated by f2c (version 20100827).
   You must link the resulting object file with libf2c:
	on Microsoft Windows system, link with libf2c.lib;
	on Linux or Unix systems, link with .../path/to/libf2c.a -lm
	or, if you install libf2c.a in a standard place, with -lf2c -lm
	-- in that order, at the end of the command line, as in
		cc *.o -lf2c -lm
	Source for libf2c is in /netlib/f2c/libf2c.zip, e.g.,

		http://www.netlib.org/f2c/libf2c.zip
*/

#include "f2c.h"

/* Table of constant values */

static int c__9 = 9;
static int c__1 = 1;
static int c__3 = 3;
static int c__4 = 4;
static real c_b44 = -999.f;

/* *********************************************************************** */
/*    Module:  spline.f */

/*    Copyright (C) 2000 Mark Drela */

/*    This program is free software; you can redistribute it and/or modify */
/*    it under the terms of the GNU General Public License as published by */
/*    the Free Software Foundation; either version 2 of the License, or */
/*    (at your option) any later version. */

/*    This program is distributed in the hope that it will be useful, */
/*    but WITHOUT ANY WARRANTY; without even the implied warranty of */
/*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the */
/*    GNU General Public License for more details. */

/*    You should have received a copy of the GNU General Public License */
/*    along with this program; if not, write to the Free Software */
/*    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */
/* *********************************************************************** */
/* Subroutine */ int spline_(real *x, real *xs, real *s, int *n)
{
    /* System generated locals */
    int i__1;

    /* Builtin functions */
    /* Subroutine */ int s_stop(char *, ftnlen);

    /* Local variables */
    static real a[1000], b[1000], c__[1000];
    static int i__;
    static real dsm, dsp;
    extern /* Subroutine */ int trisol_(real *, real *, real *, real *, 
	    int *);

/* ------------------------------------------------------- */
/*     Calculates spline coefficients for X(S).          | */
/*     Zero 2nd derivative end conditions are used.      | */
/*     To evaluate the spline at some value of S,        | */
/*     use SEVAL and/or DEVAL.                           | */
/*                                                       | */
/*     S        independent variable array (input)       | */
/*     X        dependent variable array   (input)       | */
/*     XS       dX/dS array                (calculated)  | */
/*     N        number of points           (input)       | */
/*                                                       | */
/* ------------------------------------------------------- */
    /* Parameter adjustments */
    --s;
    --xs;
    --x;

    /* Function Body */
    if (*n > 1000) {
	s_stop("SPLINE: array overflow, increase NMAX", (ftnlen)37);
    }

    i__1 = *n - 1;
    for (i__ = 2; i__ <= i__1; ++i__) {
	dsm = s[i__] - s[i__ - 1];
	dsp = s[i__ + 1] - s[i__];
	b[i__ - 1] = dsp;
	a[i__ - 1] = (dsm + dsp) * 2.f;
	c__[i__ - 1] = dsm;
	xs[i__] = ((x[i__ + 1] - x[i__]) * dsm / dsp + (x[i__] - x[i__ - 1]) *
		 dsp / dsm) * 3.f;
/* L1: */
    }

/* ---- set zero second derivative end conditions */
    a[0] = 2.f;
    c__[0] = 1.f;
    xs[1] = (x[2] - x[1]) * 3.f / (s[2] - s[1]);
    b[*n - 1] = 1.f;
    a[*n - 1] = 2.f;
    xs[*n] = (x[*n] - x[*n - 1]) * 3.f / (s[*n] - s[*n - 1]);

/* ---- solve for derivative array XS */
    trisol_(a, b, c__, &xs[1], n);

    return 0;
} /* spline_ */

/* Subroutine */ int splind_(real *x, real *xs, real *s, int *n, real *
	xs1, real *xs2)
{
    /* System generated locals */
    int i__1;

    /* Builtin functions */
    /* Subroutine */ int s_stop(char *, ftnlen);

    /* Local variables */
    static real a[1000], b[1000], c__[1000];
    static int i__;
    static real dsm, dsp;
    extern /* Subroutine */ int trisol_(real *, real *, real *, real *, 
	    int *);

/* ------------------------------------------------------- */
/*     Calculates spline coefficients for X(S).          | */
/*     Specified 1st derivative and/or usual zero 2nd    | */
/*     derivative end conditions are used.               | */
/*     To evaluate the spline at some value of S,        | */
/*     use SEVAL and/or DEVAL.                           | */
/*                                                       | */
/*     S        independent variable array (input)       | */
/*     X        dependent variable array   (input)       | */
/*     XS       dX/dS array                (calculated)  | */
/*     N        number of points           (input)       | */
/*     XS1,XS2  endpoint derivatives       (input)       | */
/*              If = 999.0, then usual zero second       | */
/*              derivative end condition(s) are used     | */
/*              If = -999.0, then zero third             | */
/*              derivative end condition(s) are used     | */
/*                                                       | */
/* ------------------------------------------------------- */
    /* Parameter adjustments */
    --s;
    --xs;
    --x;

    /* Function Body */
    if (*n > 1000) {
	s_stop("SPLIND: array overflow, increase NMAX", (ftnlen)37);
    }

    i__1 = *n - 1;
    for (i__ = 2; i__ <= i__1; ++i__) {
	dsm = s[i__] - s[i__ - 1];
	dsp = s[i__ + 1] - s[i__];
	b[i__ - 1] = dsp;
	a[i__ - 1] = (dsm + dsp) * 2.f;
	c__[i__ - 1] = dsm;
	xs[i__] = ((x[i__ + 1] - x[i__]) * dsm / dsp + (x[i__] - x[i__ - 1]) *
		 dsp / dsm) * 3.f;
/* L1: */
    }

    if (*xs1 == 999.f) {
/* ----- set zero second derivative end condition */
	a[0] = 2.f;
	c__[0] = 1.f;
	xs[1] = (x[2] - x[1]) * 3.f / (s[2] - s[1]);
    } else if (*xs1 == -999.f) {
/* ----- set zero third derivative end condition */
	a[0] = 1.f;
	c__[0] = 1.f;
	xs[1] = (x[2] - x[1]) * 2.f / (s[2] - s[1]);
    } else {
/* ----- set specified first derivative end condition */
	a[0] = 1.f;
	c__[0] = 0.f;
	xs[1] = *xs1;
    }

    if (*xs2 == 999.f) {
	b[*n - 1] = 1.f;
	a[*n - 1] = 2.f;
	xs[*n] = (x[*n] - x[*n - 1]) * 3.f / (s[*n] - s[*n - 1]);
    } else if (*xs2 == -999.f) {
	b[*n - 1] = 1.f;
	a[*n - 1] = 1.f;
	xs[*n] = (x[*n] - x[*n - 1]) * 2.f / (s[*n] - s[*n - 1]);
    } else {
	a[*n - 1] = 1.f;
	b[*n - 1] = 0.f;
	xs[*n] = *xs2;
    }

    if (*n == 2 && *xs1 == -999.f && *xs2 == -999.f) {
	b[*n - 1] = 1.f;
	a[*n - 1] = 2.f;
	xs[*n] = (x[*n] - x[*n - 1]) * 3.f / (s[*n] - s[*n - 1]);
    }

/* ---- solve for derivative array XS */
    trisol_(a, b, c__, &xs[1], n);

    return 0;
} /* splind_ */

/* Subroutine */ int splina_(real *x, real *xs, real *s, int *n)
{
    /* System generated locals */
    int i__1;

    /* Local variables */
    static int i__;
    static real ds, dx, xs1, xs2;
    static logical lend;

/* ------------------------------------------------------- */
/*     Calculates spline coefficients for X(S).          | */
/*     A simple averaging of adjacent segment slopes     | */
/*     is used to achieve non-oscillatory curve          | */
/*     End conditions are set by end segment slope       | */
/*     To evaluate the spline at some value of S,        | */
/*     use SEVAL and/or DEVAL.                           | */
/*                                                       | */
/*     S        independent variable array (input)       | */
/*     X        dependent variable array   (input)       | */
/*     XS       dX/dS array                (calculated)  | */
/*     N        number of points           (input)       | */
/*                                                       | */
/* ------------------------------------------------------- */

    /* Parameter adjustments */
    --s;
    --xs;
    --x;

    /* Function Body */
    lend = TRUE_;
    i__1 = *n - 1;
    for (i__ = 1; i__ <= i__1; ++i__) {
	ds = s[i__ + 1] - s[i__];
	if (ds == 0.f) {
	    xs[i__] = xs1;
	    lend = TRUE_;
	} else {
	    dx = x[i__ + 1] - x[i__];
	    xs2 = dx / ds;
	    if (lend) {
		xs[i__] = xs2;
		lend = FALSE_;
	    } else {
		xs[i__] = (xs1 + xs2) * .5f;
	    }
	}
	xs1 = xs2;
/* L1: */
    }
    xs[*n] = xs1;

    return 0;
} /* splina_ */

/* Subroutine */ int trisol_(real *a, real *b, real *c__, real *d__, int *
	kk)
{
    /* System generated locals */
    int i__1;

    /* Local variables */
    static int k, km;

/* ----------------------------------------- */
/*     Solves KK long, tri-diagonal system | */
/*                                         | */
/*             A C          D              | */
/*             B A C        D              | */
/*               B A .      .              | */
/*                 . . C    .              | */
/*                   B A    D              | */
/*                                         | */
/*     The righthand side D is replaced by | */
/*     the solution.  A, C are destroyed.  | */
/* ----------------------------------------- */

    /* Parameter adjustments */
    --d__;
    --c__;
    --b;
    --a;

    /* Function Body */
    i__1 = *kk;
    for (k = 2; k <= i__1; ++k) {
	km = k - 1;
	c__[km] /= a[km];
	d__[km] /= a[km];
	a[k] -= b[k] * c__[km];
	d__[k] -= b[k] * d__[km];
/* L1: */
    }

    d__[*kk] /= a[*kk];

    for (k = *kk - 1; k >= 1; --k) {
	d__[k] -= c__[k] * d__[k + 1];
/* L2: */
    }

    return 0;
} /* trisol_ */

doublereal seval_(real *ss, real *x, real *xs, real *s, int *n)
{
    /* System generated locals */
    real ret_val;

    /* Local variables */
    static int i__;
    static real t, ds, cx1, cx2;
    static int imid, ilow;

/* -------------------------------------------------- */
/*     Calculates X(SS)                             | */
/*     XS array must have been calculated by SPLINE | */
/* -------------------------------------------------- */
    /* Parameter adjustments */
    --s;
    --xs;
    --x;

    /* Function Body */
    ilow = 1;
    i__ = *n;

L10:
    if (i__ - ilow <= 1) {
	goto L11;
    }

    imid = (i__ + ilow) / 2;
    if (*ss < s[imid]) {
	i__ = imid;
    } else {
	ilow = imid;
    }
    goto L10;

L11:
    ds = s[i__] - s[i__ - 1];
    t = (*ss - s[i__ - 1]) / ds;
    cx1 = ds * xs[i__ - 1] - x[i__] + x[i__ - 1];
    cx2 = ds * xs[i__] - x[i__] + x[i__ - 1];
    ret_val = t * x[i__] + (1.f - t) * x[i__ - 1] + (t - t * t) * ((1.f - t) *
	     cx1 - t * cx2);
    return ret_val;
} /* seval_ */

doublereal deval_(real *ss, real *x, real *xs, real *s, int *n)
{
    /* System generated locals */
    real ret_val;

    /* Local variables */
    static int i__;
    static real t, ds, cx1, cx2;
    static int imid, ilow;

/* -------------------------------------------------- */
/*     Calculates dX/dS(SS)                         | */
/*     XS array must have been calculated by SPLINE | */
/* -------------------------------------------------- */
    /* Parameter adjustments */
    --s;
    --xs;
    --x;

    /* Function Body */
    ilow = 1;
    i__ = *n;

L10:
    if (i__ - ilow <= 1) {
	goto L11;
    }

    imid = (i__ + ilow) / 2;
    if (*ss < s[imid]) {
	i__ = imid;
    } else {
	ilow = imid;
    }
    goto L10;

L11:
    ds = s[i__] - s[i__ - 1];
    t = (*ss - s[i__ - 1]) / ds;
    cx1 = ds * xs[i__ - 1] - x[i__] + x[i__ - 1];
    cx2 = ds * xs[i__] - x[i__] + x[i__ - 1];
    ret_val = x[i__] - x[i__ - 1] + (1.f - t * 4.f + t * 3.f * t) * cx1 + t * 
	    (t * 3.f - 2.f) * cx2;
    ret_val /= ds;
    return ret_val;
} /* deval_ */

doublereal d2val_(real *ss, real *x, real *xs, real *s, int *n)
{
    /* System generated locals */
    real ret_val, r__1;

    /* Local variables */
    static int i__;
    static real t, ds, cx1, cx2;
    static int imid, ilow;

/* -------------------------------------------------- */
/*     Calculates d2X/dS2(SS)                       | */
/*     XS array must have been calculated by SPLINE | */
/* -------------------------------------------------- */
    /* Parameter adjustments */
    --s;
    --xs;
    --x;

    /* Function Body */
    ilow = 1;
    i__ = *n;

L10:
    if (i__ - ilow <= 1) {
	goto L11;
    }

    imid = (i__ + ilow) / 2;
    if (*ss < s[imid]) {
	i__ = imid;
    } else {
	ilow = imid;
    }
    goto L10;

L11:
    ds = s[i__] - s[i__ - 1];
    t = (*ss - s[i__ - 1]) / ds;
    cx1 = ds * xs[i__ - 1] - x[i__] + x[i__ - 1];
    cx2 = ds * xs[i__] - x[i__] + x[i__ - 1];
    ret_val = (t * 6.f - 4.f) * cx1 + (t * 6.f - 2.f) * cx2;
/* Computing 2nd power */
    r__1 = ds;
    ret_val /= r__1 * r__1;
    return ret_val;
} /* d2val_ */

doublereal curv_(real *ss, real *x, real *xs, real *y, real *ys, real *s, 
	int *n)
{
    /* System generated locals */
    real ret_val, r__1, r__2;

    /* Builtin functions */
    double sqrt(doublereal);

    /* Local variables */
    static int i__;
    static real t, ds, sd, xd, yd, cx1, cx2, cy1, cy2, xdd, ydd;
    static int imid, ilow;

/* ----------------------------------------------- */
/*     Calculates curvature of splined 2-D curve | */
/*     at S = SS                                 | */
/*                                               | */
/*     S        arc length array of curve        | */
/*     X, Y     coordinate arrays of curve       | */
/*     XS,YS    derivative arrays                | */
/*              (calculated earlier by SPLINE)   | */
/* ----------------------------------------------- */

    /* Parameter adjustments */
    --s;
    --ys;
    --y;
    --xs;
    --x;

    /* Function Body */
    ilow = 1;
    i__ = *n;

L10:
    if (i__ - ilow <= 1) {
	goto L11;
    }

    imid = (i__ + ilow) / 2;
    if (*ss < s[imid]) {
	i__ = imid;
    } else {
	ilow = imid;
    }
    goto L10;

L11:
    ds = s[i__] - s[i__ - 1];
    t = (*ss - s[i__ - 1]) / ds;

    cx1 = ds * xs[i__ - 1] - x[i__] + x[i__ - 1];
    cx2 = ds * xs[i__] - x[i__] + x[i__ - 1];
    xd = x[i__] - x[i__ - 1] + (1.f - t * 4.f + t * 3.f * t) * cx1 + t * (t * 
	    3.f - 2.f) * cx2;
    xdd = (t * 6.f - 4.f) * cx1 + (t * 6.f - 2.f) * cx2;

    cy1 = ds * ys[i__ - 1] - y[i__] + y[i__ - 1];
    cy2 = ds * ys[i__] - y[i__] + y[i__ - 1];
    yd = y[i__] - y[i__ - 1] + (1.f - t * 4.f + t * 3.f * t) * cy1 + t * (t * 
	    3.f - 2.f) * cy2;
    ydd = (t * 6.f - 4.f) * cy1 + (t * 6.f - 2.f) * cy2;

    sd = sqrt(xd * xd + yd * yd);
/* Computing MAX */
    r__1 = sd, r__2 = ds * .001f;
    sd = dmax(r__1,r__2);

/* Computing 3rd power */
    r__1 = sd;
    ret_val = (xd * ydd - yd * xdd) / (r__1 * (r__1 * r__1));

    return ret_val;
} /* curv_ */

doublereal curvs_(real *ss, real *x, real *xs, real *y, real *ys, real *s, 
	int *n)
{
    /* System generated locals */
    real ret_val, r__1, r__2;

    /* Builtin functions */
    double sqrt(doublereal);

    /* Local variables */
    static int i__;
    static real t, ds, sd, xd, yd, cx1, cx2, cy1, cy2, xdd, ydd, bot, top;
    static int imid;
    static real xddd, yddd;
    static int ilow;
    static real dbotdt, dtopdt;

/* ----------------------------------------------- */
/*     Calculates curvature derivative of        | */
/*     splined 2-D curve at S = SS               | */
/*                                               | */
/*     S        arc length array of curve        | */
/*     X, Y     coordinate arrays of curve       | */
/*     XS,YS    derivative arrays                | */
/*              (calculated earlier by SPLINE)   | */
/* ----------------------------------------------- */

    /* Parameter adjustments */
    --s;
    --ys;
    --y;
    --xs;
    --x;

    /* Function Body */
    ilow = 1;
    i__ = *n;

L10:
    if (i__ - ilow <= 1) {
	goto L11;
    }

    imid = (i__ + ilow) / 2;
    if (*ss < s[imid]) {
	i__ = imid;
    } else {
	ilow = imid;
    }
    goto L10;

L11:
    ds = s[i__] - s[i__ - 1];
    t = (*ss - s[i__ - 1]) / ds;

    cx1 = ds * xs[i__ - 1] - x[i__] + x[i__ - 1];
    cx2 = ds * xs[i__] - x[i__] + x[i__ - 1];
    xd = x[i__] - x[i__ - 1] + (1.f - t * 4.f + t * 3.f * t) * cx1 + t * (t * 
	    3.f - 2.f) * cx2;
    xdd = (t * 6.f - 4.f) * cx1 + (t * 6.f - 2.f) * cx2;
    xddd = cx1 * 6.f + cx2 * 6.f;

    cy1 = ds * ys[i__ - 1] - y[i__] + y[i__ - 1];
    cy2 = ds * ys[i__] - y[i__] + y[i__ - 1];
    yd = y[i__] - y[i__ - 1] + (1.f - t * 4.f + t * 3.f * t) * cy1 + t * (t * 
	    3.f - 2.f) * cy2;
    ydd = (t * 6.f - 4.f) * cy1 + (t * 6.f - 2.f) * cy2;
    yddd = cy1 * 6.f + cy2 * 6.f;

    sd = sqrt(xd * xd + yd * yd);
/* Computing MAX */
    r__1 = sd, r__2 = ds * .001f;
    sd = dmax(r__1,r__2);

/* Computing 3rd power */
    r__1 = sd;
    bot = r__1 * (r__1 * r__1);
    dbotdt = sd * 3.f * (xd * xdd + yd * ydd);

    top = xd * ydd - yd * xdd;
    dtopdt = xd * yddd - yd * xddd;

/* Computing 2nd power */
    r__1 = bot;
    ret_val = (dtopdt * bot - dbotdt * top) / (r__1 * r__1);

    return ret_val;
} /* curvs_ */

/* Subroutine */ int sinvrt_(real *si, real *xi, real *x, real *xs, real *s, 
	int *n)
{
    /* System generated locals */
    real r__1;

    /* Builtin functions */
    int s_wsle(cilist *), do_lio(int *, int *, char *, ftnlen), 
	    e_wsle(void);

    /* Local variables */
    static real ds, res;
    static int iter;
    static real resp;
    extern doublereal deval_(real *, real *, real *, real *, int *), 
	    seval_(real *, real *, real *, real *, int *);
    static real sisav;

    /* Fortran I/O blocks */
    static cilist io___81 = { 0, 6, 0, 0, 0 };


/* ------------------------------------------------------- */
/*     Calculates the "inverse" spline function S(X).    | */
/*     Since S(X) can be multi-valued or not defined,    | */
/*     this is not a "black-box" routine.  The calling   | */
/*     program must pass via SI a sufficiently good      | */
/*     initial guess for S(XI).                          | */
/*                                                       | */
/*     XI      specified X value       (input)           | */
/*     SI      calculated S(XI) value  (input,output)    | */
/*     X,XS,S  usual spline arrays     (input)           | */
/*                                                       | */
/* ------------------------------------------------------- */

    /* Parameter adjustments */
    --s;
    --xs;
    --x;

    /* Function Body */
    sisav = *si;

    for (iter = 1; iter <= 10; ++iter) {
	res = seval_(si, &x[1], &xs[1], &s[1], n) - *xi;
	resp = deval_(si, &x[1], &xs[1], &s[1], n);
	ds = -res / resp;
	*si += ds;
	if ((r__1 = ds / (s[*n] - s[1]), dabs(r__1)) < 1e-5f) {
	    return 0;
	}
/* L10: */
    }
    s_wsle(&io___81);
    do_lio(&c__9, &c__1, "SINVRT: spline inversion failed. Input value retur"
	    "ned.", (ftnlen)54);
    e_wsle();
    *si = sisav;

    return 0;
} /* sinvrt_ */

/* Subroutine */ int scalc_(real *x, real *y, real *s, int *n)
{
    /* System generated locals */
    int i__1;
    real r__1, r__2;

    /* Builtin functions */
    double sqrt(doublereal);

    /* Local variables */
    static int i__;

/* ---------------------------------------- */
/*     Calculates the arc length array S  | */
/*     for a 2-D array of points (X,Y).   | */
/* ---------------------------------------- */

    /* Parameter adjustments */
    --s;
    --y;
    --x;

    /* Function Body */
    s[1] = 0.f;
    i__1 = *n;
    for (i__ = 2; i__ <= i__1; ++i__) {
/* Computing 2nd power */
	r__1 = x[i__] - x[i__ - 1];
/* Computing 2nd power */
	r__2 = y[i__] - y[i__ - 1];
	s[i__] = s[i__ - 1] + sqrt(r__1 * r__1 + r__2 * r__2);
/* L10: */
    }

    return 0;
} /* scalc_ */

/* Subroutine */ int splnxy_(real *x, real *xs, real *y, real *ys, real *s, 
	int *n)
{
    /* System generated locals */
    int i__1, i__2, i__3;
    real r__1, r__2;

    /* Builtin functions */
    double sqrt(doublereal);
    int s_wsle(cilist *), do_lio(int *, int *, char *, ftnlen), 
	    e_wsle(void);

    /* Local variables */
    static int i__, k;
    static real t;
    static int kk;
    static real ds, dx, dy, xt[33], yt[33], cx1, cx2, cy1, cy2, serr, sint, 
	    sint1, sint2;
    extern /* Subroutine */ int scalc_(real *, real *, real *, int *);
    static int ipass, npass;
    extern /* Subroutine */ int segspl_(real *, real *, real *, int *);

    /* Fortran I/O blocks */
    static cilist io___102 = { 0, 6, 0, 0, 0 };


/* ----------------------------------------- */
/*     Splines 2-D shape X(S), Y(S), along | */
/*     with true arc length parameter S.   | */
/* ----------------------------------------- */

    /* Parameter adjustments */
    --s;
    --ys;
    --y;
    --xs;
    --x;

    /* Function Body */
    kk = 32;
    npass = 10;

/* ---- set first estimate of arc length parameter */
    scalc_(&x[1], &y[1], &s[1], n);

/* ---- spline X(S) and Y(S) */
    segspl_(&x[1], &xs[1], &s[1], n);
    segspl_(&y[1], &ys[1], &s[1], n);

/* ---- re-integrate true arc length */
    i__1 = npass;
    for (ipass = 1; ipass <= i__1; ++ipass) {

	serr = 0.f;

	ds = s[2] - s[1];
	i__2 = *n;
	for (i__ = 2; i__ <= i__2; ++i__) {
	    dx = x[i__] - x[i__ - 1];
	    dy = y[i__] - y[i__ - 1];

	    cx1 = ds * xs[i__ - 1] - dx;
	    cx2 = ds * xs[i__] - dx;
	    cy1 = ds * ys[i__ - 1] - dy;
	    cy2 = ds * ys[i__] - dy;

	    xt[0] = 0.f;
	    yt[0] = 0.f;
	    i__3 = kk - 1;
	    for (k = 1; k <= i__3; ++k) {
		t = (real) k / (real) kk;
		xt[k] = t * dx + (t - t * t) * ((1.f - t) * cx1 - t * cx2);
		yt[k] = t * dy + (t - t * t) * ((1.f - t) * cy1 - t * cy2);
	    }
	    xt[kk] = dx;
	    yt[kk] = dy;

	    sint1 = 0.f;
	    i__3 = kk;
	    for (k = 1; k <= i__3; ++k) {
/* Computing 2nd power */
		r__1 = xt[k] - xt[k - 1];
/* Computing 2nd power */
		r__2 = yt[k] - yt[k - 1];
		sint1 += sqrt(r__1 * r__1 + r__2 * r__2);
	    }

	    sint2 = 0.f;
	    i__3 = kk;
	    for (k = 2; k <= i__3; k += 2) {
/* Computing 2nd power */
		r__1 = xt[k] - xt[k - 2];
/* Computing 2nd power */
		r__2 = yt[k] - yt[k - 2];
		sint2 += sqrt(r__1 * r__1 + r__2 * r__2);
	    }

	    sint = (sint1 * 4.f - sint2) / 3.f;

	    if ((r__1 = sint - ds, dabs(r__1)) > dabs(serr)) {
		serr = sint - ds;
	    }

	    if (i__ < *n) {
		ds = s[i__ + 1] - s[i__];
	    }

	    s[i__] = s[i__ - 1] + sqrt(sint);
	}

	serr /= s[*n] - s[1];
	s_wsle(&io___102);
	do_lio(&c__3, &c__1, (char *)&ipass, (ftnlen)sizeof(integer));
	do_lio(&c__4, &c__1, (char *)&serr, (ftnlen)sizeof(real));
	e_wsle();

/* ------ re-spline X(S) and Y(S) */
	segspl_(&x[1], &xs[1], &s[1], n);
	segspl_(&y[1], &ys[1], &s[1], n);

	if (dabs(serr) < 1e-7f) {
	    return 0;
	}

/* L100: */
    }

    return 0;
} /* splnxy_ */

/* Subroutine */ int segspl_(real *x, real *xs, real *s, int *n)
{
    /* System generated locals */
    int i__1;

    /* Builtin functions */
    /* Subroutine */ int s_stop(char *, ftnlen);

    /* Local variables */
    static int iseg, nseg, iseg0;
    extern /* Subroutine */ int splind_(real *, real *, real *, int *, 
	    real *, real *);

/* ----------------------------------------------- */
/*     Splines X(S) array just like SPLINE,      | */
/*     but allows derivative discontinuities     | */
/*     at segment joints.  Segment joints are    | */
/*     defined by identical successive S values. | */
/* ----------------------------------------------- */

    /* Parameter adjustments */
    --s;
    --xs;
    --x;

    /* Function Body */
    if (s[1] == s[2]) {
	s_stop("SEGSPL:  First input point duplicated", (ftnlen)37);
    }
    if (s[*n] == s[*n - 1]) {
	s_stop("SEGSPL:  Last  input point duplicated", (ftnlen)37);
    }

    iseg0 = 1;
    i__1 = *n - 2;
    for (iseg = 2; iseg <= i__1; ++iseg) {
	if (s[iseg] == s[iseg + 1]) {
	    nseg = iseg - iseg0 + 1;
	    splind_(&x[iseg0], &xs[iseg0], &s[iseg0], &nseg, &c_b44, &c_b44);
	    iseg0 = iseg + 1;
	}
/* L10: */
    }

    nseg = *n - iseg0 + 1;
    splind_(&x[iseg0], &xs[iseg0], &s[iseg0], &nseg, &c_b44, &c_b44);

    return 0;
} /* segspl_ */

/* Subroutine */ int segspld_(real *x, real *xs, real *s, int *n, real *
	xs1, real *xs2)
{
    /* System generated locals */
    int i__1;

    /* Builtin functions */
    /* Subroutine */ int s_stop(char *, ftnlen);

    /* Local variables */
    static int iseg, nseg, iseg0;
    extern /* Subroutine */ int splind_(real *, real *, real *, int *, 
	    real *, real *);

/* ----------------------------------------------- */
/*     Splines X(S) array just like SPLIND,      | */
/*     but allows derivative discontinuities     | */
/*     at segment joints.  Segment joints are    | */
/*     defined by identical successive S values. | */
/* ----------------------------------------------- */

    /* Parameter adjustments */
    --s;
    --xs;
    --x;

    /* Function Body */
    if (s[1] == s[2]) {
	s_stop("SEGSPL:  First input point duplicated", (ftnlen)37);
    }
    if (s[*n] == s[*n - 1]) {
	s_stop("SEGSPL:  Last  input point duplicated", (ftnlen)37);
    }

    iseg0 = 1;
    i__1 = *n - 2;
    for (iseg = 2; iseg <= i__1; ++iseg) {
	if (s[iseg] == s[iseg + 1]) {
	    nseg = iseg - iseg0 + 1;
	    splind_(&x[iseg0], &xs[iseg0], &s[iseg0], &nseg, xs1, xs2);
	    iseg0 = iseg + 1;
	}
/* L10: */
    }

    nseg = *n - iseg0 + 1;
    splind_(&x[iseg0], &xs[iseg0], &s[iseg0], &nseg, xs1, xs2);

    return 0;
} /* segspld_ */
