/* f/xgeom.f -- translated by f2c (version 20100827).
   You must link the resulting object file with libf2c:
	on Microsoft Windows system, link with libf2c.lib;
	on Linux or Unix systems, link with .../path/to/libf2c.a -lm
	or, if you install libf2c.a in a standard place, with -lf2c -lm
	-- in that order, at the end of the command line, as in
		cc *.o -lf2c -lm
	Source for libf2c is in /netlib/f2c/libf2c.zip, e.g.,

		http://www.netlib.org/f2c/libf2c.zip
*/

#include "f2c.h"

/* Table of constant values */

static int c__9 = 9;
static int c__1 = 1;
static int c__2 = 2;
static real c_b40 = 1.f;
static real c_b79 = .14f;
static int c_n3 = -3;
static real c_b82 = 0.f;
static int c__3 = 3;
static int c__16 = 16;
static int c__5 = 5;
static int c__0 = 0;
static int c__4 = 4;

/* *********************************************************************** */
/*    Module:  xgeom.f */

/*    Copyright (C) 2000 Mark Drela */

/*    This program is free software; you can redistribute it and/or modify */
/*    it under the terms of the GNU General Public License as published by */
/*    the Free Software Foundation; either version 2 of the License, or */
/*    (at your option) any later version. */

/*    This program is distributed in the hope that it will be useful, */
/*    but WITHOUT ANY WARRANTY; without even the implied warranty of */
/*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the */
/*    GNU General Public License for more details. */

/*    You should have received a copy of the GNU General Public License */
/*    along with this program; if not, write to the Free Software */
/*    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */
/* *********************************************************************** */
/* Subroutine */ int lefind_(real *sle, real *x, real *xp, real *y, real *yp, 
	real *s, int *n)
{
    /* System generated locals */
    int i__1;
    real r__1, r__2, r__3;

    /* Builtin functions */
    int s_wsle(cilist *), do_lio(int *, int *, char *, ftnlen), 
	    e_wsle(void);

    /* Local variables */
    static int i__;
    static real dx, dy, xle, yle, res, xte, yte, dxdd, dydd, dsle, dxds;
    static int iter;
    static real dxte, dyte, dotp, dyds, ress;
    extern doublereal d2val_(real *, real *, real *, real *, int *), 
	    deval_(real *, real *, real *, real *, int *), seval_(real *, 
	    real *, real *, real *, int *);
    static real dseps, xchord, ychord;

    /* Fortran I/O blocks */
    static cilist io___22 = { 0, 6, 0, 0, 0 };


/* ------------------------------------------------------ */
/*     Locates leading edge spline-parameter value SLE */

/*     The defining condition is */

/*      (X-XTE,Y-YTE) . (X',Y') = 0     at  S = SLE */

/*     i.e. the surface tangent is normal to the chord */
/*     line connecting X(SLE),Y(SLE) and the TE point. */
/* ------------------------------------------------------ */

/* ---- convergence tolerance */
    /* Parameter adjustments */
    --s;
    --yp;
    --y;
    --xp;
    --x;

    /* Function Body */
    dseps = (s[*n] - s[1]) * 1e-5f;

/* ---- set trailing edge point coordinates */
    xte = (x[1] + x[*n]) * .5f;
    yte = (y[1] + y[*n]) * .5f;

/* ---- get first guess for SLE */
    i__1 = *n - 2;
    for (i__ = 3; i__ <= i__1; ++i__) {
	dxte = x[i__] - xte;
	dyte = y[i__] - yte;
	dx = x[i__ + 1] - x[i__];
	dy = y[i__ + 1] - y[i__];
	dotp = dxte * dx + dyte * dy;
	if (dotp < 0.f) {
	    goto L11;
	}
/* L10: */
    }

L11:
    *sle = s[i__];

/* ---- check for sharp LE case */
    if (s[i__] == s[i__ - 1]) {
/* cc        WRITE(*,*) 'Sharp LE found at ',I,SLE */
	return 0;
    }

/* ---- Newton iteration to get exact SLE value */
    for (iter = 1; iter <= 50; ++iter) {
	xle = seval_(sle, &x[1], &xp[1], &s[1], n);
	yle = seval_(sle, &y[1], &yp[1], &s[1], n);
	dxds = deval_(sle, &x[1], &xp[1], &s[1], n);
	dyds = deval_(sle, &y[1], &yp[1], &s[1], n);
	dxdd = d2val_(sle, &x[1], &xp[1], &s[1], n);
	dydd = d2val_(sle, &y[1], &yp[1], &s[1], n);

	xchord = xle - xte;
	ychord = yle - yte;

/* ------ drive dot product between chord line and LE tangent to zero */
	res = xchord * dxds + ychord * dyds;
	ress = dxds * dxds + dyds * dyds + xchord * dxdd + ychord * dydd;

/* ------ Newton delta for SLE */
	dsle = -res / ress;

/* Computing MAX */
	r__2 = dsle, r__3 = (r__1 = xchord + ychord, dabs(r__1)) * -.02f;
	dsle = dmax(r__2,r__3);
/* Computing MIN */
	r__2 = dsle, r__3 = (r__1 = xchord + ychord, dabs(r__1)) * .02f;
	dsle = dmin(r__2,r__3);
	*sle += dsle;
	if (dabs(dsle) < dseps) {
	    return 0;
	}
/* L20: */
    }
    s_wsle(&io___22);
    do_lio(&c__9, &c__1, "LEFIND:  LE point not found.  Continuing...", (
	    ftnlen)43);
    e_wsle();
    *sle = s[i__];
    return 0;
} /* lefind_ */

/* Subroutine */ int xlfind_(real *sle, real *x, real *xp, real *y, real *yp, 
	real *s, int *n)
{
    /* System generated locals */
    int i__1;
    real r__1, r__2;

    /* Builtin functions */
    int s_wsle(cilist *), do_lio(int *, int *, char *, ftnlen), 
	    e_wsle(void);

    /* Local variables */
    static int i__;
    static real dx, res, dxdd, dsle, dxds;
    static int iter;
    static real ress;
    extern doublereal d2val_(real *, real *, real *, real *, int *), 
	    deval_(real *, real *, real *, real *, int *);
    static real dslen, dseps;

    /* Fortran I/O blocks */
    static cilist io___33 = { 0, 6, 0, 0, 0 };


/* ------------------------------------------------------ */
/*     Locates leftmost (minimum x) point location SLE */

/*     The defining condition is */

/*      X' = 0     at  S = SLE */

/*     i.e. the surface tangent is vertical */
/* ------------------------------------------------------ */

    /* Parameter adjustments */
    --s;
    --yp;
    --y;
    --xp;
    --x;

    /* Function Body */
    dslen = s[*n] - s[1];

/* ---- convergence tolerance */
    dseps = (s[*n] - s[1]) * 1e-5f;

/* ---- get first guess for SLE */
    i__1 = *n - 2;
    for (i__ = 3; i__ <= i__1; ++i__) {
	dx = x[i__ + 1] - x[i__];
	if (dx > 0.f) {
	    goto L11;
	}
/* L10: */
    }

L11:
    *sle = s[i__];

/* ---- check for sharp LE case */
    if (s[i__] == s[i__ - 1]) {
/* cc        WRITE(*,*) 'Sharp LE found at ',I,SLE */
	return 0;
    }

/* ---- Newton iteration to get exact SLE value */
    for (iter = 1; iter <= 50; ++iter) {
	dxds = deval_(sle, &x[1], &xp[1], &s[1], n);
	dxdd = d2val_(sle, &x[1], &xp[1], &s[1], n);

/* ------ drive DXDS to zero */
	res = dxds;
	ress = dxdd;

/* ------ Newton delta for SLE */
	dsle = -res / ress;

/* Computing MAX */
	r__1 = dsle, r__2 = dabs(dslen) * -.01f;
	dsle = dmax(r__1,r__2);
/* Computing MIN */
	r__1 = dsle, r__2 = dabs(dslen) * .01f;
	dsle = dmin(r__1,r__2);
	*sle += dsle;
	if (dabs(dsle) < dseps) {
	    return 0;
	}
/* L20: */
    }
    s_wsle(&io___33);
    do_lio(&c__9, &c__1, "XLFIND:  Left point not found.  Continuing...", (
	    ftnlen)45);
    e_wsle();
    *sle = s[i__];
    return 0;
} /* xlfind_ */

/* Subroutine */ int nsfind_(real *sle, real *x, real *xp, real *y, real *yp, 
	real *s, int *n)
{
    /* System generated locals */
    int i__1;
    real r__1;

    /* Builtin functions */
    /* Subroutine */ int s_stop(char *, ftnlen);

    /* Local variables */
    static real a[500], b[500], c__[500];
    static int i__, im;
    static real ds, cv[500];
    static int ip;
    static real dsm, dso, dsp, cvs, cvsm, cvsp, cvss;
    extern doublereal curv_(real *, real *, real *, real *, real *, real *, 
	    int *);
    static real cvmax;
    static int ivmax;
    static real smool;
    extern /* Subroutine */ int trisol_(real *, real *, real *, real *, 
	    int *);
    static real smoosq;

/* ---------------------------------------------------------- */
/*     Finds "nose" of airfoil where curvature is a maximum */
/* ---------------------------------------------------------- */


    /* Parameter adjustments */
    --s;
    --yp;
    --y;
    --xp;
    --x;

    /* Function Body */
    if (*n > 500) {
	s_stop("NSFIND: Local array overflow. Increase NMAX.", (ftnlen)44);
    }

/* ---- set up curvature array */
    i__1 = *n;
    for (i__ = 1; i__ <= i__1; ++i__) {
	cv[i__ - 1] = curv_(&s[i__], &x[1], &xp[1], &y[1], &yp[1], &s[1], n);
/* L3: */
    }

/* ---- curvature smoothing length */
    smool = (s[*n] - s[1]) * .006f;

/* ---- set up tri-diagonal system for smoothed curvatures */
/* Computing 2nd power */
    r__1 = smool;
    smoosq = r__1 * r__1;
    a[0] = 1.f;
    c__[0] = 0.f;
    i__1 = *n - 1;
    for (i__ = 2; i__ <= i__1; ++i__) {
	dsm = s[i__] - s[i__ - 1];
	dsp = s[i__ + 1] - s[i__];
	dso = (s[i__ + 1] - s[i__ - 1]) * .5f;

	if (dsm == 0.f || dsp == 0.f) {
/* ------- leave curvature at corner point unchanged */
	    b[i__ - 1] = 0.f;
	    a[i__ - 1] = 1.f;
	    c__[i__ - 1] = 0.f;
	} else {
	    b[i__ - 1] = smoosq * (-1.f / dsm) / dso;
	    a[i__ - 1] = smoosq * (1.f / dsp + 1.f / dsm) / dso + 1.f;
	    c__[i__ - 1] = smoosq * (-1.f / dsp) / dso;
	}
/* L4: */
    }
    b[*n - 1] = 0.f;
    a[*n - 1] = 1.f;

    trisol_(a, b, c__, cv, n);

/* ---- find max curvature index */
    cvmax = 0.f;
    ivmax = 0;
    i__1 = *n - 1;
    for (i__ = 2; i__ <= i__1; ++i__) {
	if ((r__1 = cv[i__ - 1], dabs(r__1)) > cvmax) {
	    cvmax = (r__1 = cv[i__ - 1], dabs(r__1));
	    ivmax = i__;
	}
/* L71: */
    }

/* ---- fit a parabola to the curvature at the three points near maximum */
    i__ = ivmax;

    ip = i__ + 1;
    im = i__ - 1;
    if (s[i__] == s[ip]) {
	ip = i__ + 2;
    }
    if (s[i__] == s[im]) {
	im = i__ - 2;
    }
    dsm = s[i__] - s[im];
    dsp = s[ip] - s[i__];

    cvsm = (cv[i__ - 1] - cv[im - 1]) / dsm;
    cvsp = (cv[ip - 1] - cv[i__ - 1]) / dsp;

/* ---- 1st and 2nd derivatives at i=IVMAX */
    cvs = (cvsm * dsp + cvsp * dsm) / (dsp + dsm);
    cvss = (cvsp - cvsm) * 2.f / (dsp + dsm);

/* ---- set location of arc length at maximum of parabola */
    ds = -cvs / cvss;
    *sle = s[i__] + ds;

    return 0;
} /* nsfind_ */

/* Subroutine */ int sopps_(real *sopp, real *si, real *x, real *xp, real *y, 
	real *yp, real *s, int *n, real *sle)
{
    /* System generated locals */
    real r__1, r__2;

    /* Builtin functions */
    double sqrt(doublereal);
    int s_wsle(cilist *), do_lio(int *, int *, char *, ftnlen), 
	    e_wsle(void);

    /* Local variables */
    static int in;
    static real xi, yi, dxc, dyc, xle, yle, res, xte, yte, xbar, resd, slen;
    static int iter;
    static real xopp, yopp;
    extern doublereal deval_(real *, real *, real *, real *, int *);
    static real sfrac, chord;
    extern doublereal seval_(real *, real *, real *, real *, int *);
    static int inopp;
    static real dsopp, xoppd, yoppd;

    /* Fortran I/O blocks */
    static cilist io___75 = { 0, 6, 0, 0, 0 };


/* -------------------------------------------------- */
/*     Calculates arc length SOPP of point */
/*     which is opposite of point SI, on the */
/*     other side of the airfoil baseline */
/* -------------------------------------------------- */

/* ---- reference length for testing convergence */
    /* Parameter adjustments */
    --s;
    --yp;
    --y;
    --xp;
    --x;

    /* Function Body */
    slen = s[*n] - s[1];

/* ---- set chordline vector */
    xle = seval_(sle, &x[1], &xp[1], &s[1], n);
    yle = seval_(sle, &y[1], &yp[1], &s[1], n);
    xte = (x[1] + x[*n]) * .5f;
    yte = (y[1] + y[*n]) * .5f;
/* Computing 2nd power */
    r__1 = xte - xle;
/* Computing 2nd power */
    r__2 = yte - yle;
    chord = sqrt(r__1 * r__1 + r__2 * r__2);
    dxc = (xte - xle) / chord;
    dyc = (yte - yle) / chord;

    if (*si < *sle) {
	in = 1;
	inopp = *n;
    } else {
	in = *n;
	inopp = 1;
    }
    sfrac = (*si - *sle) / (s[in] - *sle);
    *sopp = *sle + sfrac * (s[inopp] - *sle);

    if (dabs(sfrac) <= 1e-5f) {
	*sopp = *sle;
	return 0;
    }

/* ---- XBAR = x coordinate in chord-line axes */
    xi = seval_(si, &x[1], &xp[1], &s[1], n);
    yi = seval_(si, &y[1], &yp[1], &s[1], n);
    xle = seval_(sle, &x[1], &xp[1], &s[1], n);
    yle = seval_(sle, &y[1], &yp[1], &s[1], n);
    xbar = (xi - xle) * dxc + (yi - yle) * dyc;

/* ---- converge on exact opposite point with same XBAR value */
    for (iter = 1; iter <= 12; ++iter) {
	xopp = seval_(sopp, &x[1], &xp[1], &s[1], n);
	yopp = seval_(sopp, &y[1], &yp[1], &s[1], n);
	xoppd = deval_(sopp, &x[1], &xp[1], &s[1], n);
	yoppd = deval_(sopp, &y[1], &yp[1], &s[1], n);

	res = (xopp - xle) * dxc + (yopp - yle) * dyc - xbar;
	resd = xoppd * dxc + yoppd * dyc;

	if (dabs(res) / slen < 1e-5f) {
	    goto L305;
	}
	if (resd == 0.f) {
	    goto L303;
	}

	dsopp = -res / resd;
	*sopp += dsopp;

	if (dabs(dsopp) / slen < 1e-5f) {
	    goto L305;
	}
/* L300: */
    }
L303:
    s_wsle(&io___75);
    do_lio(&c__9, &c__1, "SOPPS: Opposite-point location failed. Continuing."
	    "..", (ftnlen)52);
    e_wsle();
    *sopp = *sle + sfrac * (s[inopp] - *sle);

L305:
    return 0;
} /* sopps_ */

/* Subroutine */ int norm_(real *x, real *xp, real *y, real *yp, real *s, 
	int *n)
{
    /* System generated locals */
    int i__1;

    /* Local variables */
    static int i__;
    static real sle, xmin, xmax, ymin;
    extern /* Subroutine */ int scalc_(real *, real *, real *, int *);
    static real fudge;
    extern doublereal seval_(real *, real *, real *, real *, int *);
    extern /* Subroutine */ int lefind_(real *, real *, real *, real *, real *
	    , real *, int *), segspl_(real *, real *, real *, int *);

/* ----------------------------------------------- */
/*     Scales coordinates to get unit chord */
/* ----------------------------------------------- */

    /* Parameter adjustments */
    --s;
    --yp;
    --y;
    --xp;
    --x;

    /* Function Body */
    scalc_(&x[1], &y[1], &s[1], n);
    segspl_(&x[1], &xp[1], &s[1], n);
    segspl_(&y[1], &yp[1], &s[1], n);

    lefind_(&sle, &x[1], &xp[1], &y[1], &yp[1], &s[1], n);

    xmax = (x[1] + x[*n]) * .5f;
    xmin = seval_(&sle, &x[1], &xp[1], &s[1], n);
    ymin = seval_(&sle, &y[1], &yp[1], &s[1], n);

    fudge = 1.f / (xmax - xmin);
    i__1 = *n;
    for (i__ = 1; i__ <= i__1; ++i__) {
	x[i__] = (x[i__] - xmin) * fudge;
	y[i__] = (y[i__] - ymin) * fudge;
	s[i__] *= fudge;
/* L40: */
    }

    return 0;
} /* norm_ */

/* Subroutine */ int geopar_(real *x, real *xp, real *y, real *yp, real *s, 
	int *n, real *t, real *sle, real *chord, real *area, real *radle, 
	real *angte, real *ei11a, real *ei22a, real *apx1a, real *apx2a, real 
	*ei11t, real *ei22t, real *apx1t, real *apx2t, real *thick, real *
	cambr)
{
    /* Format strings */
    static char fmt_1000[] = "(\002 Max thickness = \002,f12.6,\002  at x ="
	    " \002,f7.3,/\002 Max camber    = \002,f12.6,\002  at x = \002,f7"
	    ".3)";

    /* System generated locals */
    int i__1;
    real r__1, r__2;

    /* Builtin functions */
    double sqrt(doublereal), atan2(doublereal, doublereal);
    int s_wsfe(cilist *), do_fio(int *, char *, ftnlen), e_wsfe(void);

    /* Local variables */
    static int i__;
    static real xle, yle, xte, yte, ang1, ang2, chsq, slen;
    extern doublereal curv_(real *, real *, real *, real *, real *, real *, 
	    int *), atanc_(real *, real *, real *);
    static real xcena, ycena;
    extern doublereal seval_(real *, real *, real *, real *, int *);
    static real xcent, ycent;
    extern /* Subroutine */ int aecalc_(int *, real *, real *, real *, 
	    int *, real *, real *, real *, real *, real *, real *, real *)
	    , tccalc_(real *, real *, real *, real *, real *, int *, real 
	    *, real *, real *, real *), lefind_(real *, real *, real *, real *
	    , real *, real *, int *);
    static real xcambr, xthick, curvle;

    /* Fortran I/O blocks */
    static cilist io___98 = { 0, 6, 0, fmt_1000, 0 };



/* ------------------------------------------------------ */
/*     Sets geometric parameters for airfoil shape */
/* ------------------------------------------------------ */
    /* Parameter adjustments */
    --t;
    --s;
    --yp;
    --y;
    --xp;
    --x;

    /* Function Body */
    lefind_(sle, &x[1], &xp[1], &y[1], &yp[1], &s[1], n);

    xle = seval_(sle, &x[1], &xp[1], &s[1], n);
    yle = seval_(sle, &y[1], &yp[1], &s[1], n);
    xte = (x[1] + x[*n]) * .5f;
    yte = (y[1] + y[*n]) * .5f;

/* Computing 2nd power */
    r__1 = xte - xle;
/* Computing 2nd power */
    r__2 = yte - yle;
    chsq = r__1 * r__1 + r__2 * r__2;
    *chord = sqrt(chsq);

    curvle = curv_(sle, &x[1], &xp[1], &y[1], &yp[1], &s[1], n);

    *radle = 0.f;
    if (dabs(curvle) > (s[*n] - s[1]) * .001f) {
	*radle = 1.f / curvle;
    }

    ang1 = atan2(-yp[1], -xp[1]);
    ang2 = atanc_(&yp[*n], &xp[*n], &ang1);
    *angte = ang2 - ang1;

    i__1 = *n;
    for (i__ = 1; i__ <= i__1; ++i__) {
	t[i__] = 1.f;
    }

    aecalc_(n, &x[1], &y[1], &t[1], &c__1, area, &xcena, &ycena, ei11a, ei22a,
	     apx1a, apx2a);

    aecalc_(n, &x[1], &y[1], &t[1], &c__2, &slen, &xcent, &ycent, ei11t, 
	    ei22t, apx1t, apx2t);

/* --- Old, approximate thickness,camber routine (on discrete points only) */
    tccalc_(&x[1], &xp[1], &y[1], &yp[1], &s[1], n, thick, &xthick, cambr, &
	    xcambr);

/* --- More accurate thickness and camber estimates */
/* c      CALL GETCAM(XCAM,YCAM,NCAM,XTHK,YTHK,NTHK, */
/* c     &            X,XP,Y,YP,S,N ) */
/* c      CALL GETMAX(XCAM,YCAM,YCAMP,NCAM,XCAMBR,CAMBR) */
/* c      CALL GETMAX(XTHK,YTHK,YTHKP,NTHK,XTHICK,THICK) */
/* c      THICK = 2.0*THICK */

    s_wsfe(&io___98);
    do_fio(&c__1, (char *)&(*thick), (ftnlen)sizeof(real));
    do_fio(&c__1, (char *)&xthick, (ftnlen)sizeof(real));
    do_fio(&c__1, (char *)&(*cambr), (ftnlen)sizeof(real));
    do_fio(&c__1, (char *)&xcambr, (ftnlen)sizeof(real));
    e_wsfe();

    return 0;
} /* geopar_ */

/* Subroutine */ int aecalc_(int *n, real *x, real *y, real *t, int *
	itype, real *area, real *xcen, real *ycen, real *ei11, real *ei22, 
	real *apx1, real *apx2)
{
    /* Initialized data */

    static real pi = 3.141592653589793238f;

    /* System generated locals */
    int i__1;
    real r__1, r__2;

    /* Builtin functions */
    double sqrt(doublereal), atan2(doublereal, doublereal), r_sign(real *, 
	    real *);

    /* Local variables */
    static real c1, c2, s1, s2, da, ta, ds;
    static int io, ip;
    static real xa, dx, dy, ya, sgn, aint, eisq, sint, eixx, eixy, eiyy, xint,
	     yint, xxint, xyint, yyint;

/* --------------------------------------------------------------- */
/*     Calculates geometric properties of shape X,Y */

/*     Input: */
/*       N      number of points */
/*       X(.)   shape coordinate point arrays */
/*       Y(.) */
/*       T(.)   skin-thickness array, used only if ITYPE = 2 */
/*       ITYPE  = 1 ...   integration is over whole area  dx dy */
/*              = 2 ...   integration is over skin  area   t ds */

/*     Output: */
/*       XCEN,YCEN  centroid location */
/*       EI11,EI22  principal moments of inertia */
/*       APX1,APX2  principal-axis angles */
/* --------------------------------------------------------------- */
    /* Parameter adjustments */
    --t;
    --y;
    --x;

    /* Function Body */

    sint = 0.f;
    aint = 0.f;
    xint = 0.f;
    yint = 0.f;
    xxint = 0.f;
    xyint = 0.f;
    yyint = 0.f;

    i__1 = *n;
    for (io = 1; io <= i__1; ++io) {
	if (io == *n) {
	    ip = 1;
	} else {
	    ip = io + 1;
	}

	dx = x[io] - x[ip];
	dy = y[io] - y[ip];
	xa = (x[io] + x[ip]) * .5f;
	ya = (y[io] + y[ip]) * .5f;
	ta = (t[io] + t[ip]) * .5f;

	ds = sqrt(dx * dx + dy * dy);
	sint += ds;
	if (*itype == 1) {
/* -------- integrate over airfoil cross-section */
	    da = ya * dx;
	    aint += da;
	    xint += xa * da;
	    yint += ya * da / 2.f;
	    xxint += xa * xa * da;
	    xyint += xa * ya * da / 2.f;
	    yyint += ya * ya * da / 3.f;
	} else {
/* -------- integrate over skin thickness */
	    da = ta * ds;
	    aint += da;
	    xint += xa * da;
	    yint += ya * da;
	    xxint += xa * xa * da;
	    xyint += xa * ya * da;
	    yyint += ya * ya * da;
	}

/* L10: */
    }

    *area = aint;

    if (aint == 0.f) {
	*xcen = 0.f;
	*ycen = 0.f;
	*ei11 = 0.f;
	*ei22 = 0.f;
	*apx1 = 0.f;
	*apx2 = atan2(1.f, 0.f);
	return 0;
    }


/* ---- calculate centroid location */
    *xcen = xint / aint;
    *ycen = yint / aint;

/* ---- calculate inertias */
    eixx = yyint - *ycen * *ycen * aint;
    eixy = xyint - *xcen * *ycen * aint;
    eiyy = xxint - *xcen * *xcen * aint;

/* ---- set principal-axis inertias, EI11 is closest to "up-down" bending inertia */
/* Computing 2nd power */
    r__1 = eixx - eiyy;
/* Computing 2nd power */
    r__2 = eixy;
    eisq = r__1 * r__1 * .25f + r__2 * r__2;
    r__1 = eiyy - eixx;
    sgn = r_sign(&c_b40, &r__1);
    *ei11 = (eixx + eiyy) * .5f - sgn * sqrt(eisq);
    *ei22 = (eixx + eiyy) * .5f + sgn * sqrt(eisq);

    if (*ei11 == 0.f || *ei22 == 0.f) {
/* ----- vanishing section stiffness */
	*apx1 = 0.f;
	*apx2 = atan2(1.f, 0.f);

    } else /* if(complicated condition) */ {
/* Computing 4th power */
	r__1 = sint * .001f, r__1 *= r__1;
	if (eisq / (*ei11 * *ei22) < r__1 * r__1) {
/* ----- rotationally-invariant section (circle, square, etc.) */
	    *apx1 = 0.f;
	    *apx2 = atan2(1.f, 0.f);

	} else {
/* ----- normal airfoil section */
	    c1 = eixy;
	    s1 = eixx - *ei11;

	    c2 = eixy;
	    s2 = eixx - *ei22;

	    if (dabs(s1) > dabs(s2)) {
		*apx1 = atan2(s1, c1);
		*apx2 = *apx1 + pi * .5f;
	    } else {
		*apx2 = atan2(s2, c2);
		*apx1 = *apx2 - pi * .5f;
	    }
	    if (*apx1 < pi * -.5f) {
		*apx1 += pi;
	    }
	    if (*apx1 > pi * .5f) {
		*apx1 -= pi;
	    }
	    if (*apx2 < pi * -.5f) {
		*apx2 += pi;
	    }
	    if (*apx2 > pi * .5f) {
		*apx2 -= pi;
	    }

	}
    }

    return 0;
} /* aecalc_ */

/* Subroutine */ int tccalc_(real *x, real *xp, real *y, real *yp, real *s, 
	int *n, real *thick, real *xthick, real *cambr, real *xcambr)
{
    /* System generated locals */
    int i__1;
    real r__1, r__2;

    /* Builtin functions */
    double sqrt(doublereal);

    /* Local variables */
    static int i__;
    static real yc, yt, dxc, dyc, sle, xle, yle, xte, yte, xbar, ybar, sopp, 
	    xopp, yopp, chord;
    extern doublereal seval_(real *, real *, real *, real *, int *);
    extern /* Subroutine */ int sopps_(real *, real *, real *, real *, real *,
	     real *, real *, int *, real *), lefind_(real *, real *, real 
	    *, real *, real *, real *, int *);
    static real ybarop;

/* --------------------------------------------------------------- */
/*     Calculates max thickness and camber at airfoil points */

/*     Note: this routine does not find the maximum camber or */
/*           thickness exactly as it only looks at discrete points */

/*     Input: */
/*       N      number of points */
/*       X(.)   shape coordinate point arrays */
/*       Y(.) */

/*     Output: */
/*       THICK  max thickness */
/*       CAMBR  max camber */
/* --------------------------------------------------------------- */
    /* Parameter adjustments */
    --s;
    --yp;
    --y;
    --xp;
    --x;

    /* Function Body */
    lefind_(&sle, &x[1], &xp[1], &y[1], &yp[1], &s[1], n);
    xle = seval_(&sle, &x[1], &xp[1], &s[1], n);
    yle = seval_(&sle, &y[1], &yp[1], &s[1], n);
    xte = (x[1] + x[*n]) * .5f;
    yte = (y[1] + y[*n]) * .5f;
/* Computing 2nd power */
    r__1 = xte - xle;
/* Computing 2nd power */
    r__2 = yte - yle;
    chord = sqrt(r__1 * r__1 + r__2 * r__2);

/* ---- set unit chord-line vector */
    dxc = (xte - xle) / chord;
    dyc = (yte - yle) / chord;

    *thick = 0.f;
    *xthick = 0.f;
    *cambr = 0.f;
    *xcambr = 0.f;

/* ---- go over each point, finding the y-thickness and camber */
    i__1 = *n;
    for (i__ = 1; i__ <= i__1; ++i__) {
	xbar = (x[i__] - xle) * dxc + (y[i__] - yle) * dyc;
	ybar = (y[i__] - yle) * dxc - (x[i__] - xle) * dyc;

/* ------ set point on the opposite side with the same chord x value */
	sopps_(&sopp, &s[i__], &x[1], &xp[1], &y[1], &yp[1], &s[1], n, &sle);
	xopp = seval_(&sopp, &x[1], &xp[1], &s[1], n);
	yopp = seval_(&sopp, &y[1], &yp[1], &s[1], n);

	ybarop = (yopp - yle) * dxc - (xopp - xle) * dyc;

	yc = (ybar + ybarop) * .5f;
	yt = (r__1 = ybar - ybarop, dabs(r__1));

	if (dabs(yc) > dabs(*cambr)) {
	    *cambr = yc;
	    *xcambr = xopp;
	}
	if (dabs(yt) > dabs(*thick)) {
	    *thick = yt;
	    *xthick = xopp;
	}
/* L30: */
    }

    return 0;
} /* tccalc_ */

/* Subroutine */ int ysym_(real *x, real *xp, real *y, real *yp, real *s, 
	int *nx, int *n, int *iside, real *xnew, real *ynew)
{
    /* System generated locals */
    int i__1, i__2;
    real r__1, r__2;

    /* Builtin functions */
    double sqrt(doublereal);
    /* Subroutine */ int s_stop(char *, ftnlen);

    /* Local variables */
    static int i__, i1, i2, ig;
    static real ds;
    static int ig1, ig2, ile;
    static real dxc, dyc, sle, xle, yle, xte, yte;
    static int ile1, ile2;
    static real xbar, ybar, chsq, sref;
    static int nnew;
    extern /* Subroutine */ int scalc_(real *, real *, real *, int *);
    static int igdir;
    extern doublereal seval_(real *, real *, real *, real *, int *);
    extern /* Subroutine */ int lefind_(real *, real *, real *, real *, real *
	    , real *, int *), segspl_(real *, real *, real *, int *);

/* --------------------------------------------------------- */
/*     Makes passed-in airfoil symmetric about chord line. */
/* --------------------------------------------------------- */

    /* Parameter adjustments */
    --ynew;
    --xnew;
    --s;
    --yp;
    --y;
    --xp;
    --x;

    /* Function Body */
    sref = s[*n] - s[1];

    lefind_(&sle, &x[1], &xp[1], &y[1], &yp[1], &s[1], n);
    xle = seval_(&sle, &x[1], &xp[1], &s[1], n);
    yle = seval_(&sle, &y[1], &yp[1], &s[1], n);
    xte = (x[1] + x[*n]) * .5f;
    yte = (y[1] + y[*n]) * .5f;
/* Computing 2nd power */
    r__1 = xte - xle;
/* Computing 2nd power */
    r__2 = yte - yle;
    chsq = r__1 * r__1 + r__2 * r__2;

/* ---- set unit chord-line vector */
    dxc = (xte - xle) / sqrt(chsq);
    dyc = (yte - yle) / sqrt(chsq);

/* ---- find index of node ILE which is just before leading edge point */
    i__1 = *n;
    for (i__ = 2; i__ <= i__1; ++i__) {
	ds = s[i__] - s[i__ - 1];
	if (s[i__] - sle >= ds * -.01f) {
	    goto L6;
	}
/* L5: */
    }
L6:
    ile = i__ - 1;

    ds = s[ile + 1] - s[ile];
    if (sle - s[ile - 1] < ds * .1f) {
/* ------ point is just before LE, we will move it ahead to LE */
	ile1 = ile - 1;
	ile2 = ile + 1;
    } else if (s[ile + 1] - sle < ds * .1f) {
/* ------ point is just after LE, we will move it back to LE */
	ile1 = ile;
	ile2 = ile + 2;
    } else {
/* ------ no point is near LE ... we will add new point */
	ile1 = ile;
	ile2 = ile + 1;
    }

/* ---- set index limits of side which will set symmetric geometry */
    if (*iside == 1) {
	ig1 = 1;
	ig2 = ile1;
	igdir = 1;
    } else {
	ig1 = *n;
	ig2 = ile2;
	igdir = -1;
    }

/* ---- set new number of points, including LE point */
    nnew = ((i__1 = ig2 - ig1, abs(i__1)) + 1 << 1) + 1;
    if (nnew > *nx) {
	s_stop("YSYM:  Array overflow on passed arrays.", (ftnlen)39);
    }

/* ---- set symmetric geometry */
    i__1 = ig2;
    i__2 = igdir;
    for (i__ = ig1; i__2 < 0 ? i__ >= i__1 : i__ <= i__1; i__ += i__2) {

/* ------ coordinates in chord-line axes */
	xbar = (x[i__] - xle) * dxc + (y[i__] - yle) * dyc;
	ybar = (y[i__] - yle) * dxc - (x[i__] - xle) * dyc;

	i1 = (i__ - ig1) * igdir + 1;
	i2 = nnew - (i__ - ig1) * igdir;

	xnew[i1] = xle + xbar * dxc - ybar * dyc;
	xnew[i2] = xle + xbar * dxc + ybar * dyc;

	ynew[i1] = yle + ybar * dxc + xbar * dyc;
	ynew[i2] = yle - ybar * dxc + xbar * dyc;
/* L10: */
    }

/* ---- set new LE point */
    xnew[nnew / 2 + 1] = xle;
    ynew[nnew / 2 + 1] = yle;

/* ---- set geometry for returning */
    *n = nnew;
    i__2 = *n;
    for (ig = 1; ig <= i__2; ++ig) {
	if (igdir == 1) {
	    i__ = ig;
	} else {
	    i__ = *n - ig + 1;
	}
	x[i__] = xnew[ig];
	y[i__] = ynew[ig];
/* L20: */
    }

    scalc_(&x[1], &y[1], &s[1], n);
    segspl_(&x[1], &xp[1], &s[1], n);
    segspl_(&y[1], &yp[1], &s[1], n);

    return 0;
} /* ysym_ */

/* Subroutine */ int lerscl_(real *x, real *xp, real *y, real *yp, real *s, 
	int *n, real *doc, real *rfac, real *xnew, real *ynew)
{
    /* System generated locals */
    int i__1;
    real r__1, r__2;

    /* Builtin functions */
    double sqrt(doublereal), exp(doublereal);

    /* Local variables */
    static int i__;
    static real arg, dxc, dyc, sle, xle, yle, xoc, xte, yte, tfac, xbar, ybar,
	     sopp, xopp, yopp, srfac, chord;
    extern doublereal seval_(real *, real *, real *, real *, int *);
    extern /* Subroutine */ int sopps_(real *, real *, real *, real *, real *,
	     real *, real *, int *, real *), lefind_(real *, real *, real 
	    *, real *, real *, real *, int *);
    static real ybarct, ybarop;

/* --------------------------------------------------------- */
/*     Adjusts airfoil to scale LE radius by factor RFAC. */
/*     Blending of new shape is done with decay length DOC. */
/* --------------------------------------------------------- */

    /* Parameter adjustments */
    --ynew;
    --xnew;
    --s;
    --yp;
    --y;
    --xp;
    --x;

    /* Function Body */
    lefind_(&sle, &x[1], &xp[1], &y[1], &yp[1], &s[1], n);
    xle = seval_(&sle, &x[1], &xp[1], &s[1], n);
    yle = seval_(&sle, &y[1], &yp[1], &s[1], n);
    xte = (x[1] + x[*n]) * .5f;
    yte = (y[1] + y[*n]) * .5f;
/* Computing 2nd power */
    r__1 = xte - xle;
/* Computing 2nd power */
    r__2 = yte - yle;
    chord = sqrt(r__1 * r__1 + r__2 * r__2);

/* ---- set unit chord-line vector */
    dxc = (xte - xle) / chord;
    dyc = (yte - yle) / chord;

    srfac = sqrt((dabs(*rfac)));

/* ---- go over each point, changing the y-thickness appropriately */
    i__1 = *n;
    for (i__ = 1; i__ <= i__1; ++i__) {
	xbar = (x[i__] - xle) * dxc + (y[i__] - yle) * dyc;
	ybar = (y[i__] - yle) * dxc - (x[i__] - xle) * dyc;

/* ------ set point on the opposite side with the same chord x value */
	sopps_(&sopp, &s[i__], &x[1], &xp[1], &y[1], &yp[1], &s[1], n, &sle);
	xopp = seval_(&sopp, &x[1], &xp[1], &s[1], n);
	yopp = seval_(&sopp, &y[1], &yp[1], &s[1], n);

	ybarop = (yopp - yle) * dxc - (xopp - xle) * dyc;

/* ------ thickness factor tails off exponentially towards trailing edge */
	xoc = xbar / chord;
/* Computing MIN */
	r__1 = xoc / *doc;
	arg = dmin(r__1,15.f);
	tfac = 1.f - (1.f - srfac) * exp(-arg);

/* ------ set new chord x,y coordinates by changing thickness locally */
	ybarct = (ybar + ybarop) * .5f + tfac * .5f * (ybar - ybarop);

	xnew[i__] = xle + xbar * dxc - ybarct * dyc;
	ynew[i__] = yle + ybarct * dxc + xbar * dyc;
/* L30: */
    }

    return 0;
} /* lerscl_ */

/* Subroutine */ int sss_(real *ss, real *s1, real *s2, real *del, real *xbf, 
	real *ybf, real *x, real *xp, real *y, real *yp, real *s, int *n, 
	int *iside)
{
    /* Initialized data */

    static real eps = 1e-5f;

    /* System generated locals */
    real r__1, r__2;

    /* Builtin functions */
    double sin(doublereal), sqrt(doublereal);
    int s_wsle(cilist *), do_lio(int *, int *, char *, ftnlen), 
	    e_wsle(void);

    /* Local variables */
    static real r1, r2, x1, y1, x2, y2, a11, a12, a21, a22, rr, ds1, ds2, rs1,
	     rs2, x1p, y1p, x2p, y2p, det, rsq, r1sq, r2sq, x1pp, y1pp, x2pp, 
	    y2pp, r1_s1__, r2_s2__, sind;
    static int iter;
    static real ssgn, rrsq, stot, xtot, ytot;
    extern doublereal d2val_(real *, real *, real *, real *, int *);
    static real rr_s1__, rr_s2__;
    extern doublereal deval_(real *, real *, real *, real *, int *), 
	    seval_(real *, real *, real *, real *, int *);

    /* Fortran I/O blocks */
    static cilist io___224 = { 0, 6, 0, 0, 0 };


/* ---------------------------------------------------------------- */
/*     Returns arc length points S1,S2 at flap surface break */
/*     locations.  S1 is on fixed airfoil part, S2 is on flap. */
/*     The points are defined according to two cases: */


/*     If DEL > 0:  Surface will be eliminated in S1 < s < S2 */

/*     Returns the arc length values S1,S2 of the endpoints */
/*     of the airfoil surface segment which "disappears" as a */
/*     result of the flap deflection.  The line segments between */
/*     these enpoints and the flap hinge point (XBF,YBF) have */
/*     an included angle of DEL.  DEL is therefore the flap */
/*     deflection which will join up the points at S1,S2. */
/*     SS is an approximate arc length value near S1 and S2. */
/*     It is used as an initial guess for the Newton loop */
/*     for S1 and S2. */


/*     If DEL = 0:  Surface will be created at s = S1 = S2 */

/*     If DEL=0, then S1,S2 will cooincide, and will be located */
/*     on the airfoil surface where the segment joining the */
/*     point at S1,S2 and the hinge point is perpendicular to */
/*     the airfoil surface.  This will be the point where the */
/*     airfoil surface must be broken to permit a gap to open */
/*     as a result of the flap deflection. */
/* ---------------------------------------------------------------- */

/* ---- convergence epsilon */
    /* Parameter adjustments */
    --s;
    --yp;
    --y;
    --xp;
    --x;

    /* Function Body */

    stot = (r__1 = s[(0 + (0 + (*n << 2))) / 4] - s[1], dabs(r__1));

    sind = sin(dabs(*del) * .5f);

    ssgn = 1.f;
    if (*iside == 1) {
	ssgn = -1.f;
    }

/* ---- initial guesses for S1, S2 */
/* Computing 2nd power */
    r__1 = seval_(ss, &x[1], &xp[1], &s[1], n) - *xbf;
/* Computing 2nd power */
    r__2 = seval_(ss, &y[1], &yp[1], &s[1], n) - *ybf;
    rsq = r__1 * r__1 + r__2 * r__2;
    *s1 = *ss - (sind * sqrt(rsq) + eps * stot) * ssgn;
    *s2 = *ss + (sind * sqrt(rsq) + eps * stot) * ssgn;

/* ---- Newton iteration loop */
    for (iter = 1; iter <= 10; ++iter) {
	x1 = seval_(s1, &x[1], &xp[1], &s[1], n);
	x1p = deval_(s1, &x[1], &xp[1], &s[1], n);
	y1 = seval_(s1, &y[1], &yp[1], &s[1], n);
	y1p = deval_(s1, &y[1], &yp[1], &s[1], n);

	x2 = seval_(s2, &x[1], &xp[1], &s[1], n);
	x2p = deval_(s2, &x[1], &xp[1], &s[1], n);
	y2 = seval_(s2, &y[1], &yp[1], &s[1], n);
	y2p = deval_(s2, &y[1], &yp[1], &s[1], n);

/* Computing 2nd power */
	r__1 = x1 - *xbf;
/* Computing 2nd power */
	r__2 = y1 - *ybf;
	r1sq = r__1 * r__1 + r__2 * r__2;
/* Computing 2nd power */
	r__1 = x2 - *xbf;
/* Computing 2nd power */
	r__2 = y2 - *ybf;
	r2sq = r__1 * r__1 + r__2 * r__2;
	r1 = sqrt(r1sq);
	r2 = sqrt(r2sq);

/* Computing 2nd power */
	r__1 = x1 - x2;
/* Computing 2nd power */
	r__2 = y1 - y2;
	rrsq = r__1 * r__1 + r__2 * r__2;
	rr = sqrt(rrsq);

	if (r1 <= eps * stot || r2 <= eps * stot) {
	    *s1 = *ss;
	    *s2 = *ss;
	    return 0;
	}

	r1_s1__ = (x1p * (x1 - *xbf) + y1p * (y1 - *ybf)) / r1;
	r2_s2__ = (x2p * (x2 - *xbf) + y2p * (y2 - *ybf)) / r2;

	if (sind > .01f) {

	    if (rr == 0.f) {
		return 0;
	    }

	    rr_s1__ = (x1p * (x1 - x2) + y1p * (y1 - y2)) / rr;
	    rr_s2__ = -(x2p * (x1 - x2) + y2p * (y1 - y2)) / rr;

/* ------- Residual 1: set included angle via dot product */
	    rs1 = ((*xbf - x1) * (x2 - x1) + (*ybf - y1) * (y2 - y1)) / rr - 
		    sind * r1;
	    a11 = ((*xbf - x1) * (-x1p) + (*ybf - y1) * (-y1p)) / rr + (-x1p *
		     (x2 - x1) + -y1p * (y2 - y1)) / rr - ((*xbf - x1) * (x2 
		    - x1) + (*ybf - y1) * (y2 - y1)) * rr_s1__ / rrsq - sind *
		     r1_s1__;
	    a12 = ((*xbf - x1) * x2p + (*ybf - y1) * y2p) / rr - ((*xbf - x1) 
		    * (x2 - x1) + (*ybf - y1) * (y2 - y1)) * rr_s2__ / rrsq;

/* ------- Residual 2: set equal length segments */
	    rs2 = r1 - r2;
	    a21 = r1_s1__;
	    a22 = -r2_s2__;

	} else {

/* ------- Residual 1: set included angle via small angle approximation */
	    rs1 = (r1 + r2) * sind + (*s1 - *s2) * ssgn;
	    a11 = r1_s1__ * sind + ssgn;
	    a12 = r2_s2__ * sind - ssgn;

/* ------- Residual 2: set vector sum of line segments beteen the */
/* -       endpoints and flap hinge to be perpendicular to airfoil surface. */
	    x1pp = d2val_(s1, &x[1], &xp[1], &s[1], n);
	    y1pp = d2val_(s1, &y[1], &yp[1], &s[1], n);
	    x2pp = d2val_(s2, &x[1], &xp[1], &s[1], n);
	    y2pp = d2val_(s2, &y[1], &yp[1], &s[1], n);

	    xtot = x1 + x2 - *xbf * 2.f;
	    ytot = y1 + y2 - *ybf * 2.f;

	    rs2 = xtot * (x1p + x2p) + ytot * (y1p + y2p);
	    a21 = x1p * (x1p + x2p) + y1p * (y1p + y2p) + xtot * x1pp + ytot *
		     y1pp;
	    a22 = x2p * (x1p + x2p) + y2p * (y1p + y2p) + xtot * x2pp + ytot *
		     y2pp;

	}

	det = a11 * a22 - a12 * a21;
	ds1 = -(rs1 * a22 - a12 * rs2) / det;
	ds2 = -(a11 * rs2 - rs1 * a21) / det;

/* Computing MIN */
	r__1 = ds1, r__2 = stot * .01f;
	ds1 = dmin(r__1,r__2);
/* Computing MAX */
	r__1 = ds1, r__2 = stot * -.01f;
	ds1 = dmax(r__1,r__2);
/* Computing MIN */
	r__1 = ds2, r__2 = stot * .01f;
	ds2 = dmin(r__1,r__2);
/* Computing MAX */
	r__1 = ds2, r__2 = stot * -.01f;
	ds2 = dmax(r__1,r__2);

	*s1 += ds1;
	*s2 += ds2;
	if (dabs(ds1) + dabs(ds2) < eps * stot) {
	    goto L11;
	}
/* L10: */
    }
    s_wsle(&io___224);
    do_lio(&c__9, &c__1, "SSS: failed to converge subtending angle points", (
	    ftnlen)47);
    e_wsle();
    *s1 = *ss;
    *s2 = *ss;

L11:

/* ---- make sure points are identical if included angle is zero. */
    if (*del == 0.f) {
	*s1 = (*s1 + *s2) * .5f;
	*s2 = *s1;
    }

    return 0;
} /* sss_ */

/* Subroutine */ int clis_(real *x, real *xp, real *y, real *yp, real *s, 
	int *n)
{
    /* Format strings */
    static char fmt_1050[] = "(/\002  i        x         y         s       t"
	    "heta        curv\002)";
    static char fmt_1100[] = "(1x,i3,3f10.5,f11.3,f12.3)";
    static char fmt_1200[] = "(/\002 Maximum curvature =\002,f14.3,\002   at"
	    "  i,x,y,s  = \002,i3,3f9.4)";

    /* System generated locals */
    int i__1;
    real r__1, r__2;

    /* Builtin functions */
    double atan(doublereal);
    int s_wsfe(cilist *), e_wsfe(void);
    double atan2(doublereal, doublereal);
    int do_fio(int *, char *, ftnlen);

    /* Local variables */
    static int i__;
    static real pi, cv, adeg, arad, cmax;
    static int imax;
    extern doublereal curv_(real *, real *, real *, real *, real *, real *, 
	    int *), atanc_(real *, real *, real *);

    /* Fortran I/O blocks */
    static cilist io___228 = { 0, 6, 0, fmt_1050, 0 };
    static cilist io___233 = { 0, 6, 0, fmt_1100, 0 };
    static cilist io___234 = { 0, 6, 0, fmt_1200, 0 };


/* ------------------------------------------------------------------- */
/*     Displays curvatures at panel nodes. */
/* ------------------------------------------------------------------- */
    /* Parameter adjustments */
    --s;
    --yp;
    --y;
    --xp;
    --x;

    /* Function Body */
    pi = atan(1.f) * 4.f;

    cmax = 0.f;
    imax = 1;

/* ---- go over each point, calculating curvature */
    s_wsfe(&io___228);
    e_wsfe();
    i__1 = *n;
    for (i__ = 1; i__ <= i__1; ++i__) {
	if (i__ == 1) {
	    arad = atan2(-yp[i__], -xp[i__]);
	} else {
	    r__1 = -yp[i__];
	    r__2 = -xp[i__];
	    arad = atanc_(&r__1, &r__2, &arad);
	}
	adeg = arad * 180.f / pi;
	cv = curv_(&s[i__], &x[1], &xp[1], &y[1], &yp[1], &s[1], n);
	s_wsfe(&io___233);
	do_fio(&c__1, (char *)&i__, (ftnlen)sizeof(integer));
	do_fio(&c__1, (char *)&x[i__], (ftnlen)sizeof(real));
	do_fio(&c__1, (char *)&y[i__], (ftnlen)sizeof(real));
	do_fio(&c__1, (char *)&s[i__], (ftnlen)sizeof(real));
	do_fio(&c__1, (char *)&adeg, (ftnlen)sizeof(real));
	do_fio(&c__1, (char *)&cv, (ftnlen)sizeof(real));
	e_wsfe();
	if (dabs(cv) > dabs(cmax)) {
	    cmax = cv;
	    imax = i__;
	}
/* L30: */
    }

    s_wsfe(&io___234);
    do_fio(&c__1, (char *)&cmax, (ftnlen)sizeof(real));
    do_fio(&c__1, (char *)&imax, (ftnlen)sizeof(integer));
    do_fio(&c__1, (char *)&x[imax], (ftnlen)sizeof(real));
    do_fio(&c__1, (char *)&y[imax], (ftnlen)sizeof(real));
    do_fio(&c__1, (char *)&s[imax], (ftnlen)sizeof(real));
    e_wsfe();

    return 0;

/* CC           120   0.12134  -0.10234  -0.30234   180.024      2025.322 */
} /* clis_ */

/* Subroutine */ int pltcrv_(real *sble, real *xb, real *xbp, real *yb, real *
	ybp, real *sb, int *nb, real *cv)
{
    /* Initialized data */

    static int lmask2 = -30584;

    /* System generated locals */
    int i__1;
    real r__1, r__2, r__3;
    doublereal d__1, d__2;

    /* Builtin functions */
    double pow_dd(doublereal *, doublereal *), r_sign(real *, real *);
    int s_wsle(cilist *), do_lio(int *, int *, char *, ftnlen), 
	    e_wsle(void);
    /* Subroutine */ int s_copy(char *, char *, ftnlen, ftnlen);

    /* Local variables */
    extern /* Subroutine */ int getcolor_(int *), newcolor_(int *);
    static int i__;
    static real ch, xc, yc;
    static int ile;
    static char ans[1];
    static real par, xle, yle;
    static int nxg;
    static real cwt, xof;
    static int nyg;
    static real xte, yte, xmn, xsf, ysf, yof, xln, xmx, xwt;
    extern /* Subroutine */ int askc_(char *, char *, char *, ftnlen, ftnlen, 
	    ftnlen);
    static real cvle, xdel, ydel;
    extern /* Subroutine */ int askr_(char *, real *, ftnlen);
    static real cvmn, xlen, ylen, xmin, ymin, cvmx, xmax;
    extern doublereal curv_(real *, real *, real *, real *, real *, real *, 
	    int *);
    static real ymax;
    extern /* Subroutine */ int plot_(real *, real *, int *);
    static int icol0;
    extern /* Subroutine */ int newcolorname_(char *, ftnlen);
    static real cvdel;
    extern doublereal seval_(real *, real *, real *, real *, int *);
    static real cvmin, cvmax, cvsgn, cvexp;
    static logical error;
    static real xspan, sbtot, svmin;
    extern /* Subroutine */ int xaxis_(real *, real *, real *, real *, real *,
	     real *, real *, int *);
    static real svmax;
    extern /* Subroutine */ int yaxis_(real *, real *, real *, real *, real *,
	     real *, real *, int *);
    static real xvmin, xvmax;
    extern /* Subroutine */ int plchar_(real *, real *, real *, char *, real *
	    , int *, ftnlen);
    static char ansarg[128];
    extern /* Subroutine */ int plgrid_(real *, real *, int *, real *, 
	    int *, real *, int *), getflt_(char *, real *, int *, 
	    logical *, ftnlen);
    static real cvspan;
    extern /* Subroutine */ int newpen_(int *), plnumb_(real *, real *, 
	    real *, real *, real *, int *), pltini_(void);
    static logical lcvexp;
    extern /* Subroutine */ int plsymb_(real *, real *, real *, int *, 
	    real *, int *);
    static int nxtics;
    extern /* Subroutine */ int xyline_(int *, real *, real *, real *, 
	    real *, real *, real *, int *);
    static int ninput;
    static real rinput;
    extern /* Subroutine */ int axisadj_(real *, real *, real *, real *, 
	    int *);
    static int ncvtics;
    extern /* Subroutine */ int plflush_(void);

    /* Fortran I/O blocks */
    static cilist io___287 = { 0, 6, 0, 0, 0 };
    static cilist io___288 = { 0, 6, 0, 0, 0 };
    static cilist io___289 = { 0, 6, 0, 0, 0 };
    static cilist io___290 = { 0, 6, 0, 0, 0 };
    static cilist io___291 = { 0, 6, 0, 0, 0 };
    static cilist io___292 = { 0, 6, 0, 0, 0 };
    static cilist io___293 = { 0, 6, 0, 0, 0 };
    static cilist io___294 = { 0, 6, 0, 0, 0 };
    static cilist io___295 = { 0, 6, 0, 0, 0 };
    static cilist io___296 = { 0, 6, 0, 0, 0 };



/* ---- Plot the curvature on the blade */


    /* Parameter adjustments */
    --cv;
    --sb;
    --ybp;
    --yb;
    --xbp;
    --xb;

    /* Function Body */

    ch = .01f;
    lcvexp = FALSE_;
    cvexp = .33333333333333331f;

L10:
    sbtot = (sb[*nb] - sb[1]) * .5f;
    xte = (xb[*nb] + xb[1]) * .5f;
    yte = (yb[*nb] + yb[1]) * .5f;
    xle = seval_(sble, &xb[1], &xbp[1], &sb[1], nb);
    yle = seval_(sble, &yb[1], &ybp[1], &sb[1], nb);
    cvle = curv_(sble, &xb[1], &xbp[1], &yb[1], &ybp[1], &sb[1], nb) * sbtot;
    if (lcvexp) {
	d__1 = (doublereal) cvle;
	d__2 = (doublereal) cvexp;
	cvle = pow_dd(&d__1, &d__2);
    }

    cvmax = cvle;
    svmax = *sble;
    xvmax = xle;
    cvmin = cvle;
    svmin = *sble;
    xvmin = xle;
    i__1 = *nb;
    for (i__ = 1; i__ <= i__1; ++i__) {
/* ---- set up curvature array */
	cv[i__] = curv_(&sb[i__], &xb[1], &xbp[1], &yb[1], &ybp[1], &sb[1], 
		nb) * sbtot;
	if (lcvexp) {
	    if (cv[i__] > 0.f) {
		d__1 = (doublereal) cv[i__];
		d__2 = (doublereal) cvexp;
		cv[i__] = pow_dd(&d__1, &d__2);
	    } else if (cv[i__] == 0.f) {
		cv[i__] = 0.f;
	    } else if (cv[i__] < 0.f) {
		cvsgn = r_sign(&c_b40, &cv[i__]);
		d__1 = (r__1 = cv[i__], (doublereal) dabs(r__1));
		d__2 = (doublereal) cvexp;
		cv[i__] = cvsgn * pow_dd(&d__1, &d__2);
	    }
	}
	if (cv[i__] > cvmax) {
	    cvmax = cv[i__];
	    svmax = sb[i__];
	    xvmax = xb[i__];
	}
	if (cv[i__] < cvmin) {
	    cvmin = cv[i__];
	    svmin = sb[i__];
	    xvmin = xb[i__];
	}
	if (sb[i__] <= *sble) {
	    ile = i__;
	}
    }

/* c    CALL SCALIT(1,CVMAX-CVMIN,0.0,CWT) */
    cvmx = cvmax;
    cvmn = cvmin;
    axisadj_(&cvmn, &cvmx, &cvspan, &cvdel, &ncvtics);
    cwt = 1.f / cvspan;
    xmx = xte;
    xmn = xle;
    axisadj_(&xmn, &xmx, &xspan, &xdel, &nxtics);
/* --- Correct min/max for points just slightly off from a major division in X */
    if (xle - xmn > xdel * .95f) {
	xmn += xdel;
    }
    if (xmx - xte > xdel * .95f) {
	xmx -= xdel;
    }
    xspan = xmx - xmn;
    xwt = 1.f / xspan;

    par = .75f;
    xlen = .8f;
    ylen = par * xlen;
    xmin = xmn;
    xmax = xmx;
    xdel = xdel;
    nxg = (xmax - xmin) / xdel;
    xsf = xlen / (xmax - xmin);
    xof = xmn;
    ymin = cvmn;
    ymax = cvmx;
    ydel = cvdel;
    nyg = (ymax - ymin) / ydel;
    ysf = ylen / (ymax - ymin);
    yof = 0.f;

    pltini_();
    r__1 = ylen * (-ymin / (ymax - ymin)) + .1f;
    plot_(&c_b79, &r__1, &c_n3);

/* --- X axis (x/c) */
    newpen_(&c__2);
    xln = xlen;
    if (xmin == 0.f) {
	xln = -xln;
    }
    r__1 = xsf * xdel;
    xaxis_(&c_b82, &c_b82, &xln, &r__1, &xmin, &xdel, &ch, &c__1);
    xc = xsf * 3.5f * xdel - ch * .59999999999999998f;
    yc = ch * -4.2000000000000002f;
    r__1 = ch * 1.2f;
    plchar_(&xc, &yc, &r__1, "X", &c_b82, &c__1, (ftnlen)1);

/* --- Y axis (curvature) */
    r__1 = ysf * ymin;
    r__2 = ysf * ydel;
    yaxis_(&c_b82, &r__1, &ylen, &r__2, &ymin, &ydel, &ch, &c__1);
    xc = ch * -5.3999999999999995f;
    yc = ysf * (ymax - ydel * .5f) - ch * .59999999999999998f;
    if (lcvexp) {
	r__1 = xc - ch * 5.3999999999999995f;
	r__2 = ch * 1.2f;
	plchar_(&r__1, &yc, &r__2, "CV^", &c_b82, &c__3, (ftnlen)3);
	r__1 = xc - ch * 1.7999999999999998f;
	r__2 = yc + ch * .5f;
	plnumb_(&r__1, &r__2, &ch, &cvexp, &c_b82, &c__2);
    } else {
	r__1 = ch * 1.2f;
	plchar_(&xc, &yc, &r__1, "CV", &c_b82, &c__2, (ftnlen)2);
    }

    r__1 = ysf * ymin;
    r__2 = xsf * xdel;
    r__3 = ysf * ydel;
    plgrid_(&c_b82, &r__1, &nxg, &r__2, &nyg, &r__3, &lmask2);
    xc = 0.f;
    yc = ysf * ymax + ch * 1.2f;
    if (lcvexp) {
	r__1 = ch * 1.2f;
	plchar_(&xc, &yc, &r__1, "Curvature^n vs X", &c_b82, &c__16, (ftnlen)
		16);
    } else {
	r__1 = ch * 1.2f;
	plchar_(&xc, &yc, &r__1, "Curvature vs X", &c_b82, &c__16, (ftnlen)14)
		;
    }

/* --- Upper surface curvature */
    getcolor_(&icol0);
    newcolorname_("yellow", (ftnlen)6);
    xyline_(&ile, &xb[1], &cv[1], &xof, &xsf, &yof, &ysf, &c__1);
    xc = xsf * (xb[(ile << 1) / 3] - xof);
    yc = ysf * (cv[(ile << 1) / 3] - yof);
    r__1 = xc + ch * .5f;
    r__2 = yc + ch * .5f;
    plchar_(&r__1, &r__2, &ch, "Upper", &c_b82, &c__5, (ftnlen)5);

/* --- LE curvature */
    newcolorname_("red", (ftnlen)3);
    xc = xsf * (xle - xof);
    yc = ysf * (cvle - yof);
    plsymb_(&xc, &yc, &ch, &c__3, &c_b82, &c__0);
    r__1 = xc + ch * 1.f;
    r__2 = yc - ch * .5f;
    plchar_(&r__1, &r__2, &ch, "LE", &c_b82, &c__2, (ftnlen)2);

/* --- Lower surface curvature */
    newcolorname_("cyan", (ftnlen)4);
    i__1 = *nb - ile + 1;
    xyline_(&i__1, &xb[ile], &cv[ile], &xof, &xsf, &yof, &ysf, &c__2);
    xc = xsf * (xb[(ile + *nb) / 2] - xof);
    yc = ysf * (cv[(ile + *nb) / 2] - yof);
    r__1 = xc + ch * .5f;
    r__2 = yc + ch * .5f;
    plchar_(&r__1, &r__2, &ch, "Lower", &c_b82, &c__5, (ftnlen)5);

    newcolor_(&icol0);
    plflush_();


L20:
    s_wsle(&io___287);
    do_lio(&c__9, &c__1, " ", (ftnlen)1);
    e_wsle();
    s_wsle(&io___288);
    do_lio(&c__9, &c__1, "Airfoil curvature (yellow-upper, cyan-lower) ", (
	    ftnlen)45);
    e_wsle();
    if (lcvexp) {
	s_wsle(&io___289);
	do_lio(&c__9, &c__1, " Range compressed using CV=(curvature)^n with "
		"n =", (ftnlen)49);
	do_lio(&c__4, &c__1, (char *)&cvexp, (ftnlen)sizeof(real));
	e_wsle();
    }
    s_wsle(&io___290);
    do_lio(&c__9, &c__1, " CVLE  = ", (ftnlen)9);
    do_lio(&c__4, &c__1, (char *)&cvle, (ftnlen)sizeof(real));
    do_lio(&c__9, &c__1, " at S = ", (ftnlen)8);
    do_lio(&c__4, &c__1, (char *)&(*sble), (ftnlen)sizeof(real));
    do_lio(&c__9, &c__1, " at X = ", (ftnlen)8);
    do_lio(&c__4, &c__1, (char *)&xle, (ftnlen)sizeof(real));
    e_wsle();
    s_wsle(&io___291);
    do_lio(&c__9, &c__1, " CVmax = ", (ftnlen)9);
    do_lio(&c__4, &c__1, (char *)&cvmax, (ftnlen)sizeof(real));
    do_lio(&c__9, &c__1, " at S = ", (ftnlen)8);
    do_lio(&c__4, &c__1, (char *)&svmax, (ftnlen)sizeof(real));
    do_lio(&c__9, &c__1, " at X = ", (ftnlen)8);
    do_lio(&c__4, &c__1, (char *)&xvmax, (ftnlen)sizeof(real));
    e_wsle();
    s_wsle(&io___292);
    do_lio(&c__9, &c__1, " CVmin = ", (ftnlen)9);
    do_lio(&c__4, &c__1, (char *)&cvmin, (ftnlen)sizeof(real));
    do_lio(&c__9, &c__1, " at S = ", (ftnlen)8);
    do_lio(&c__4, &c__1, (char *)&svmin, (ftnlen)sizeof(real));
    do_lio(&c__9, &c__1, " at X = ", (ftnlen)8);
    do_lio(&c__4, &c__1, (char *)&xvmin, (ftnlen)sizeof(real));
    e_wsle();

    s_wsle(&io___293);
    do_lio(&c__9, &c__1, " ", (ftnlen)1);
    e_wsle();
    s_wsle(&io___294);
    do_lio(&c__9, &c__1, "Enter C for curvature    plot", (ftnlen)29);
    e_wsle();
    s_wsle(&io___295);
    do_lio(&c__9, &c__1, "Enter N for curvature**N plot", (ftnlen)29);
    e_wsle();
    s_wsle(&io___296);
    do_lio(&c__9, &c__1, "Hit <cr> to exit", (ftnlen)16);
    e_wsle();
    s_copy(ansarg, " ", (ftnlen)128, (ftnlen)1);
    askc_("..CPLO^", ans, ansarg, (ftnlen)7, (ftnlen)1, (ftnlen)128);
    if (*(unsigned char *)ans == ' ') {
	return 0;
    }

    rinput = 0.f;
    ninput = 1;
    getflt_(ansarg, &rinput, &ninput, &error, (ftnlen)128);

    if (*(unsigned char *)ans == 'n' || *(unsigned char *)ans == 'N') {
	if (ninput >= 1) {
	    cvexp = rinput;
	} else {
	    cvexp = .3f;
	    askr_("Enter curvature exponent (default 0.3)^", &cvexp, (ftnlen)
		    39);
	}
	lcvexp = TRUE_;
	goto L10;
    }
    if (*(unsigned char *)ans == 'c' || *(unsigned char *)ans == 'C') {
	lcvexp = FALSE_;
	goto L10;
    }
    goto L20;

/* L1000: */
} /* pltcrv_ */

/* Subroutine */ int cang_(real *x, real *y, int *n, int *iprint, 
	int *imax, real *amax)
{
    /* Format strings */
    static char fmt_1050[] = "(/\002  i       x        y      angle\002)";
    static char fmt_1100[] = "(1x,i3,2f9.4,f9.3)";
    static char fmt_1200[] = "(/\002 Maximum panel corner angle =\002,f7.3"
	    ",\002   at  i,x,y  = \002,i3,2f9.4)";

    /* System generated locals */
    int i__1;
    real r__1, r__2, r__3, r__4;

    /* Builtin functions */
    int s_wsfe(cilist *), e_wsfe(void);
    double sqrt(doublereal), asin(doublereal);
    int do_fio(int *, char *, ftnlen);

    /* Local variables */
    static int i__;
    static real dx1, dy1, dx2, dy2, angl, crossp;

    /* Fortran I/O blocks */
    static cilist io___302 = { 0, 6, 0, fmt_1050, 0 };
    static cilist io___310 = { 0, 6, 0, fmt_1100, 0 };
    static cilist io___311 = { 0, 6, 0, fmt_1200, 0 };


/* ------------------------------------------------------------------- */
/*     IPRINT=2:   Displays all panel node corner angles */
/*     IPRINT=1:   Displays max panel node corner angle */
/*     IPRINT=0:   No display... just returns values */
/* ------------------------------------------------------------------- */

    /* Parameter adjustments */
    --y;
    --x;

    /* Function Body */
    *amax = 0.f;
    *imax = 1;

/* ---- go over each point, calculating corner angle */
    if (*iprint == 2) {
	s_wsfe(&io___302);
	e_wsfe();
    }
    i__1 = *n - 1;
    for (i__ = 2; i__ <= i__1; ++i__) {
	dx1 = x[i__] - x[i__ - 1];
	dy1 = y[i__] - y[i__ - 1];
	dx2 = x[i__] - x[i__ + 1];
	dy2 = y[i__] - y[i__ + 1];

/* ------ allow for doubled points */
	if (dx1 == 0.f && dy1 == 0.f) {
	    dx1 = x[i__] - x[i__ - 2];
	    dy1 = y[i__] - y[i__ - 2];
	}
	if (dx2 == 0.f && dy2 == 0.f) {
	    dx2 = x[i__] - x[i__ + 2];
	    dy2 = y[i__] - y[i__ + 2];
	}

/* Computing 2nd power */
	r__1 = dx1;
/* Computing 2nd power */
	r__2 = dy1;
/* Computing 2nd power */
	r__3 = dx2;
/* Computing 2nd power */
	r__4 = dy2;
	crossp = (dx2 * dy1 - dy2 * dx1) / sqrt((r__1 * r__1 + r__2 * r__2) * 
		(r__3 * r__3 + r__4 * r__4));
	angl = asin(crossp) * 57.295780490442965f;
	if (*iprint == 2) {
	    s_wsfe(&io___310);
	    do_fio(&c__1, (char *)&i__, (ftnlen)sizeof(integer));
	    do_fio(&c__1, (char *)&x[i__], (ftnlen)sizeof(real));
	    do_fio(&c__1, (char *)&y[i__], (ftnlen)sizeof(real));
	    do_fio(&c__1, (char *)&angl, (ftnlen)sizeof(real));
	    e_wsfe();
	}
	if (dabs(angl) > dabs(*amax)) {
	    *amax = angl;
	    *imax = i__;
	}
/* L30: */
    }

    if (*iprint >= 1) {
	s_wsfe(&io___311);
	do_fio(&c__1, (char *)&(*amax), (ftnlen)sizeof(real));
	do_fio(&c__1, (char *)&(*imax), (ftnlen)sizeof(integer));
	do_fio(&c__1, (char *)&x[*imax], (ftnlen)sizeof(real));
	do_fio(&c__1, (char *)&y[*imax], (ftnlen)sizeof(real));
	e_wsfe();
    }

    return 0;

/* CC             120   0.2134  -0.0234   25.322 */
} /* cang_ */

/* Subroutine */ int inter_(real *x0, real *xp0, real *y0, real *yp0, real *
	s0, int *n0, real *sle0, real *x1, real *xp1, real *y1, real *yp1,
	 real *s1, int *n1, real *sle1, real *x, real *y, int *n, 
	real *frac)
{
    /* System generated locals */
    int i__1;

    /* Local variables */
    static int i__;
    static real f0, f1, sn, st0, st1, xt0, yt0, xt1, yt1, bots0, bots1, tops0,
	     tops1;
    extern doublereal seval_(real *, real *, real *, real *, int *);

/*     ..................................................................... */

/*     Interpolates two source airfoil shapes into an "intermediate" shape. */

/*     Procedure: */
/*        The interpolated x coordinate at a given normalized spline */
/*        parameter value is a weighted average of the two source */
/*        x coordinates at the same normalized spline parameter value. */
/*        Ditto for the y coordinates. The normalized spline parameter */
/*        runs from 0 at the leading edge to 1 at the trailing edge on */
/*        each surface. */
/*     ..................................................................... */


/* ---- number of points in interpolated airfoil is the same as in airfoil 0 */
    /* Parameter adjustments */
    --s0;
    --yp0;
    --y0;
    --xp0;
    --x0;
    --s1;
    --yp1;
    --y1;
    --xp1;
    --x1;
    --x;
    --y;

    /* Function Body */
    *n = *n0;

/* ---- interpolation weighting fractions */
    f0 = 1.f - *frac;
    f1 = *frac;

/* ---- top side spline parameter increments */
    tops0 = s0[1] - *sle0;
    tops1 = s1[1] - *sle1;

/* ---- bottom side spline parameter increments */
    bots0 = s0[*n0] - *sle0;
    bots1 = s1[*n1] - *sle1;

    i__1 = *n;
    for (i__ = 1; i__ <= i__1; ++i__) {

/* ------ normalized spline parameter is taken from airfoil 0 value */
	if (s0[i__] < *sle0) {
	    sn = (s0[i__] - *sle0) / tops0;
	}
	if (s0[i__] >= *sle0) {
	    sn = (s0[i__] - *sle0) / bots0;
	}

/* ------ set actual spline parameters */
	st0 = s0[i__];
	if (st0 < *sle0) {
	    st1 = *sle1 + tops1 * sn;
	}
	if (st0 >= *sle0) {
	    st1 = *sle1 + bots1 * sn;
	}

/* ------ set input coordinates at common spline parameter location */
	xt0 = seval_(&st0, &x0[1], &xp0[1], &s0[1], n0);
	yt0 = seval_(&st0, &y0[1], &yp0[1], &s0[1], n0);
	xt1 = seval_(&st1, &x1[1], &xp1[1], &s1[1], n1);
	yt1 = seval_(&st1, &y1[1], &yp1[1], &s1[1], n1);

/* ------ set interpolated x,y coordinates */
	x[i__] = f0 * xt0 + f1 * xt1;
	y[i__] = f0 * yt0 + f1 * yt1;

/* L50: */
    }

    return 0;
} /* inter_ */

/* Subroutine */ int interx_(real *x0, real *xp0, real *y0, real *yp0, real *
	s0, int *n0, real *sle0, real *x1, real *xp1, real *y1, real *yp1,
	 real *s1, int *n1, real *sle1, real *x, real *y, int *n, 
	real *frac)
{
    /* System generated locals */
    int i__1;

    /* Local variables */
    static int i__;
    static real f0, f1, xn, st0, xt0, xt1, st1, yt0, yt1, xle0, xle1;
    extern doublereal seval_(real *, real *, real *, real *, int *);
    extern /* Subroutine */ int sinvrt_(real *, real *, real *, real *, real *
	    , int *);

/*     ..................................................................... */

/*     Interpolates two source airfoil shapes into an "intermediate" shape. */

/*     Procedure: */
/*        The interpolated x coordinate at a given normalized spline */
/*        parameter value is a weighted average of the two source */
/*        x coordinates at the same normalized spline parameter value. */
/*        Ditto for the y coordinates. The normalized spline parameter */
/*        runs from 0 at the leading edge to 1 at the trailing edge on */
/*        each surface. */
/*     ..................................................................... */


/* ---- number of points in interpolated airfoil is the same as in airfoil 0 */
    /* Parameter adjustments */
    --s0;
    --yp0;
    --y0;
    --xp0;
    --x0;
    --s1;
    --yp1;
    --y1;
    --xp1;
    --x1;
    --y;
    --x;

    /* Function Body */
    *n = *n0;

/* ---- interpolation weighting fractions */
    f0 = 1.f - *frac;
    f1 = *frac;

    xle0 = seval_(sle0, &x0[1], &xp0[1], &s0[1], n0);
    xle1 = seval_(sle1, &x1[1], &xp1[1], &s1[1], n1);

    i__1 = *n;
    for (i__ = 1; i__ <= i__1; ++i__) {

/* ------ normalized x parameter is taken from airfoil 0 value */
	if (s0[i__] < *sle0) {
	    xn = (x0[i__] - xle0) / (x0[1] - xle0);
	}
	if (s0[i__] >= *sle0) {
	    xn = (x0[i__] - xle0) / (x0[*n0] - xle0);
	}

/* ------ set target x and initial spline parameters */
	xt0 = x0[i__];
	st0 = s0[i__];
	if (st0 < *sle0) {
	    xt1 = xle1 + (x1[1] - xle1) * xn;
	    st1 = *sle1 + (s1[1] - *sle1) * xn;
	} else {
	    xt1 = xle1 + (x1[*n1] - xle1) * xn;
	    st1 = *sle1 + (s1[*n1] - *sle1) * xn;
	}

	sinvrt_(&st0, &xt0, &x0[1], &xp0[1], &s0[1], n0);
	sinvrt_(&st1, &xt1, &x1[1], &xp1[1], &s1[1], n1);

/* ------ set input coordinates at common spline parameter location */
	xt0 = seval_(&st0, &x0[1], &xp0[1], &s0[1], n0);
	yt0 = seval_(&st0, &y0[1], &yp0[1], &s0[1], n0);
	xt1 = seval_(&st1, &x1[1], &xp1[1], &s1[1], n1);
	yt1 = seval_(&st1, &y1[1], &yp1[1], &s1[1], n1);

/* ------ set interpolated x,y coordinates */
	x[i__] = f0 * xt0 + f1 * xt1;
	y[i__] = f0 * yt0 + f1 * yt1;

/* L50: */
    }

    return 0;
} /* interx_ */

/* Subroutine */ int bendump_(int *n, real *x, real *y)
{
    /* Format strings */
    static char fmt_1200[] = "(1x,a,g14.6)";

    /* System generated locals */
    real r__1, r__2, r__3, r__4;

    /* Builtin functions */
    int s_wsle(cilist *), e_wsle(void), s_wsfe(cilist *), do_fio(int *
	    , char *, ftnlen), e_wsfe(void);

    /* Local variables */
    static real aj, xc, yc, ajt, pex, xct, yct, area, xbar, ybar, slen, aixx, 
	    xmin, ymin, xmax, ymax, aiyy, xbart, ybart, aixxt, aiyyt;
    extern /* Subroutine */ int ijsect_(int *, real *, real *, real *, 
	    real *, real *, real *, real *, real *, real *, real *, real *, 
	    real *, real *, real *, real *, real *, real *, real *, real *, 
	    real *, real *);
    static real xexint, yexint;

    /* Fortran I/O blocks */
    static cilist io___357 = { 0, 6, 0, 0, 0 };
    static cilist io___358 = { 0, 6, 0, fmt_1200, 0 };
    static cilist io___359 = { 0, 6, 0, fmt_1200, 0 };
    static cilist io___360 = { 0, 6, 0, 0, 0 };
    static cilist io___361 = { 0, 6, 0, fmt_1200, 0 };
    static cilist io___362 = { 0, 6, 0, fmt_1200, 0 };
    static cilist io___363 = { 0, 6, 0, fmt_1200, 0 };
    static cilist io___364 = { 0, 6, 0, fmt_1200, 0 };
    static cilist io___365 = { 0, 6, 0, fmt_1200, 0 };
    static cilist io___367 = { 0, 6, 0, fmt_1200, 0 };
    static cilist io___368 = { 0, 6, 0, 0, 0 };
    static cilist io___369 = { 0, 6, 0, fmt_1200, 0 };
    static cilist io___370 = { 0, 6, 0, fmt_1200, 0 };
    static cilist io___371 = { 0, 6, 0, fmt_1200, 0 };
    static cilist io___372 = { 0, 6, 0, fmt_1200, 0 };
    static cilist io___373 = { 0, 6, 0, fmt_1200, 0 };
    static cilist io___375 = { 0, 6, 0, fmt_1200, 0 };
    static cilist io___376 = { 0, 6, 0, 0, 0 };
    static cilist io___377 = { 0, 6, 0, fmt_1200, 0 };
    static cilist io___378 = { 0, 6, 0, 0, 0 };
    static cilist io___379 = { 0, 6, 0, 0, 0 };
    static cilist io___380 = { 0, 6, 0, fmt_1200, 0 };
    static cilist io___381 = { 0, 6, 0, fmt_1200, 0 };
    static cilist io___382 = { 0, 6, 0, fmt_1200, 0 };
    static cilist io___383 = { 0, 6, 0, fmt_1200, 0 };
    static cilist io___384 = { 0, 6, 0, fmt_1200, 0 };
    static cilist io___386 = { 0, 6, 0, fmt_1200, 0 };
    static cilist io___387 = { 0, 6, 0, 0, 0 };
    static cilist io___388 = { 0, 6, 0, fmt_1200, 0 };
    static cilist io___389 = { 0, 6, 0, fmt_1200, 0 };
    static cilist io___390 = { 0, 6, 0, fmt_1200, 0 };
    static cilist io___391 = { 0, 6, 0, fmt_1200, 0 };
    static cilist io___392 = { 0, 6, 0, fmt_1200, 0 };
    static cilist io___394 = { 0, 6, 0, fmt_1200, 0 };
    static cilist io___395 = { 0, 6, 0, 0, 0 };
    static cilist io___396 = { 0, 6, 0, fmt_1200, 0 };



    /* Parameter adjustments */
    --y;
    --x;

    /* Function Body */
    pex = 16.f;
    ijsect_(n, &x[1], &y[1], &pex, &area, &slen, &xmin, &xmax, &xexint, &ymin,
	     &ymax, &yexint, &xc, &yc, &xct, &yct, &aixx, &aiyy, &aixxt, &
	    aiyyt, &aj, &ajt);
/*      CALL IJSECT(N,X,Y, PEX, */
/*     &    AREA, SLEN, */
/*     &    XC, XMIN, XMAX, XEXINT, */
/*     &    YC, YMIN, YMAX, YEXINT, */
/*     &    AIXX, AIXXT, */
/*     &    AIYY, AIYYT, */
/*     &    AJ  , AJT   ) */

    s_wsle(&io___357);
    e_wsle();
    s_wsfe(&io___358);
    do_fio(&c__1, "Area =", (ftnlen)6);
    do_fio(&c__1, (char *)&area, (ftnlen)sizeof(real));
    e_wsfe();
    s_wsfe(&io___359);
    do_fio(&c__1, "Slen =", (ftnlen)6);
    do_fio(&c__1, (char *)&slen, (ftnlen)sizeof(real));
    e_wsfe();
    s_wsle(&io___360);
    e_wsle();
    s_wsfe(&io___361);
    do_fio(&c__1, "X-bending parameters(solid):", (ftnlen)28);
    e_wsfe();
    s_wsfe(&io___362);
    do_fio(&c__1, "        Xc =", (ftnlen)12);
    do_fio(&c__1, (char *)&xc, (ftnlen)sizeof(real));
    e_wsfe();
    s_wsfe(&io___363);
    do_fio(&c__1, "  max X-Xc =", (ftnlen)12);
    r__1 = xmax - xc;
    do_fio(&c__1, (char *)&r__1, (ftnlen)sizeof(real));
    e_wsfe();
    s_wsfe(&io___364);
    do_fio(&c__1, "  min X-Xc =", (ftnlen)12);
    r__1 = xmin - xc;
    do_fio(&c__1, (char *)&r__1, (ftnlen)sizeof(real));
    e_wsfe();
    s_wsfe(&io___365);
    do_fio(&c__1, "       Iyy =", (ftnlen)12);
    do_fio(&c__1, (char *)&aiyy, (ftnlen)sizeof(real));
    e_wsfe();
/* Computing MAX */
    r__3 = (r__1 = xmax - xc, dabs(r__1)), r__4 = (r__2 = xmin - xc, dabs(
	    r__2));
    xbar = dmax(r__3,r__4);
    s_wsfe(&io___367);
    do_fio(&c__1, " Iyy/(X-Xc)=", (ftnlen)12);
    r__1 = aiyy / xbar;
    do_fio(&c__1, (char *)&r__1, (ftnlen)sizeof(real));
    e_wsfe();
    s_wsle(&io___368);
    e_wsle();
    s_wsfe(&io___369);
    do_fio(&c__1, "Y-bending parameters(solid):", (ftnlen)28);
    e_wsfe();
    s_wsfe(&io___370);
    do_fio(&c__1, "        Yc =", (ftnlen)12);
    do_fio(&c__1, (char *)&yc, (ftnlen)sizeof(real));
    e_wsfe();
    s_wsfe(&io___371);
    do_fio(&c__1, "  max Y-Yc =", (ftnlen)12);
    r__1 = ymax - yc;
    do_fio(&c__1, (char *)&r__1, (ftnlen)sizeof(real));
    e_wsfe();
    s_wsfe(&io___372);
    do_fio(&c__1, "  min Y-Yc =", (ftnlen)12);
    r__1 = ymin - yc;
    do_fio(&c__1, (char *)&r__1, (ftnlen)sizeof(real));
    e_wsfe();
    s_wsfe(&io___373);
    do_fio(&c__1, "       Ixx =", (ftnlen)12);
    do_fio(&c__1, (char *)&aixx, (ftnlen)sizeof(real));
    e_wsfe();
/* Computing MAX */
    r__3 = (r__1 = ymax - yc, dabs(r__1)), r__4 = (r__2 = ymin - yc, dabs(
	    r__2));
    ybar = dmax(r__3,r__4);
    s_wsfe(&io___375);
    do_fio(&c__1, " Ixx/(Y-Yc)=", (ftnlen)12);
    r__1 = aixx / ybar;
    do_fio(&c__1, (char *)&r__1, (ftnlen)sizeof(real));
    e_wsfe();
    s_wsle(&io___376);
    e_wsle();
    s_wsfe(&io___377);
    do_fio(&c__1, "       J   =", (ftnlen)12);
    do_fio(&c__1, (char *)&aj, (ftnlen)sizeof(real));
    e_wsfe();

    s_wsle(&io___378);
    e_wsle();
    s_wsle(&io___379);
    e_wsle();
    s_wsfe(&io___380);
    do_fio(&c__1, "X-bending parameters(skin):", (ftnlen)27);
    e_wsfe();
    s_wsfe(&io___381);
    do_fio(&c__1, "         Xc =", (ftnlen)13);
    do_fio(&c__1, (char *)&xct, (ftnlen)sizeof(real));
    e_wsfe();
    s_wsfe(&io___382);
    do_fio(&c__1, "   max X-Xc =", (ftnlen)13);
    r__1 = xmax - xct;
    do_fio(&c__1, (char *)&r__1, (ftnlen)sizeof(real));
    e_wsfe();
    s_wsfe(&io___383);
    do_fio(&c__1, "   min X-Xc =", (ftnlen)13);
    r__1 = xmin - xct;
    do_fio(&c__1, (char *)&r__1, (ftnlen)sizeof(real));
    e_wsfe();
    s_wsfe(&io___384);
    do_fio(&c__1, "      Iyy/t =", (ftnlen)13);
    do_fio(&c__1, (char *)&aiyyt, (ftnlen)sizeof(real));
    e_wsfe();
/* Computing MAX */
    r__3 = (r__1 = xmax - xct, dabs(r__1)), r__4 = (r__2 = xmin - xct, dabs(
	    r__2));
    xbart = dmax(r__3,r__4);
    s_wsfe(&io___386);
    do_fio(&c__1, " Iyy/t(X-Xc)=", (ftnlen)13);
    r__1 = aiyyt / xbart;
    do_fio(&c__1, (char *)&r__1, (ftnlen)sizeof(real));
    e_wsfe();
    s_wsle(&io___387);
    e_wsle();
    s_wsfe(&io___388);
    do_fio(&c__1, "Y-bending parameters(skin):", (ftnlen)27);
    e_wsfe();
    s_wsfe(&io___389);
    do_fio(&c__1, "         Yc =", (ftnlen)13);
    do_fio(&c__1, (char *)&yct, (ftnlen)sizeof(real));
    e_wsfe();
    s_wsfe(&io___390);
    do_fio(&c__1, "   max Y-Yc =", (ftnlen)13);
    r__1 = ymax - yct;
    do_fio(&c__1, (char *)&r__1, (ftnlen)sizeof(real));
    e_wsfe();
    s_wsfe(&io___391);
    do_fio(&c__1, "   min Y-Yc =", (ftnlen)13);
    r__1 = ymin - yct;
    do_fio(&c__1, (char *)&r__1, (ftnlen)sizeof(real));
    e_wsfe();
    s_wsfe(&io___392);
    do_fio(&c__1, "      Ixx/t =", (ftnlen)13);
    do_fio(&c__1, (char *)&aixxt, (ftnlen)sizeof(real));
    e_wsfe();
/* Computing MAX */
    r__3 = (r__1 = ymax - yct, dabs(r__1)), r__4 = (r__2 = ymin - yct, dabs(
	    r__2));
    ybart = dmax(r__3,r__4);
    s_wsfe(&io___394);
    do_fio(&c__1, " Ixx/t(Y-Yc)=", (ftnlen)13);
    r__1 = aixxt / ybart;
    do_fio(&c__1, (char *)&r__1, (ftnlen)sizeof(real));
    e_wsfe();
    s_wsle(&io___395);
    e_wsle();
    s_wsfe(&io___396);
    do_fio(&c__1, "      J/t   =", (ftnlen)13);
    do_fio(&c__1, (char *)&ajt, (ftnlen)sizeof(real));
    e_wsfe();

/*      WRITE(*,*) */
/*      WRITE(*,1200) '  power-avg X-Xc =', XEXINT */
/*      WRITE(*,1200) '  power-avg Y-Yc =', YEXINT */

    return 0;

} /* bendump_ */

/* Subroutine */ int bendump2_(int *n, real *x, real *y, real *t)
{
    /* Format strings */
    static char fmt_1200[] = "(1x,a,g14.6)";

    /* System generated locals */
    real r__1, r__2, r__3, r__4;

    /* Builtin functions */
    double atan(doublereal);
    int s_wsle(cilist *), e_wsle(void), s_wsfe(cilist *), do_fio(int *
	    , char *, ftnlen), e_wsfe(void);

    /* Local variables */
    static real aj, xc, yc, ajt, dtr, pex, xct, yct, ei11a, ei22a, area, 
	    ei11t, ei22t, slen, aixx, xmin, ymin, xmax, ymax, aiyy, apx1a, 
	    apx2a, apx1t, apx2t, xbara, xcena, ycena, ybara, xbart, xcent, 
	    ycent, ybart, aixxt, aiyyt;
    extern /* Subroutine */ int aecalc_(int *, real *, real *, real *, 
	    int *, real *, real *, real *, real *, real *, real *, real *)
	    , ijsect_(int *, real *, real *, real *, real *, real *, real 
	    *, real *, real *, real *, real *, real *, real *, real *, real *,
	     real *, real *, real *, real *, real *, real *, real *);
    static real xexint, yexint;

    /* Fortran I/O blocks */
    static cilist io___429 = { 0, 6, 0, 0, 0 };
    static cilist io___430 = { 0, 6, 0, fmt_1200, 0 };
    static cilist io___431 = { 0, 6, 0, fmt_1200, 0 };
    static cilist io___432 = { 0, 6, 0, 0, 0 };
    static cilist io___433 = { 0, 6, 0, fmt_1200, 0 };
    static cilist io___434 = { 0, 6, 0, fmt_1200, 0 };
    static cilist io___435 = { 0, 6, 0, fmt_1200, 0 };
    static cilist io___436 = { 0, 6, 0, fmt_1200, 0 };
    static cilist io___437 = { 0, 6, 0, fmt_1200, 0 };
    static cilist io___438 = { 0, 6, 0, fmt_1200, 0 };
    static cilist io___439 = { 0, 6, 0, fmt_1200, 0 };
    static cilist io___440 = { 0, 6, 0, fmt_1200, 0 };
    static cilist io___441 = { 0, 6, 0, fmt_1200, 0 };
    static cilist io___444 = { 0, 6, 0, fmt_1200, 0 };
    static cilist io___445 = { 0, 6, 0, fmt_1200, 0 };
    static cilist io___446 = { 0, 6, 0, 0, 0 };
    static cilist io___447 = { 0, 6, 0, fmt_1200, 0 };
    static cilist io___448 = { 0, 6, 0, fmt_1200, 0 };
    static cilist io___449 = { 0, 6, 0, fmt_1200, 0 };
    static cilist io___450 = { 0, 6, 0, fmt_1200, 0 };
    static cilist io___451 = { 0, 6, 0, fmt_1200, 0 };
    static cilist io___452 = { 0, 6, 0, fmt_1200, 0 };
    static cilist io___453 = { 0, 6, 0, fmt_1200, 0 };
    static cilist io___454 = { 0, 6, 0, fmt_1200, 0 };
    static cilist io___455 = { 0, 6, 0, fmt_1200, 0 };
    static cilist io___458 = { 0, 6, 0, fmt_1200, 0 };
    static cilist io___459 = { 0, 6, 0, fmt_1200, 0 };
    static cilist io___460 = { 0, 6, 0, 0, 0 };
    static cilist io___461 = { 0, 6, 0, fmt_1200, 0 };
    static cilist io___462 = { 0, 6, 0, fmt_1200, 0 };
    static cilist io___463 = { 0, 6, 0, 0, 0 };
    static cilist io___464 = { 0, 6, 0, fmt_1200, 0 };
    static cilist io___465 = { 0, 6, 0, fmt_1200, 0 };



    /* Parameter adjustments */
    --t;
    --y;
    --x;

    /* Function Body */
    dtr = atan(1.f) / 45.f;

    pex = 16.f;
    ijsect_(n, &x[1], &y[1], &pex, &area, &slen, &xmin, &xmax, &xexint, &ymin,
	     &ymax, &yexint, &xc, &yc, &xct, &yct, &aixx, &aiyy, &aixxt, &
	    aiyyt, &aj, &ajt);
/*      CALL IJSECT(N,X,Y, PEX, */
/*     &    AREA, SLEN, */
/*     &    XC, XMIN, XMAX, XEXINT, */
/*     &    YC, YMIN, YMAX, YEXINT, */
/*     &    AIXX, AIXXT, */
/*     &    AIYY, AIYYT, */
/*     &    AJ  , AJT   ) */


    aecalc_(n, &x[1], &y[1], &t[1], &c__1, &area, &xcena, &ycena, &ei11a, &
	    ei22a, &apx1a, &apx2a);

    aecalc_(n, &x[1], &y[1], &t[1], &c__2, &slen, &xcent, &ycent, &ei11t, &
	    ei22t, &apx1t, &apx2t);

    s_wsle(&io___429);
    e_wsle();
    s_wsfe(&io___430);
    do_fio(&c__1, "Area =", (ftnlen)6);
    do_fio(&c__1, (char *)&area, (ftnlen)sizeof(real));
    e_wsfe();
    s_wsfe(&io___431);
    do_fio(&c__1, "Slen =", (ftnlen)6);
    do_fio(&c__1, (char *)&slen, (ftnlen)sizeof(real));
    e_wsfe();
    s_wsle(&io___432);
    e_wsle();
    s_wsfe(&io___433);
    do_fio(&c__1, "X-bending parameters:", (ftnlen)21);
    e_wsfe();
    s_wsfe(&io___434);
    do_fio(&c__1, "solid centroid Xc=", (ftnlen)18);
    do_fio(&c__1, (char *)&xcena, (ftnlen)sizeof(real));
    e_wsfe();
    s_wsfe(&io___435);
    do_fio(&c__1, "skin  centroid Xc=", (ftnlen)18);
    do_fio(&c__1, (char *)&xcent, (ftnlen)sizeof(real));
    e_wsfe();
    s_wsfe(&io___436);
    do_fio(&c__1, " solid max X-Xc  =", (ftnlen)18);
    r__1 = xmax - xcena;
    do_fio(&c__1, (char *)&r__1, (ftnlen)sizeof(real));
    e_wsfe();
    s_wsfe(&io___437);
    do_fio(&c__1, " solid min X-Xc  =", (ftnlen)18);
    r__1 = xmin - xcena;
    do_fio(&c__1, (char *)&r__1, (ftnlen)sizeof(real));
    e_wsfe();
    s_wsfe(&io___438);
    do_fio(&c__1, " skin  max X-Xc  =", (ftnlen)18);
    r__1 = xmax - xcent;
    do_fio(&c__1, (char *)&r__1, (ftnlen)sizeof(real));
    e_wsfe();
    s_wsfe(&io___439);
    do_fio(&c__1, " skin  min X-Xc  =", (ftnlen)18);
    r__1 = xmin - xcent;
    do_fio(&c__1, (char *)&r__1, (ftnlen)sizeof(real));
    e_wsfe();
    s_wsfe(&io___440);
    do_fio(&c__1, "     solid Iyy   =", (ftnlen)18);
    do_fio(&c__1, (char *)&ei22a, (ftnlen)sizeof(real));
    e_wsfe();
    s_wsfe(&io___441);
    do_fio(&c__1, "     skin  Iyy/t =", (ftnlen)18);
    do_fio(&c__1, (char *)&ei22t, (ftnlen)sizeof(real));
    e_wsfe();
/* Computing MAX */
    r__3 = (r__1 = xmax - xcena, dabs(r__1)), r__4 = (r__2 = xmin - xcena, 
	    dabs(r__2));
    xbara = dmax(r__3,r__4);
/* Computing MAX */
    r__3 = (r__1 = xmax - xcent, dabs(r__1)), r__4 = (r__2 = xmin - xcent, 
	    dabs(r__2));
    xbart = dmax(r__3,r__4);
    s_wsfe(&io___444);
    do_fio(&c__1, " solid Iyy/(X-Xc)=", (ftnlen)18);
    r__1 = ei22a / xbara;
    do_fio(&c__1, (char *)&r__1, (ftnlen)sizeof(real));
    e_wsfe();
    s_wsfe(&io___445);
    do_fio(&c__1, " skin Iyy/t(X-Xc)=", (ftnlen)18);
    r__1 = ei22t / xbart;
    do_fio(&c__1, (char *)&r__1, (ftnlen)sizeof(real));
    e_wsfe();

    s_wsle(&io___446);
    e_wsle();
    s_wsfe(&io___447);
    do_fio(&c__1, "Y-bending parameters:", (ftnlen)21);
    e_wsfe();
    s_wsfe(&io___448);
    do_fio(&c__1, "solid centroid Yc=", (ftnlen)18);
    do_fio(&c__1, (char *)&ycena, (ftnlen)sizeof(real));
    e_wsfe();
    s_wsfe(&io___449);
    do_fio(&c__1, "skin  centroid Yc=", (ftnlen)18);
    do_fio(&c__1, (char *)&ycent, (ftnlen)sizeof(real));
    e_wsfe();
    s_wsfe(&io___450);
    do_fio(&c__1, " solid max Y-Yc  =", (ftnlen)18);
    r__1 = ymax - ycena;
    do_fio(&c__1, (char *)&r__1, (ftnlen)sizeof(real));
    e_wsfe();
    s_wsfe(&io___451);
    do_fio(&c__1, " solid min Y-Yc  =", (ftnlen)18);
    r__1 = ymin - ycena;
    do_fio(&c__1, (char *)&r__1, (ftnlen)sizeof(real));
    e_wsfe();
    s_wsfe(&io___452);
    do_fio(&c__1, " skin  max Y-Yc  =", (ftnlen)18);
    r__1 = ymax - ycent;
    do_fio(&c__1, (char *)&r__1, (ftnlen)sizeof(real));
    e_wsfe();
    s_wsfe(&io___453);
    do_fio(&c__1, " skin  min Y-Yc  =", (ftnlen)18);
    r__1 = ymin - ycent;
    do_fio(&c__1, (char *)&r__1, (ftnlen)sizeof(real));
    e_wsfe();
    s_wsfe(&io___454);
    do_fio(&c__1, "     solid Ixx   =", (ftnlen)18);
    do_fio(&c__1, (char *)&ei11a, (ftnlen)sizeof(real));
    e_wsfe();
    s_wsfe(&io___455);
    do_fio(&c__1, "     skin  Ixx/t =", (ftnlen)18);
    do_fio(&c__1, (char *)&ei11t, (ftnlen)sizeof(real));
    e_wsfe();
/* Computing MAX */
    r__3 = (r__1 = ymax - ycena, dabs(r__1)), r__4 = (r__2 = ymin - ycena, 
	    dabs(r__2));
    ybara = dmax(r__3,r__4);
/* Computing MAX */
    r__3 = (r__1 = ymax - ycent, dabs(r__1)), r__4 = (r__2 = ymin - ycent, 
	    dabs(r__2));
    ybart = dmax(r__3,r__4);
    s_wsfe(&io___458);
    do_fio(&c__1, " solid Ixx/(Y-Yc)=", (ftnlen)18);
    r__1 = ei11a / ybara;
    do_fio(&c__1, (char *)&r__1, (ftnlen)sizeof(real));
    e_wsfe();
    s_wsfe(&io___459);
    do_fio(&c__1, " skin Ixx/t(Y-Yc)=", (ftnlen)18);
    r__1 = ei11t / ybart;
    do_fio(&c__1, (char *)&r__1, (ftnlen)sizeof(real));
    e_wsfe();

    s_wsle(&io___460);
    e_wsle();
    s_wsfe(&io___461);
    do_fio(&c__1, " solid principal axis angle (deg ccw) =", (ftnlen)39);
    r__1 = apx1a / dtr;
    do_fio(&c__1, (char *)&r__1, (ftnlen)sizeof(real));
    e_wsfe();
    s_wsfe(&io___462);
    do_fio(&c__1, " skin  principal axis angle (deg ccw) =", (ftnlen)39);
    r__1 = apx1t / dtr;
    do_fio(&c__1, (char *)&r__1, (ftnlen)sizeof(real));
    e_wsfe();
/*      WRITE(*,*) */
/*      WRITE(*,1200) '  power-avg X-Xc =', XEXINT */
/*      WRITE(*,1200) '  power-avg Y-Yc =', YEXINT */

    s_wsle(&io___463);
    e_wsle();
    s_wsfe(&io___464);
    do_fio(&c__1, "    solid J     =", (ftnlen)17);
    do_fio(&c__1, (char *)&aj, (ftnlen)sizeof(real));
    e_wsfe();
    s_wsfe(&io___465);
    do_fio(&c__1, "    skin  J/t   =", (ftnlen)17);
    do_fio(&c__1, (char *)&ajt, (ftnlen)sizeof(real));
    e_wsfe();
    return 0;

} /* bendump2_ */

/* Subroutine */ int ijsect_(int *n, real *x, real *y, real *pex, real *
	area, real *slen, real *xmin, real *xmax, real *xexint, real *ymin, 
	real *ymax, real *yexint, real *xc, real *yc, real *xct, real *yct, 
	real *aixx, real *aiyy, real *aixxt, real *aiyyt, real *aj, real *ajt)
{
    /* System generated locals */
    int i__1, i__2;
    real r__1, r__2;

    /* Builtin functions */
    double sqrt(doublereal);

    /* Local variables */
    static int i__, j;
    static real ds, dx, dy, c_ds__, frac;
    static int imid;
    static real x_ds__, y_ds__, x_dy__, y_dx__, xavg, yavg, sint, xint, yint, 
	    yopp, xx_ds__, yy_ds__, xx_dy__, yy_dx__, xxx_dy__, yyy_dx__;


    /* Parameter adjustments */
    --y;
    --x;

    /* Function Body */
    *xmin = x[1];
    *xmax = x[1];
    *ymin = y[1];
    *ymax = y[1];

    dx = x[1] - x[*n];
    dy = y[1] - y[*n];
    ds = sqrt(dx * dx + dy * dy);
    xavg = (x[1] + x[*n]) * .5f;
    yavg = (y[1] + y[*n]) * .5f;

    x_dy__ = dy * xavg;
/* Computing 2nd power */
    r__1 = xavg;
    xx_dy__ = dy * (r__1 * r__1);
/* Computing 3rd power */
    r__1 = xavg;
    xxx_dy__ = dy * (r__1 * (r__1 * r__1));
    x_ds__ = ds * xavg;
/* Computing 2nd power */
    r__1 = xavg;
    xx_ds__ = ds * (r__1 * r__1);

    y_dx__ = dx * yavg;
/* Computing 2nd power */
    r__1 = yavg;
    yy_dx__ = dx * (r__1 * r__1);
/* Computing 3rd power */
    r__1 = yavg;
    yyy_dx__ = dx * (r__1 * (r__1 * r__1));
    y_ds__ = ds * yavg;
/* Computing 2nd power */
    r__1 = yavg;
    yy_ds__ = ds * (r__1 * r__1);

    c_ds__ = ds;

    i__1 = *n;
    for (i__ = 2; i__ <= i__1; ++i__) {
	dx = x[i__] - x[i__ - 1];
	dy = y[i__] - y[i__ - 1];
	ds = sqrt(dx * dx + dy * dy);
	xavg = (x[i__] + x[i__ - 1]) * .5f;
	yavg = (y[i__] + y[i__ - 1]) * .5f;

	x_dy__ += dy * xavg;
/* Computing 2nd power */
	r__1 = xavg;
	xx_dy__ += dy * (r__1 * r__1);
/* Computing 3rd power */
	r__1 = xavg;
	xxx_dy__ += dy * (r__1 * (r__1 * r__1));
	x_ds__ += ds * xavg;
/* Computing 2nd power */
	r__1 = xavg;
	xx_ds__ += ds * (r__1 * r__1);

	y_dx__ += dx * yavg;
/* Computing 2nd power */
	r__1 = yavg;
	yy_dx__ += dx * (r__1 * r__1);
/* Computing 3rd power */
	r__1 = yavg;
	yyy_dx__ += dx * (r__1 * (r__1 * r__1));
	y_ds__ += ds * yavg;
/* Computing 2nd power */
	r__1 = yavg;
	yy_ds__ += ds * (r__1 * r__1);

	c_ds__ += ds;

/* Computing MIN */
	r__1 = *xmin, r__2 = x[i__];
	*xmin = dmin(r__1,r__2);
/* Computing MAX */
	r__1 = *xmax, r__2 = x[i__];
	*xmax = dmax(r__1,r__2);
/* Computing MIN */
	r__1 = *ymin, r__2 = y[i__];
	*ymin = dmin(r__1,r__2);
/* Computing MAX */
	r__1 = *ymax, r__2 = y[i__];
	*ymax = dmax(r__1,r__2);
/* L10: */
    }

    *area = -y_dx__;
    *slen = c_ds__;

    if (*area == 0.f) {
	return 0;
    }

    *xc = xx_dy__ / (x_dy__ * 2.f);
    *xct = x_ds__ / c_ds__;
/* Computing 2nd power */
    r__1 = *xc;
    *aiyy = xxx_dy__ / 3.f - xx_dy__ * *xc + x_dy__ * (r__1 * r__1);
/* Computing 2nd power */
    r__1 = *xct;
    *aiyyt = xx_ds__ - x_ds__ * *xct * 2.f + c_ds__ * (r__1 * r__1);

    *yc = yy_dx__ / (y_dx__ * 2.f);
    *yct = y_ds__ / c_ds__;
/* Computing 2nd power */
    r__1 = *yc;
    *aixx = -yyy_dx__ / 3.f + yy_dx__ * *yc - y_dx__ * (r__1 * r__1);
/* Computing 2nd power */
    r__1 = *yct;
    *aixxt = yy_ds__ - y_ds__ * *yct * 2.f + c_ds__ * (r__1 * r__1);


    sint = 0.f;
    xint = 0.f;
    yint = 0.f;

    i__1 = *n;
    for (i__ = 2; i__ <= i__1; ++i__) {
	dx = x[i__] - x[i__ - 1];
	dy = y[i__] - y[i__ - 1];
	ds = sqrt(dx * dx + dy * dy);
	xavg = (x[i__] + x[i__ - 1]) * .5f - *xc;
	yavg = (y[i__] + y[i__ - 1]) * .5f - *yc;

	sint += ds;
/* c        XINT = XINT + DS * ABS(XAVG)**PEX */
/* c        YINT = YINT + DS * ABS(YAVG)**PEX */
/* L20: */
    }

    i__1 = *n - 1;
    for (i__ = 1; i__ <= i__1; ++i__) {
	if (x[i__ + 1] >= x[i__]) {
	    goto L30;
	}
    }
    imid = *n / 2;
L30:
    imid = i__;

    *aj = 0.f;
    i__1 = imid;
    for (i__ = 2; i__ <= i__1; ++i__) {
	xavg = (x[i__] + x[i__ - 1]) * .5f;
	yavg = (y[i__] + y[i__ - 1]) * .5f;
	dx = x[i__ - 1] - x[i__];

	if (xavg > x[*n]) {
	    yopp = y[*n];
	    goto L41;
	}
	if (xavg <= x[imid]) {
	    yopp = y[imid];
	    goto L41;
	}

	i__2 = imid;
	for (j = *n; j >= i__2; --j) {
	    if (xavg > x[j - 1] && xavg <= x[j]) {
		frac = (xavg - x[j - 1]) / (x[j] - x[j - 1]);
		yopp = y[j - 1] + (y[j] - y[j - 1]) * frac;
		goto L41;
	    }
	}
L41:

/* Computing 3rd power */
	r__2 = (r__1 = yavg - yopp, dabs(r__1));
	*aj += r__2 * (r__2 * r__2) * dx / 3.f;
    }

/* Computing 2nd power */
    r__1 = *area;
    *ajt = r__1 * r__1 * 4.f / *slen;

/* c      XEXINT = (XINT/SINT)**(1.0/PEX) */
/* c      YEXINT = (YINT/SINT)**(1.0/PEX) */

    return 0;
} /* ijsect_ */


/* Subroutine */ int arefine_(real *x, real *y, real *s, real *xs, real *ys, 
	int *n, real *atol, int *ndim, int *nnew, real *xnew, 
	real *ynew, real *x1, real *x2)
{
    /* System generated locals */
    int i__1;

    /* Builtin functions */
    double atan2(doublereal, doublereal);
    int s_wsle(cilist *), do_lio(int *, int *, char *, ftnlen), 
	    e_wsle(void);

    /* Local variables */
    static int i__, k, im, ip;
    static real xk, yk, dxm, dym, dxp, dyp, aseg;
    static logical lref;
    static real smid, dotp, crsp;
    extern doublereal seval_(real *, real *, real *, real *, int *);
    static real atolr;

    /* Fortran I/O blocks */
    static cilist io___506 = { 0, 6, 0, 0, 0 };


/* ------------------------------------------------------------- */
/*     Adds points to a x,y spline contour wherever */
/*     the angle between adjacent segments at a node */
/*     exceeds a specified threshold.  The points are */
/*     added 1/3 of a segment before and after the */
/*     offending node. */

/*     The point adding is done only within X1..X2. */

/*     Intended for doubling the number of points */
/*     of Eppler and Selig airfoils so that they are */
/*     suitable for clean interpolation using Xfoil's */
/*     arc-length spline routines. */
/* ------------------------------------------------------ */

    /* Parameter adjustments */
    --x;
    --y;
    --s;
    --xs;
    --ys;
    --ynew;
    --xnew;

    /* Function Body */
    atolr = *atol * 3.14159f / 180.f;

    k = 1;
    xnew[k] = x[1];
    ynew[k] = y[1];

    i__1 = *n - 1;
    for (i__ = 2; i__ <= i__1; ++i__) {
	im = i__ - 1;
	ip = i__ + 1;

	dxm = x[i__] - x[i__ - 1];
	dym = y[i__] - y[i__ - 1];
	dxp = x[i__ + 1] - x[i__];
	dyp = y[i__ + 1] - y[i__];

	crsp = dxm * dyp - dym * dxp;
	dotp = dxm * dxp + dym * dyp;
	if (crsp == 0.f && dotp == 0.f) {
	    aseg = 0.f;
	} else {
	    aseg = atan2(crsp, dotp);
	}

	lref = dabs(aseg) > atolr;

	if (lref) {
/* ------- add extra point just before this node */
	    smid = s[i__] - (s[i__] - s[i__ - 1]) * .3333f;
	    xk = seval_(&smid, &x[1], &xs[1], &s[1], n);
	    yk = seval_(&smid, &y[1], &ys[1], &s[1], n);
	    if (xk >= *x1 && xk <= *x2) {
		++k;
		if (k > *ndim) {
		    goto L90;
		}
		xnew[k] = xk;
		ynew[k] = yk;
	    }
	}

/* ------ add the node itself */
	++k;
	if (k > *ndim) {
	    goto L90;
	}
	xnew[k] = x[i__];
	ynew[k] = y[i__];

	if (lref) {
/* ------- add extra point just after this node */
	    smid = s[i__] + (s[i__ + 1] - s[i__]) * .3333f;
	    xk = seval_(&smid, &x[1], &xs[1], &s[1], n);
	    yk = seval_(&smid, &y[1], &ys[1], &s[1], n);
	    if (xk >= *x1 && xk <= *x2) {
		++k;
		if (k > *ndim) {
		    goto L90;
		}
		xnew[k] = xk;
		ynew[k] = yk;
	    }
	}
/* L10: */
    }

    ++k;
    if (k > *ndim) {
	goto L90;
    }
    xnew[k] = x[*n];
    ynew[k] = y[*n];

    *nnew = k;
    return 0;

L90:
    s_wsle(&io___506);
    do_lio(&c__9, &c__1, "SDOUBLE:  Arrays will overflow.  No action taken.", 
	    (ftnlen)49);
    e_wsle();
    *nnew = 0;
    return 0;

} /* arefine_ */

/* Subroutine */ int scheck_(real *x, real *y, int *n, real *stol, 
	logical *lchange)
{
    /* System generated locals */
    int i__1, i__2;

    /* Builtin functions */
    int s_wsle(cilist *), do_lio(int *, int *, char *, ftnlen), 
	    e_wsle(void);
    double sqrt(doublereal);

    /* Local variables */
    static int i__, l, im1, ip1, ip2;
    static real dsm1, dsp1, dsp2, dxm1, dym1, dxp1, dyp1, dxp2, dyp2;

    /* Fortran I/O blocks */
    static cilist io___507 = { 0, 6, 0, 0, 0 };
    static cilist io___522 = { 0, 6, 0, 0, 0 };


/* ------------------------------------------------------------- */
/*     Removes points from an x,y spline contour wherever */
/*     the size of a segment between nodes falls below a */
/*     a specified threshold of the adjacent segments. */
/*     The two node points defining the short segment are */
/*     replaced with a single node at their midpoint. */
/*     Note that the number of nodes may be altered by */
/*     this routine. */

/*     Intended for eliminating odd "micro" panels */
/*     that occur when blending a flap to a foil. */
/*     If LCHANGE is set on return the airfoil definition */
/*     has been changed and resplining should be done. */

/*     The recommended value for STOL is 0.05 (meaning */
/*     segments less than 5% of the length of either adjoining */
/*     segment are removed).  4/24/01 HHY */
/* ------------------------------------------------------ */

    /* Parameter adjustments */
    --y;
    --x;

    /* Function Body */
    *lchange = FALSE_;
/* --- Check STOL for sanity */
    if (*stol > .3f) {
	s_wsle(&io___507);
	do_lio(&c__9, &c__1, "SCHECK:  Bad value for small panels (STOL > 0."
		"3)", (ftnlen)48);
	e_wsle();
	return 0;
    }

L10:
    i__1 = *n - 2;
    for (i__ = 2; i__ <= i__1; ++i__) {
	im1 = i__ - 1;
	ip1 = i__ + 1;
	ip2 = i__ + 2;

	dxm1 = x[i__] - x[i__ - 1];
	dym1 = y[i__] - y[i__ - 1];
	dsm1 = sqrt(dxm1 * dxm1 + dym1 * dym1);

	dxp1 = x[i__ + 1] - x[i__];
	dyp1 = y[i__ + 1] - y[i__];
	dsp1 = sqrt(dxp1 * dxp1 + dyp1 * dyp1);

	dxp2 = x[i__ + 2] - x[i__ + 1];
	dyp2 = y[i__ + 2] - y[i__ + 1];
	dsp2 = sqrt(dxp2 * dxp2 + dyp2 * dyp2);

/* ------- Don't mess with doubled points (slope breaks) */
	if (dsp1 == 0.f) {
	    goto L20;
	}

	if (dsp1 < *stol * dsm1 || dsp1 < *stol * dsp2) {
/* ------- Replace node I with average of I and I+1 */
	    x[i__] = (x[i__] + x[i__ + 1]) * .5f;
	    y[i__] = (y[i__] + y[i__ + 1]) * .5f;
/* ------- Remove node I+1 */
	    i__2 = *n;
	    for (l = i__ + 1; l <= i__2; ++l) {
		x[l] = x[l + 1];
		y[l] = y[l + 1];
	    }
	    --(*n);
	    *lchange = TRUE_;
	    s_wsle(&io___522);
	    do_lio(&c__9, &c__1, "SCHECK segment removed at ", (ftnlen)26);
	    do_lio(&c__3, &c__1, (char *)&i__, (ftnlen)sizeof(integer));
	    e_wsle();
	    goto L10;
	}

L20:
	;
    }

    return 0;
} /* scheck_ */

/* Subroutine */ int half_(real *x, real *y, real *s, int *n)
{
    /* System generated locals */
    int i__1;

    /* Local variables */
    static int i__, k, inext;

/* ------------------------------------------------- */
/*     Halves the number of points in airfoil */
/* ------------------------------------------------- */

    /* Parameter adjustments */
    --s;
    --y;
    --x;

    /* Function Body */
    k = 1;
    inext = 3;
    i__1 = *n - 1;
    for (i__ = 2; i__ <= i__1; ++i__) {
/* ------ if corner is found, preserve it. */
	if (s[i__] == s[i__ + 1]) {
	    ++k;
	    x[k] = x[i__];
	    y[k] = y[i__];
	    ++k;
	    x[k] = x[i__ + 1];
	    y[k] = y[i__ + 1];
	    inext = i__ + 3;
	}

	if (i__ == inext) {
	    ++k;
	    x[k] = x[i__];
	    y[k] = y[i__];
	    inext = i__ + 2;
	}

/* L20: */
    }
    ++k;
    x[k] = x[*n];
    y[k] = y[*n];

/* ---- set new number of points */
    *n = k;

    return 0;
} /* half_ */
