/* f/xutils.f -- translated by f2c (version 20100827).
   You must link the resulting object file with libf2c:
	on Microsoft Windows system, link with libf2c.lib;
	on Linux or Unix systems, link with .../path/to/libf2c.a -lm
	or, if you install libf2c.a in a standard place, with -lf2c -lm
	-- in that order, at the end of the command line, as in
		cc *.o -lf2c -lm
	Source for libf2c is in /netlib/f2c/libf2c.zip, e.g.,

		http://www.netlib.org/f2c/libf2c.zip
*/

#include "f2c.h"

/* Table of constant values */

static int c__9 = 9;
static int c__1 = 1;

/* Subroutine */ int setexp_(real *s, real *ds1, real *smax, int *nn)
{
    /* System generated locals */
    int i__1;
    real r__1;
    doublereal d__1, d__2, d__3, d__4;

    /* Builtin functions */
    /* Subroutine */ int s_stop(char *, ftnlen);
    double sqrt(doublereal), pow_ri(real *, int *), pow_dd(doublereal *, 
	    doublereal *);
    int s_wsle(cilist *), do_lio(int *, int *, char *, ftnlen), 
	    e_wsle(void);

    /* Local variables */
    static int n;
    static real ds, aaa, bbb, ccc, rni, res;
    static int nex;
    static real disc;
    static int iter;
    static real rnex, sigma, ratio, sigman, dratio, dresdr;

    /* Fortran I/O blocks */
    static cilist io___15 = { 0, 6, 0, 0, 0 };


/* ........................................................ */
/*     Sets geometrically stretched array S: */

/*       S(i+1) - S(i)  =  r * [S(i) - S(i-1)] */

/*       S     (output)  array to be set */
/*       DS1   (input)   first S increment:  S(2) - S(1) */
/*       SMAX  (input)   final S value:      S(NN) */
/*       NN    (input)   number of points */
/* ........................................................ */

    /* Parameter adjustments */
    --s;

    /* Function Body */
    sigma = *smax / *ds1;
    nex = *nn - 1;
    rnex = (real) nex;
    rni = 1.f / rnex;

/* ---- solve quadratic for initial geometric ratio guess */
    aaa = rnex * (rnex - 1.f) * (rnex - 2.f) / 6.f;
    bbb = rnex * (rnex - 1.f) / 2.f;
    ccc = rnex - sigma;

/* Computing 2nd power */
    r__1 = bbb;
    disc = r__1 * r__1 - aaa * 4.f * ccc;
    disc = dmax(0.f,disc);

    if (nex <= 1) {
	s_stop("SETEXP: Cannot fill array.  N too small.", (ftnlen)40);
    } else if (nex == 2) {
	ratio = -ccc / bbb + 1.f;
    } else {
	ratio = (-bbb + sqrt(disc)) / (aaa * 2.f) + 1.f;
    }

    if (ratio == 1.f) {
	goto L11;
    }

/* ---- Newton iteration for actual geometric ratio */
    for (iter = 1; iter <= 100; ++iter) {
	sigman = (pow_ri(&ratio, &nex) - 1.f) / (ratio - 1.f);
	d__1 = (doublereal) sigman;
	d__2 = (doublereal) rni;
	d__3 = (doublereal) sigma;
	d__4 = (doublereal) rni;
	res = pow_dd(&d__1, &d__2) - pow_dd(&d__3, &d__4);
	d__1 = (doublereal) sigman;
	d__2 = (doublereal) rni;
	i__1 = nex - 1;
	dresdr = rni * pow_dd(&d__1, &d__2) * (rnex * pow_ri(&ratio, &i__1) - 
		sigman) / (pow_ri(&ratio, &nex) - 1.f);

	dratio = -res / dresdr;
	ratio += dratio;

	if (dabs(dratio) < 1e-5f) {
	    goto L11;
	}

/* L1: */
    }
    s_wsle(&io___15);
    do_lio(&c__9, &c__1, "SETEXP: Convergence failed.  Continuing anyway ...",
	     (ftnlen)50);
    e_wsle();

/* ---- set up stretched array using converged geometric ratio */
L11:
    s[1] = 0.f;
    ds = *ds1;
    i__1 = *nn;
    for (n = 2; n <= i__1; ++n) {
	s[n] = s[n - 1] + ds;
	ds *= ratio;
/* L2: */
    }

    return 0;
} /* setexp_ */

doublereal atanc_(real *y, real *x, real *thold)
{
    /* Initialized data */

    static real pi = 3.1415926535897932384f;
    static real tpi = 6.2831853071795864769f;

    /* System generated locals */
    real ret_val;

    /* Builtin functions */
    double atan2(doublereal, doublereal), r_sign(real *, real *);

    /* Local variables */
    static real dthet, thnew, dtcorr;

/* --------------------------------------------------------------- */
/*     ATAN2 function with branch cut checking. */

/*     Increments position angle of point X,Y from some previous */
/*     value THOLD due to a change in position, ensuring that the */
/*     position change does not cross the ATAN2 branch cut */
/*     (which is in the -x direction).  For example: */

/*       ATANC( -1.0 , -1.0 , 0.75*pi )  returns  1.25*pi , whereas */
/*       ATAN2( -1.0 , -1.0 )            returns  -.75*pi . */

/*     Typically, ATANC is used to fill an array of angles: */

/*        THETA(1) = ATAN2( Y(1) , X(1) ) */
/*        DO i=2, N */
/*          THETA(i) = ATANC( Y(i) , X(i) , THETA(i-1) ) */
/*        END DO */

/*     This will prevent the angle array THETA(i) from jumping by */
/*     +/- 2 pi when the path X(i),Y(i) crosses the negative x axis. */

/*     Input: */
/*       X,Y     point position coordinates */
/*       THOLD   position angle of nearby point */

/*     Output: */
/*       ATANC   position angle of X,Y */
/* --------------------------------------------------------------- */

/* ---- set new position angle, ignoring branch cut in ATAN2 function for now */
    thnew = atan2(*y, *x);
    dthet = thnew - *thold;

/* ---- angle change cannot exceed +/- pi, so get rid of any multiples of 2 pi */
    dtcorr = dthet - tpi * (integer) ((dthet + r_sign(&pi, &dthet)) / tpi);

/* ---- set correct new angle */
    ret_val = *thold + dtcorr;

    return ret_val;
} /* atanc_ */
